#include <math.h>
#include "DxLib.h"
#include "main.h"
#include "Camera.h"
#include "Game.h"
#include "Bullet.h"
#include "GraphHandle.h"
#include "KeyPadInput.h"
#include "Player.h"

// \̎̒`
static BULLET Bullet[SHOTMAX];

// ʏe̍XV
void BulletMove(void){
	VECTOR OldPos,NewPos;
	int HitTarget;

	for(int i=0;i<SHOTMAX;i++){
		if(Bullet[i].Flag){

			// ߋ̈ʒuL
			OldPos.x=Bullet[i].Pos.x; OldPos.y=Bullet[i].Pos.y; OldPos.z=Bullet[i].Pos.z;

			// ʒuAbvf[g
			Bullet[i].Pos.x+=Bullet[i].Spd*sin(Bullet[i].Rot.v+1.0f/2.0f*DX_PI)*cos(1.0f/2.0f*DX_PI-Bullet[i].Rot.h);
			Bullet[i].Pos.y+=Bullet[i].Spd*cos(Bullet[i].Rot.v+1.0f/2.0f*DX_PI);
			Bullet[i].Pos.z+=Bullet[i].Spd*sin(Bullet[i].Rot.v+1.0f/2.0f*DX_PI)*sin(1.0f/2.0f*DX_PI-Bullet[i].Rot.h);

			// VʒuL
			NewPos.x=Bullet[i].Pos.x; NewPos.y=Bullet[i].Pos.y; NewPos.z=Bullet[i].Pos.z;

			// 蔻
			if((HitTarget=CheckAllHit(Bullet[i].PlayerID,OldPos,NewPos))!=-1){
				PlayerDamage(Bullet[i].PlayerID,HitTarget,Bullet[i].Power+5*(GetPlayerPower(Bullet[i].PlayerID)-1));
				ShotUnregist(i);
				CheckPlayerKilled(HitTarget,Bullet[i].PlayerID,Bullet[i].Variety);
			}

			// ͈͊Oɏo
			if(Bullet[i].Pos.x<-STAGESIZE/2||STAGESIZE/2<Bullet[i].Pos.x||
			   Bullet[i].Pos.y<-STAGESIZE/2||STAGESIZE/2<Bullet[i].Pos.y||
			   Bullet[i].Pos.z<-STAGESIZE/2||STAGESIZE/2<Bullet[i].Pos.z) ShotUnregist(i);
		}
	}
}

// e`
void DrawBullet(void){
	int GameFrame=GetGameFrame();

	for(int i=0;i<SHOTMAX;i++){

		// ʏe^eȂ
		if(Bullet[i].Flag==1&&(Bullet[i].Variety==BV_NORMAL||Bullet[i].Variety==BV_DOUBLEDIRECTIONALLAZERN)){
			DrawBillboard3D(Bullet[i].Pos,0.5f,0.5f,Bullet[i].Size,0.0f,Bullet[i].Handle.Graph,TRUE);

		// _ufBNVi[U[Ȃ
		}else if(Bullet[i].Flag==1&&Bullet[i].Variety==BV_DOUBLEDIRECTIONALLAZERL){

			// 60t[ȓ̎
			if(GameFrame-Bullet[i].StartFrame<60){
				PC Pc1=GetPlayer(Bullet[i].PlayerID),Pc2=GetPlayer(GetMainPlayerID());

				// \̕`
				SetDrawBlendMode(DX_BLENDMODE_ALPHA,(60+Bullet[i].StartFrame-GameFrame)*2.55*10/6);
				if(Pc1.Team==Pc2.Team) DrawLine3D(Bullet[i].Pos,Bullet[i].NPos,GetColor(255,0,0)); else DrawLine3D(Bullet[i].Pos,Bullet[i].NPos,GetColor(0,0,255));
				SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);

			// 60t[ȍ~̎
			}else{

				// 60t[̎
				//if(Game.Frame-Bullet[i].FirstFrame==60){				
					// }X^[Xp[Nʒu
				//	Bullet[i].Pos.x+=(Bullet[i].NPos.x-Bullet[i].Pos.x)/150; Bullet[i].Pos.y+=(Bullet[i].NPos.y-Bullet[i].Pos.y)/150; Bullet[i].Pos.z+=(Bullet[i].NPos.z-Bullet[i].Pos.z)/150;
				//}

				// [U[̕`
				MATERIALPARAM Material;
				Material.Ambient=GetColorF(0,0,0,0);
				Material.Diffuse=GetColorF(0,0,0,1);
				Material.Specular=GetColorF(0,0,0,0);
				Material.Emissive=GetColorF(1,1,0.3,1);
				Material.Power=20;
				SetMaterialParam(Material);
				MV1SetPosition(Bullet[i].Handle.Model,Bullet[i].Pos);
				MV1SetRotationXYZ(Bullet[i].Handle.Model,VGet(Bullet[i].Rot.v,Bullet[i].Rot.h,Bullet[i].Rot.t));
				MV1SetOpacityRate(Bullet[i].Handle.Model,min(180+GetRand(10),(Bullet[i].EndFrame-GameFrame)/64.0));
				MV1DrawModel(Bullet[i].Handle.Model);

				// I蒼O
				if(GameFrame==Bullet[i].EndFrame-1){

					// f폜
					MV1DeleteModel(Bullet[i].Handle.Model);

					// e폜
					ShotUnregist(i);
				}
			}

		// }X^[Xp[NȂ
		}else if(Bullet[i].Flag==1&&Bullet[i].Variety==BV_MASTERSPARK){

			// 100t[ȓ̎
			if(GameFrame-Bullet[i].StartFrame<100){

				// \̕`
				SetDrawBlendMode(DX_BLENDMODE_ALPHA,(100+Bullet[i].StartFrame-GameFrame)*2.55);
				PC Pc1=GetPlayer(Bullet[i].PlayerID),Pc2=GetPlayer(GetMainPlayerID());
				if(Pc1.Team==Pc2.Team) DrawLine3D(Bullet[i].Pos,Bullet[i].NPos,GetColor(255,0,0)); else DrawLine3D(Bullet[i].Pos,Bullet[i].NPos,GetColor(0,0,255));
				SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);

			// 100t[ȍ~̎
			}else{

				// 100t[̎
				if(GameFrame-Bullet[i].StartFrame==100){

					// Cgnhgp
					Bullet[i].Pos.x+=(Bullet[i].NPos.x-Bullet[i].Pos.x)/50; Bullet[i].Pos.y+=(Bullet[i].NPos.y-Bullet[i].Pos.y)/50; Bullet[i].Pos.z+=(Bullet[i].NPos.z-Bullet[i].Pos.z)/50;
					Bullet[i].LightHandle=CreatePointLightHandle(Bullet[i].Pos,STAGESIZE,0,0.1,0);
					Bullet[i].Pos.x-=(Bullet[i].NPos.x-Bullet[i].Pos.x)/50; Bullet[i].Pos.y-=(Bullet[i].NPos.y-Bullet[i].Pos.y)/50; Bullet[i].Pos.z-=(Bullet[i].NPos.z-Bullet[i].Pos.z)/50;
					SetLightEnableHandle(Bullet[i].LightHandle,1);
					
					// }X^[Xp[Nʒu
					Bullet[i].Pos.x+=(Bullet[i].NPos.x-Bullet[i].Pos.x)/150; Bullet[i].Pos.y+=(Bullet[i].NPos.y-Bullet[i].Pos.y)/150; Bullet[i].Pos.z+=(Bullet[i].NPos.z-Bullet[i].Pos.z)/150;
				}

				// }X^[Xp[N̕`
				MATERIALPARAM Material;
				Material.Ambient=GetColorF(0,0,0,0);
				Material.Diffuse=GetColorF(0,0,0,1);
				Material.Specular=GetColorF(0,0,0,0);
				Material.Emissive=GetColorF(1,1,0.3,1);
				Material.Power=20;
				SetMaterialParam(Material);
				MV1SetPosition(Bullet[i].Handle.Model,Bullet[i].Pos);
				MV1SetRotationXYZ(Bullet[i].Handle.Model,VGet(Bullet[i].Rot.v,Bullet[i].Rot.h,Bullet[i].Rot.t));
				MV1SetOpacityRate(Bullet[i].Handle.Model,min(180+GetRand(10),Bullet[i].EndFrame-GameFrame)/255.0);
				MV1DrawModel(Bullet[i].Handle.Model);
				SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(180+GetRand(10),Bullet[i].EndFrame-GameFrame));
				DrawCapsule3D( Bullet[i].Pos, Bullet[i].NPos, 700.0f+GetRand(30), 16, GetColor( 255,255,255 ),GetColor( 255,255,255 ), TRUE ) ;
				SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);

				// I蒼O
				if(GameFrame==Bullet[i].EndFrame-1){

					// Cgnh폜
					DeleteLightHandle(Bullet[i].LightHandle);

					// f폜
					MV1DeleteModel(Bullet[i].Handle.Model);

					// e폜
					ShotUnregist(i);
				}
			}
		}
	}
}

// eo^łȂƂT
int SearchShot(void){
	for(int j=0;j<SHOTMAX;j++) if(Bullet[j].Flag==0) return j;
	return -1;
}

// eo^
void ShotRegist(int i){
	int j;

	// 擾
	int PlayerID=GetMainPlayerID();
	PC Player=GetPlayer(i);
	GRAPHHANDLE Handle=GetAllHandle();
	DINPUT_JOYSTATE PadState=GetPadState();

	// 󂫂
	if((j=SearchShot())!=-1){

		// eo^
		if(Player.Team==0) Bullet[j].Handle.Graph=Handle.RedBullet.Graph;
		else Bullet[j].Handle.Graph=Handle.BuleBullet.Graph;
		Bullet[j].Flag=1;
		Bullet[j].PlayerID=i;
		Bullet[j].Variety=BV_NORMAL;
		Bullet[j].Pos.x=Player.Pos.x;
		Bullet[j].Pos.y=Player.Pos.y;
		Bullet[j].Pos.z=Player.Pos.z;

		// e̔ԕ́ACPU͓G̕
		if(i!=PlayerID){
			Bullet[j].Rot.h=Player.RotEne.h+((double)GetRand(1000)-500)/1500;
			Bullet[j].Rot.v=Player.RotEne.v+((double)GetRand(1000)-500)/1500;
			Bullet[j].Rot.t=Player.RotEne.t+((double)GetRand(1000)-500)/1500;

		// ^[Qbg[hȂG̕
		}else if(Player.Flag.TargetMode==1){
			Bullet[j].Rot.h=Player.RotEne.h+((double)GetRand(1000)-500)/1500+PadState.Rx/10000.0;
			Bullet[j].Rot.v=Player.RotEne.v+((double)GetRand(1000)-500)/1500+PadState.Ry/10000.0;
			Bullet[j].Rot.t=Player.RotEne.t+((double)GetRand(1000)-500)/1500;

		// t[[hȂJ̕
		}else{
			CAMERA Camera=GetCamera();
			Bullet[j].Rot.h=Camera.Rot.h+((double)GetRand(1000)-500)/1500;
			Bullet[j].Rot.v=Camera.Rot.v+((double)GetRand(1000)-500)/1500;
			Bullet[j].Rot.t=Camera.Rot.t+((double)GetRand(1000)-500)/1500;
		}
		Bullet[j].StartFrame=GetGameFrame();
		Bullet[j].EndFrame=Bullet[j].StartFrame+1500;
		Bullet[j].Spd=40.0f;
		Bullet[j].Size=40.0f;
		Bullet[j].Power=10;
	}
}

// XLe̓o^
void SkillBulletRegist(int ID, int Variety, int Time, VECTOR Pos1, VECTOR Pos2){

	// 擾
	PC Player=GetPlayer(ID);
	HANDLES* Handle=GetStarBulletGraphHandle();
	int j;

	// _ufBNVi[U[̐^eo^
	if(Variety==BV_DOUBLEDIRECTIONALLAZERN){

		// 󂢂Ă
		if((j=SearchShot())!=-1){
			Bullet[j].Handle.Graph=Handle[GetRand(4)].Graph;
			Bullet[j].Flag=1;
			Bullet[j].Variety=BV_DOUBLEDIRECTIONALLAZERN;
			Bullet[j].Rot.h=Player.SARot.h+(Time-70)/10.0f+(GetRand(1000)-500)/15000.0f;
			Bullet[j].Rot.v=Player.SARot.v+(GetRand(1000)-500)/1500.0f;
			Bullet[j].Rot.t=Player.SARot.t;
			Bullet[j].Pos.x=Player.Pos.x+300*sin(Bullet[j].Rot.v+1.0f/2.0f*DX_PI)*cos(1.0f/2.0f*DX_PI-Bullet[j].Rot.h);
			Bullet[j].Pos.y=Player.Pos.y+300*cos(Bullet[j].Rot.v+1.0f/2.0f*DX_PI);
			Bullet[j].Pos.z=Player.Pos.z+300*sin(Bullet[j].Rot.v+1.0f/2.0f*DX_PI)*sin(1.0f/2.0f*DX_PI-Bullet[j].Rot.h);
			Bullet[j].StartFrame=GetGameFrame();
			Bullet[j].EndFrame=Bullet[j].StartFrame+1500;
			Bullet[j].Spd=60.0f;
			Bullet[j].Size=150.0f;
			Bullet[j].Power=10;
		}

	// _ufBNVi[U[̃[U[o^
	}else if(Variety==BV_DOUBLEDIRECTIONALLAZERL){
		if((j=SearchShot())!=-1){
			GRAPHHANDLE Handle=GetAllHandle();
			Bullet[j].Handle.Model=MV1DuplicateModel(Handle.Bomb[BM_MASTERSPARK].Model);
			MV1SetScale(Bullet[j].Handle.Model,VGet(50,50,500));
			int MaterialNum = MV1GetMaterialNum(Bullet[j].Handle.Model); 
			for(int k=0;k<MaterialNum;k++) MV1SetMeshBackCulling(Bullet[j].Handle.Model,k,FALSE);
			Bullet[j].Handle.Attach = MV1AttachAnim(Bullet[j].Handle.Model,0);

			Bullet[j].Flag=1;
			Bullet[j].Variety=BV_DOUBLEDIRECTIONALLAZERL;
			Bullet[j].Pos=Pos1;
			Bullet[j].NPos=Pos2;
			Bullet[j].Rot.h=atan2(Bullet[j].NPos.x-Bullet[j].Pos.x,Bullet[j].NPos.z-Bullet[j].Pos.z);
			Bullet[j].Rot.v=-atan2(Bullet[j].NPos.y-Bullet[j].Pos.y,hypotf(Bullet[j].NPos.z-Bullet[j].Pos.z,Bullet[j].NPos.x-Bullet[j].Pos.x));
			Bullet[j].StartFrame=GetGameFrame();
			Bullet[j].EndFrame=Bullet[j].StartFrame+150;
			Bullet[j].Spd=0.0f;
			Bullet[j].Size=100.0f;
			Bullet[j].Power=5;
		}
	}
}

// {e̓o^
void BombBulletRegist(int Variety, VECTOR Pos1, VECTOR Pos2){

	// }X^[Xp[No^
	if(Variety==BV_MASTERSPARK){
		int j;
		if((j=SearchShot())!=-1){
			GRAPHHANDLE Handle=GetAllHandle();
			Bullet[j].Handle.Model=MV1DuplicateModel(Handle.Bomb[BM_MASTERSPARK].Model);
			MV1SetScale(Bullet[j].Handle.Model,VGet(300,300,500));
			int MaterialNum = MV1GetMaterialNum(Bullet[j].Handle.Model); 
			for(int k=0;k<MaterialNum;k++) MV1SetMeshBackCulling(Bullet[j].Handle.Model,k,FALSE);
			Bullet[j].Handle.Attach = MV1AttachAnim(Bullet[j].Handle.Model,0);	

			Bullet[j].Flag=1;
			Bullet[j].Variety=BV_DOUBLEDIRECTIONALLAZERL;
			Bullet[j].Pos=Pos1;
			Bullet[j].NPos=Pos2;
			Bullet[j].Rot.h=atan2(Bullet[j].NPos.x-Bullet[j].Pos.x,Bullet[j].NPos.z-Bullet[j].Pos.z);
			Bullet[j].Rot.v=-atan2(Bullet[j].NPos.y-Bullet[j].Pos.y,hypotf(Bullet[j].NPos.z-Bullet[j].Pos.z,Bullet[j].NPos.x-Bullet[j].Pos.x));
			Bullet[j].StartFrame=GetGameFrame();
			Bullet[j].EndFrame=Bullet[j].StartFrame+200;
			Bullet[j].Spd=0.0f;
			Bullet[j].Size=600.0f;
			Bullet[j].Power=10;
		}
	}
}

// eo^
void ShotUnregist(int Num){
	Bullet[Num].Flag=0;
}

// ẽAj[V
void UpdateBulletAnim(void){

	for(int i=0;i<SHOTMAX;i++){

		// `敨}XpȂ
		if(Bullet[i].Variety==BV_MASTERSPARK||Bullet[i].Variety==BV_DOUBLEDIRECTIONALLAZERL){

			// Aj[VԂ̒擾
			int TotalTime=MV1GetAttachAnimTotalTime(Bullet[i].Handle.Model,Bullet[i].Handle.Attach);

			// ݂̃Aj[VԂ̍XV
			if(TotalTime==0) Bullet[i].Handle.Anitime=0.0;
			else Bullet[i].Handle.Anitime=(Bullet[i].Handle.Anitime+1)%TotalTime;

			// Aj[VԂZbg
			MV1SetAttachAnimTime(Bullet[i].Handle.Model,Bullet[i].Handle.Attach,Bullet[i].Handle.Anitime);
		}
	}
}