#include "Game.h"
#include "Font.h"
#include "Camera.h"
#include "Map.h"
#include "KeyPadInput.h"
#include "main.h"
#include "DxLib.h"

// \̎̒`
static GAME Game;

extern char KeyName[ALLKEY][12]; // L[̖O
extern char PadName[ALLPAD][12]; // pbh̖O

// QƗp
GAME GetGameAll(void){ return Game; } // Q[擾
int GetGameFrame(void){ return Game.Frame; } // t[擾
int GetGameFunctionStatus(void){ return Game.FunctionStatus; } // ̃Q[̏Ԃ擾
int GetGameSelectedMenu(void){ return Game.SelectedMenu; } // I𒆂̃jڂ擾
int GetGameSelectedRule(void){ return Game.SelectedRule; } // ̃Q[[擾
int GetGameSelectedCharacter(void){ return Game.SelectedCharacter; } // ILN^擾
int GetGameSelectMap(void){ return Game.SelectMap; } // I𒆂̃}bv擾

// 
void GameInit(void){

	Game.Frame=0;
	Game.FunctionStatus=FS_MENU;
	Game.SelectMenu=SM_KEYCONFIG;
	Game.SelectRule=SR_TEAMDEATHMATCH;
	Game.SelectKeyConfig=0;
	Game.SelectCharacter=0;
	Game.SelectMap=0;
	Game.SelectedRule=SR_TEAMDEATHMATCH;
	Game.SelectedCharacter=SCR_MARISA;
	Game.SelectedMap=0;
}

// Q[ԉZ
void GameFrameCountUp(void){ Game.Frame++; }

// FSXV
void UpdateGameFunctionStatus(int State){
	Game.FunctionStatus=State;
	Game.Frame=-1;
}

// j`
void MenuDraw(void){

	// 擾
	FONT Font=GetFont();
	KEYCON KeyCon=GetKeyCon();
	KEYCON PadCon=GetPadCon();
	DINPUT_JOYSTATE PadState=GetPadState();
	int *Key=GetKey();
	int *Pad=GetPad();

	switch(Game.SelectedMenu){

		case SM_CHARACTER:
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,70);
			DrawBox(0,0,WINDOWWIDTH,WINDOWHEIGHT,GetColor(0,0,0),1);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectCharacter!=SCR_DEFAULT) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(300,320,GetColor(255,255,255),Font.Status,"Default");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectCharacter!=SCR_MARISA) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(300,350,GetColor(255,255,255),Font.Status,"Marisa");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			goto A;

		case SM_MAP:
			CameraMove();
			DrawMap();
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,70);
			DrawBox(0,0,WINDOWWIDTH,WINDOWHEIGHT,GetColor(0,0,0),1);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectMap!=0) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(300,290,GetColor(255,255,255),Font.Status,"Default");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			goto A;

		case SM_RULE:
			if(Game.SelectRule!=SR_TEAMDEATHMATCH) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(300,260,GetColor(255,255,255),Font.Status,"TeamDeathMatch");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);

		case SM_NOTSELECTED:
			A:
			DrawFormatStringToHandle(280,75,GetColor(255,255,255),Font.KeyConfig,"Ƃ");
			DrawFormatStringToHandle(280,100,GetColor(255,255,255),Font.Title,"/10000");
			DrawFormatStringToHandle(30,200,GetColor(255,255,255),Font.Status,"ModeSelect:");
			if(Game.SelectMenu!=SM_KEYCONFIG) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(40,230,GetColor(255,255,255),Font.Status,"KeyConfig");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectMenu!=SM_RULE) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(40,260,GetColor(255,255,255),Font.Status,"RuleSelect");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectMenu!=SM_MAP) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(40,290,GetColor(255,255,255),Font.Status,"MapSelect");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectMenu!=SM_CHARACTER) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(40,320,GetColor(255,255,255),Font.Status,"CharacterSelect");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectMenu!=SM_START) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(40,350,GetColor(255,255,255),Font.Status,"Start");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			break;

		case SM_KEYCONFIG:
			// ʂɏ`
			DrawFormatStringToHandle( 0, 0, GetColor( 255,255,255 ),Font.KeyConfig, "X:%d Y:%d Z:%d", PadState.X, PadState.Y, PadState.Z ) ;
			DrawFormatStringToHandle( 0, 20, GetColor( 255,255,255 ),Font.KeyConfig, "Rx:%d Ry:%d Rz:%d", PadState.Rx, PadState.Ry, PadState.Rz ) ;
			DrawFormatStringToHandle( 0, 40, GetColor( 255,255,255 ),Font.KeyConfig, "Slider 0:%d 1:%d", PadState.Slider[ 0 ], PadState.Slider[ 1 ] ) ;
			DrawFormatStringToHandle( 0, 60, GetColor( 255,255,255 ),Font.KeyConfig, "POV 0:%d 1:%d 2:%d 3:%d", PadState.POV[ 0 ], PadState.POV[ 1 ], PadState.POV[ 2 ], PadState.POV[ 3 ] ) ;
			DrawFormatStringToHandle( 0, 80, GetColor( 255,255,255 ) ,Font.KeyConfig,"Button") ;

			for(int i=0;i<32;i++) DrawFormatStringToHandle(64+i%8*90,80+i/8*20,GetColor(255,255,255),Font.KeyConfig,"%2d:%d",i,Pad[i]);
		
			DrawFormatStringToHandle(30,200,GetColor(255,255,255),Font.Status,"KeyConfig:");
			if(Game.SelectKeyConfig!=0) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(190,205,GetColor(255,255,255),Font.KeyConfig,"Back>>");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=1) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(40,250,GetColor(255,255,255),Font.KeyConfig,"   [%s/%s]",KeyName[KeyCon.Left],PadName[PadCon.Left]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=2) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(40,280,GetColor(255,255,255),Font.KeyConfig,"E   [%s/%s]",KeyName[KeyCon.Right],PadName[PadCon.Right]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=3) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(40,310,GetColor(255,255,255),Font.KeyConfig,"   [%s/%s]",KeyName[KeyCon.Up],PadName[PadCon.Up]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=4) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(40,340,GetColor(255,255,255),Font.KeyConfig,"   [%s/%s]",KeyName[KeyCon.Down],PadName[PadCon.Down]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=5) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(40,370,GetColor(255,255,255),Font.KeyConfig,"2  [%s/%s]",KeyName[KeyCon.Left2],PadName[PadCon.Left2]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=6) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(40,400,GetColor(255,255,255),Font.KeyConfig,"E2  [%s/%s]",KeyName[KeyCon.Right2],PadName[PadCon.Right2]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=7) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(40,430,GetColor(255,255,255),Font.KeyConfig,"2  [%s/%s]",KeyName[KeyCon.Up2],PadName[PadCon.Up2]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=8) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(40,460,GetColor(255,255,255),Font.KeyConfig,"2  [%s/%s]",KeyName[KeyCon.Down2],PadName[PadCon.Down2]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=9) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(240,250,GetColor(255,255,255),Font.KeyConfig,"   [%s/%s]",KeyName[KeyCon.Enter],PadName[PadCon.Enter]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=10) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(240,280,GetColor(255,255,255),Font.KeyConfig,"LZ   [%s/%s]",KeyName[KeyCon.Cancel],PadName[PadCon.Cancel]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=11) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(240,310,GetColor(255,255,255),Font.KeyConfig,"ʏU   [%s/%s]",KeyName[KeyCon.Shot],PadName[PadCon.Shot]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=12) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(240,340,GetColor(255,255,255),Font.KeyConfig,"{   [%s/%s]",KeyName[KeyCon.Bomb],PadName[PadCon.Bomb]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=13) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(240,370,GetColor(255,255,255),Font.KeyConfig,"Target/Free Modeؑ  [%s/%s]",KeyName[KeyCon.ShotModeSelect],PadName[PadCon.ShotModeSelect]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=14) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(240,400,GetColor(255,255,255),Font.KeyConfig,"^[QbgI  [%s/%s]",KeyName[KeyCon.TargetChange],PadName[PadCon.TargetChange]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=15) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(240,430,GetColor(255,255,255),Font.KeyConfig,"XL1gp  [%s/%s]",KeyName[KeyCon.Skill1],PadName[PadCon.Skill1]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=16) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(240,460,GetColor(255,255,255),Font.KeyConfig,"XL2gp  [%s/%s]",KeyName[KeyCon.Skill2],PadName[PadCon.Skill2]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=17) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(540,250,GetColor(255,255,255),Font.KeyConfig,"XL3gp  [%s/%s]",KeyName[KeyCon.Skill3],PadName[PadCon.Skill3]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=18) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(540,280,GetColor(255,255,255),Font.KeyConfig,"XL4gp  [%s/%s]",KeyName[KeyCon.Skill4],PadName[PadCon.Skill4]);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=19) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(540,310,GetColor(255,255,255),Font.KeyConfig,"gp");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=20) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(540,340,GetColor(255,255,255),Font.KeyConfig,"gp");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=21) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(540,370,GetColor(255,255,255),Font.KeyConfig,"gp");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=22) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(540,400,GetColor(255,255,255),Font.KeyConfig,"gp");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=23) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(540,430,GetColor(255,255,255),Font.KeyConfig,"gp");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			if(Game.SelectKeyConfig!=24) SetDrawBlendMode(DX_BLENDMODE_ALPHA,122);
			DrawFormatStringToHandle(540,460,GetColor(255,255,255),Font.KeyConfig,"gp");
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
			break;
	}
}

void StartSelect(void){
	Game.FunctionStatus=FS_PLAY;
	Game.SelectedMenu=SM_NOTSELECTED;
	Game.Frame=-1;
}

void CharacterSelect(void){
	if(KeyOrPad(CF_UP)==1||KeyOrPad(CF_UP2)==1) Game.SelectCharacter--;
	if(KeyOrPad(CF_DOWN)==1||KeyOrPad(CF_DOWN2)==1) Game.SelectCharacter++;
	if(Game.SelectCharacter==CHARACTERMODELNUM) Game.SelectCharacter=0;
	if(Game.SelectCharacter==-1) Game.SelectCharacter=CHARACTERMODELNUM-1;

	if(KeyOrPad(CF_ENTER)==1){
		Game.SelectedCharacter=Game.SelectCharacter;
		Game.SelectedMenu=SM_NOTSELECTED;
	}
	if(KeyOrPad(CF_CANCEL)==1){
		Game.SelectedMenu=SM_NOTSELECTED;
	}
}

void MapSelect(void){
	if(KeyOrPad(CF_UP)==1||KeyOrPad(CF_UP2)==1) Game.SelectMap--;
	if(KeyOrPad(CF_DOWN)==1||KeyOrPad(CF_DOWN2)==1) Game.SelectMap++;
	if(Game.SelectMap==MAPNUM) Game.SelectMap=0;
	if(Game.SelectMap==-1) Game.SelectMap=MAPNUM-1;

	if(KeyOrPad(CF_ENTER)==1){
		Game.SelectedMap=Game.SelectMap;
		Game.SelectedMenu=SM_NOTSELECTED;
	}
	if(KeyOrPad(CF_CANCEL)==1){
		Game.SelectedMenu=SM_NOTSELECTED;
	}
}


// [I
void RuleSelect(void){
	if(KeyOrPad(CF_UP)==1||KeyOrPad(CF_UP2)==1) Game.SelectRule--;
	if(KeyOrPad(CF_DOWN)==1||KeyOrPad(CF_DOWN2)==1) Game.SelectRule++;
	if(Game.SelectRule==SR_TEAMDEATHMATCH+1) Game.SelectRule=SR_TEAMDEATHMATCH;
	if(Game.SelectRule==SR_TEAMDEATHMATCH-1) Game.SelectRule=SR_TEAMDEATHMATCH;

	if(KeyOrPad(CF_ENTER)==1){
		Game.SelectedRule=Game.SelectRule;
		Game.SelectedMenu=SM_NOTSELECTED;
	}
	if(KeyOrPad(CF_CANCEL)==1){
		Game.SelectedMenu=SM_NOTSELECTED;
	}
}

void KeyConfig(void){
	KEYCON KeyCon=GetKeyCon();
	KEYCON PadCon=GetPadCon();
	int *Key=GetKey();
	int *Pad=GetPad();

	if(KeyOrPad(CF_UP)==1||KeyOrPad(CF_UP2)==1) Game.SelectKeyConfig--;
	if(KeyOrPad(CF_DOWN)==1||KeyOrPad(CF_DOWN2)==1) Game.SelectKeyConfig++;
	if(KeyOrPad(CF_LEFT)==1||KeyOrPad(CF_LEFT2)==1){
		Game.SelectKeyConfig-=8;
		if(Game.SelectKeyConfig<1) Game.SelectKeyConfig+=24;
	}
	if(KeyOrPad(CF_RIGHT)==1||KeyOrPad(CF_RIGHT2)==1){
		Game.SelectKeyConfig+=8;
		if(Game.SelectKeyConfig>24) Game.SelectKeyConfig-=24;
	}

	if(Game.SelectKeyConfig==25) Game.SelectKeyConfig=0;
	if(Game.SelectKeyConfig==-1) Game.SelectKeyConfig=24;

	if(KeyOrPad(CF_ENTER)==1){
		if(Game.SelectKeyConfig==0) Game.SelectedMenu=SM_NOTSELECTED;
		else Game.SelectedKeyConfig=Game.SelectKeyConfig;
	}

	if(Game.SelectedKeyConfig==1 ){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Left=i; Game.SelectedKeyConfig=0; }
												    for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Left=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==2 ){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Right=i; Game.SelectedKeyConfig=0; }
												    for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Right=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==3 ){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Up=i; Game.SelectedKeyConfig=0; }
												    for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Up=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==4 ){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Down=i; Game.SelectedKeyConfig=0; }
												    for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Down=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==5 ){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Left2=i; Game.SelectedKeyConfig=0; }
												    for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Left2=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==6 ){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Right2=i; Game.SelectedKeyConfig=0; }
												    for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Right2=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==7 ){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Up2=i; Game.SelectedKeyConfig=0; }
												    for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Up2=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==8 ){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Down2=i; Game.SelectedKeyConfig=0; }
												    for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Down2=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==9 ){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Enter=i; Game.SelectedKeyConfig=0; }
								  				    for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Enter=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==10){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Cancel=i; Game.SelectedKeyConfig=0; }
													for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Cancel=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==11){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Shot=i; Game.SelectedKeyConfig=0; }
													for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Shot=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==12){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Bomb=i; Game.SelectedKeyConfig=0; }
													for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Bomb=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==13){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.ShotModeSelect=i; Game.SelectedKeyConfig=0; }
													for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.ShotModeSelect=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==14){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.TargetChange=i; Game.SelectedKeyConfig=0; }
													for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.TargetChange=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==15){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Skill1=i; Game.SelectedKeyConfig=0; }
													for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Skill1=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==16){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Skill2=i; Game.SelectedKeyConfig=0; }
													for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Skill2=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==17){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Skill3=i; Game.SelectedKeyConfig=0; }
													for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Skill3=i; Game.SelectedKeyConfig=0; }}
	if(Game.SelectedKeyConfig==18){ WaitKeyOrPad(); for(int i=0;i<ALLKEY;i++) if(Key[i]==1){ KeyCon.Skill4=i; Game.SelectedKeyConfig=0; }
													for(int i=0;i<ALLPAD;i++) if(Pad[i]==1){ PadCon.Skill4=i; Game.SelectedKeyConfig=0; }}
}

// j[
void Menu(void){
	if(KeyOrPad(CF_UP)==1||KeyOrPad(CF_UP2)==1) Game.SelectMenu--;
	if(KeyOrPad(CF_DOWN)==1||KeyOrPad(CF_DOWN2)==1) Game.SelectMenu++;
	if(Game.SelectMenu==SM_START+1) Game.SelectMenu=SM_KEYCONFIG;
	if(Game.SelectMenu==SM_NOTSELECTED) Game.SelectMenu=SM_START;

	if(KeyOrPad(CF_ENTER)==1) Game.SelectedMenu=Game.SelectMenu;
}