#ifndef _GAME_H_
#define _GAME_H_

// Q[
struct GAME {
	int FunctionStatus;
	int Frame;
	int SelectRule;
	int SelectedRule;
	int SelectMenu;
	int SelectedMenu;
	int SelectKeyConfig;
	int SelectedKeyConfig;
	int SelectCharacter;
	int SelectedCharacter;
	int SelectMap;
	int SelectedMap;
};

// QƗp
GAME GetGameAll(void);
int GetGameFrame(void);
int GetGameFunctionStatus(void);
int GetGameSelectedMenu(void);
int GetGameSelectedRule(void);
int GetGameSelectedCharacter(void);
int GetGameSelectMap(void);

void GameInit(void);
void GameFrameCountUp(void);
void UpdateGameFunctionStatus(int State);

void MenuDraw(void);
void StartSelect(void);
void CharacterSelect(void);
void MapSelect(void);
void RuleSelect(void);
void KeyConfig(void);
void Menu(void);

#endif