#include "GraphHandle.h"
#include "Game.h"
#include "Camera.h"
#include "DxLib.h"

// \̎̒`
static GRAPHHANDLE Handle;

// QƗp
HANDLES* GetCharacterModelHandle(void){ return Handle.Character; } // LN^̃fnh擾
HANDLES* GetStarBulletGraphHandle(void){ return Handle.StarBullet; } // ^ẽOtnh擾
HANDLES GetScreenGraphHandle(void){ return Handle.Screen; } // XN[̉摜nh擾
GRAPHHANDLE GetAllHandle(void){ return Handle; } // Snh擾

// L̃f[h
void LoadCharacterModel(void){

	char CharacterModel[CHARACTERMODELNUM][30]={{"Model/pc_test1.mqo"},{"Model/MarisaV12/Ver12.mv1"}};
	for(int i=0;i<CHARACTERMODELNUM;i++) Handle.Character[i].Model=MV1LoadModel(CharacterModel[i]);
}

// {̃f[h
void LoadBombModel(void){

	char BombModel[BOMBNUM][30]={{"Model/masterspark8.mv1"}};
	for(int i=0;i<BOMBNUM;i++) Handle.Bomb[i].Model=MV1LoadModel(BombModel[i]);
}

// 摜[h
void LoadGraphs(void){

	char StarBullet[5][30]={"Graph/BulletS0.png","Graph/BulletS1.png","Graph/BulletS2.png","Graph/BulletS3.png","Graph/BulletS4.png"};
	char BombGraph[BOMBNUM][30]={{"Graph/Bomb0.png"}};
	for(int i=0;i<5;i++) Handle.StarBullet[i].Graph=LoadGraph(StarBullet[i]);
	Handle.ScoreBoard.Graph=LoadGraph("Graph/ScoreBoard.jpg");
	for(int i=0;i<BOMBNUM;i++) Handle.Bomb[i].Graph=LoadGraph(BombGraph[i]);
	Handle.RedBullet.Graph=LoadGraph("Graph/RedBullet.png");
	Handle.BuleBullet.Graph=LoadGraph("Graph/BlueBullet.png");
}

// `ʗ̈̉摜쐬
HANDLES MakeScreenGraph(void){
	int GameFrame=GetGameFrame();
	CAMERA Camera=GetCamera();

	// Q[Jn
	if(GameFrame==0){

		// `ʉ\ȉ摜쐬
		SetUseDivGraphFlag(FALSE);
		SetDrawValidAlphaChannelGraphCreateFlag(TRUE);
		Handle.Screen.Graph=MakeScreen(961,541,0);
		SetDrawValidAlphaChannelGraphCreateFlag(FALSE);
		SetUseDivGraphFlag(TRUE);
	}
	
	// O[XP[摜
	SetDrawScreen(Handle.Screen.Graph);
	ClearDrawScreen();

	// JĐݒ
	SetupCamera_Perspective(DX_PI/3);
	SetCameraScreenCenter(380.0f,270.0f);
	SetCameraPositionAndAngle(VGet(Camera.Pos.x,Camera.Pos.y,Camera.Pos.z),Camera.Rot.v,Camera.Rot.h,Camera.Rot.t) ;
	
	DrawPhase();
	
	SetDrawScreen(DX_SCREEN_BACK);

	// JĐݒ
	SetupCamera_Perspective(DX_PI/3);
	SetCameraScreenCenter(380.0f,270.0f);
	SetCameraPositionAndAngle(VGet(Camera.Pos.x,Camera.Pos.y,Camera.Pos.z),Camera.Rot.v,Camera.Rot.h,Camera.Rot.t);

	return Handle.Screen;
}