#ifndef _GRAPHHANDLE_H_
#define _GRAPHHANDLE_H_

#include "main.h"

// fnh
struct HANDLES {
	int Graph;
	int Model;
	int Attach;
	int Anitime;
	int BeforeAttach;
	int AfterAttach;
	int BeforeAnim;
	int AfterAnim;
};

// nhQ
struct GRAPHHANDLE {
	HANDLES Screen; // 
	HANDLES ScoreBoard; // XRA{[h
	HANDLES RedBullet; // Ԃe
	HANDLES BuleBullet; // e
	HANDLES StarBullet[5]; // ^e
	HANDLES Character[CHARACTERMODELNUM]; // LN^
	HANDLES Bomb[BOMBNUM]; // {
};

// QƗp
HANDLES* GetCharacterModelHandle(void);
HANDLES* GetStarBulletGraphHandle(void);
HANDLES GetScreenGraphHandle(void);
GRAPHHANDLE GetAllHandle(void);

void LoadCharacterModel(void);
void LoadBombModel(void);
void LoadGraphs(void);
HANDLES MakeScreenGraph(void);

#endif