#include <string.h>
#include "KeyPadInput.h"
#include "main.h"
#include "DxLib.h"

// \̎̒`
static KEYCON KeyCon,PadCon;

static int Key[256]; // L[Ăt[̊i[
static int Pad[32]; // pbh̃{^Ăt[̊i[
char KeyName[ALLKEY][12]; // L[̖O
char PadName[ALLPAD][12]; // pbh̖O
static DINPUT_JOYSTATE PadState; // pbh͏̊i[

// QƗp
KEYCON GetKeyCon(void){ return KeyCon; } // L[RtBO擾
KEYCON GetPadCon(void){ return PadCon; } // pbhRtBO擾
int* GetKey(void){ return Key; } // L[Ăt[擾
int* GetPad(void){ return Pad; } // pbh̃{^Ăt[擾
DINPUT_JOYSTATE GetPadState(void){ return PadState; } // pbh͏̎擾

// L[RtBO
void KeyConfigInit(void){

	// L[{[h
	KeyCon.Left=KEY_INPUT_A;
	KeyCon.Right=KEY_INPUT_D;
	KeyCon.Up=KEY_INPUT_W;
	KeyCon.Down=KEY_INPUT_S;
	KeyCon.Left2=KEY_INPUT_LEFT;
	KeyCon.Right2=KEY_INPUT_RIGHT;
	KeyCon.Up2=KEY_INPUT_UP;
	KeyCon.Down2=KEY_INPUT_DOWN;
	KeyCon.Enter=KEY_INPUT_Z;
	KeyCon.Cancel=KEY_INPUT_X;
	KeyCon.Shot=KEY_INPUT_SPACE;
	KeyCon.Bomb=KEY_INPUT_B;
	KeyCon.ShotModeSelect=KEY_INPUT_E;
	KeyCon.TargetChange=KEY_INPUT_R;
	KeyCon.Skill1=KEY_INPUT_F;
	KeyCon.Skill2=KEY_INPUT_G;
	KeyCon.Skill3=KEY_INPUT_C;
	KeyCon.Skill4=KEY_INPUT_V;

	// pbh́ij
	PadCon.Left=17;
	PadCon.Right=16;
	PadCon.Up=19;
	PadCon.Down=18;
	PadCon.Left2=23;
	PadCon.Right2=22;
	PadCon.Up2=25;
	PadCon.Down2=24;
	PadCon.Enter=1;
	PadCon.Cancel=0;
	PadCon.Shot=5;
	PadCon.Bomb=4;
	PadCon.ShotModeSelect=21;
	PadCon.TargetChange=20;
	PadCon.Skill1=28;
	PadCon.Skill2=29;
	PadCon.Skill3=30;
	PadCon.Skill4=31;
}

// L[̖O擾
void LoadKeyName(void){

	strcpy_s(KeyName[KEY_INPUT_BACK],"BackSpace");    strcpy_s(KeyName[KEY_INPUT_TAB],"Tab");
	strcpy_s(KeyName[KEY_INPUT_RETURN],"Enter");      strcpy_s(KeyName[KEY_INPUT_LSHIFT],"LShift");
	strcpy_s(KeyName[KEY_INPUT_RSHIFT],"RShift");     strcpy_s(KeyName[KEY_INPUT_LCONTROL],"LControl");
	strcpy_s(KeyName[KEY_INPUT_RCONTROL],"RControl"); strcpy_s(KeyName[KEY_INPUT_ESCAPE],"Escape");
	strcpy_s(KeyName[KEY_INPUT_SPACE],"Space");       strcpy_s(KeyName[KEY_INPUT_PGUP],"PageUp");
	strcpy_s(KeyName[KEY_INPUT_PGDN],"PageDown");     strcpy_s(KeyName[KEY_INPUT_END],"End");
	strcpy_s(KeyName[KEY_INPUT_HOME],"Home");         strcpy_s(KeyName[KEY_INPUT_LEFT],"Left");
	strcpy_s(KeyName[KEY_INPUT_RIGHT],"Right");       strcpy_s(KeyName[KEY_INPUT_DOWN],"Down");
	strcpy_s(KeyName[KEY_INPUT_UP],"Up");             strcpy_s(KeyName[KEY_INPUT_INSERT],"Insert");
	strcpy_s(KeyName[KEY_INPUT_DELETE],"Delete");

	strcpy_s(KeyName[KEY_INPUT_F1],"F1");   strcpy_s(KeyName[KEY_INPUT_F2],"F2");
	strcpy_s(KeyName[KEY_INPUT_F3],"F3");   strcpy_s(KeyName[KEY_INPUT_F4],"F4");
	strcpy_s(KeyName[KEY_INPUT_F5],"F5");   strcpy_s(KeyName[KEY_INPUT_F6],"F6");
	strcpy_s(KeyName[KEY_INPUT_F7],"F7");   strcpy_s(KeyName[KEY_INPUT_F8],"F8");
	strcpy_s(KeyName[KEY_INPUT_F9],"F9");   strcpy_s(KeyName[KEY_INPUT_F10],"F10");
	strcpy_s(KeyName[KEY_INPUT_F11],"F11"); strcpy_s(KeyName[KEY_INPUT_F12],"F12");

	strcpy_s(KeyName[KEY_INPUT_A],"A"); strcpy_s(KeyName[KEY_INPUT_B],"B");
	strcpy_s(KeyName[KEY_INPUT_C],"C"); strcpy_s(KeyName[KEY_INPUT_D],"D");
	strcpy_s(KeyName[KEY_INPUT_E],"E"); strcpy_s(KeyName[KEY_INPUT_F],"F");
	strcpy_s(KeyName[KEY_INPUT_G],"G"); strcpy_s(KeyName[KEY_INPUT_H],"H");
	strcpy_s(KeyName[KEY_INPUT_I],"I"); strcpy_s(KeyName[KEY_INPUT_J],"J");
	strcpy_s(KeyName[KEY_INPUT_K],"K"); strcpy_s(KeyName[KEY_INPUT_L],"L");
	strcpy_s(KeyName[KEY_INPUT_M],"M"); strcpy_s(KeyName[KEY_INPUT_N],"N");
	strcpy_s(KeyName[KEY_INPUT_O],"O"); strcpy_s(KeyName[KEY_INPUT_P],"P");
	strcpy_s(KeyName[KEY_INPUT_Q],"Q"); strcpy_s(KeyName[KEY_INPUT_R],"R");
	strcpy_s(KeyName[KEY_INPUT_S],"S"); strcpy_s(KeyName[KEY_INPUT_T],"T");
	strcpy_s(KeyName[KEY_INPUT_U],"U"); strcpy_s(KeyName[KEY_INPUT_V],"V");
	strcpy_s(KeyName[KEY_INPUT_W],"W"); strcpy_s(KeyName[KEY_INPUT_X],"X");
	strcpy_s(KeyName[KEY_INPUT_Y],"Y"); strcpy_s(KeyName[KEY_INPUT_Z],"Z");

	strcpy_s(KeyName[KEY_INPUT_0],"0"); strcpy_s(KeyName[KEY_INPUT_1],"1");
	strcpy_s(KeyName[KEY_INPUT_2],"2"); strcpy_s(KeyName[KEY_INPUT_3],"3");
	strcpy_s(KeyName[KEY_INPUT_4],"4"); strcpy_s(KeyName[KEY_INPUT_5],"5");
	strcpy_s(KeyName[KEY_INPUT_6],"6"); strcpy_s(KeyName[KEY_INPUT_7],"7");
	strcpy_s(KeyName[KEY_INPUT_8],"8"); strcpy_s(KeyName[KEY_INPUT_9],"9");

	strcpy_s(PadName[0],"Button0");   strcpy_s(PadName[1],"Button1");
	strcpy_s(PadName[2],"Button2");   strcpy_s(PadName[3],"Button3");
	strcpy_s(PadName[4],"Button4");   strcpy_s(PadName[5],"Button5");
	strcpy_s(PadName[6],"Button6");   strcpy_s(PadName[7],"Button7");
	strcpy_s(PadName[8],"Button8");   strcpy_s(PadName[9],"Button9");
	strcpy_s(PadName[10],"Button10"); strcpy_s(PadName[11],"Button11");
	strcpy_s(PadName[12],"Button12"); strcpy_s(PadName[13],"Button13");
	strcpy_s(PadName[14],"Button14"); strcpy_s(PadName[15],"Button15");
	strcpy_s(PadName[16],"Stick_X");  strcpy_s(PadName[17],"Stick_-X");
	strcpy_s(PadName[18],"Stick_Y");  strcpy_s(PadName[19],"Stick_-Y");
	strcpy_s(PadName[20],"Stick_Z");  strcpy_s(PadName[21],"Stick_-Z");
	strcpy_s(PadName[22],"Stick_RX"); strcpy_s(PadName[23],"Stick_-RX");
	strcpy_s(PadName[24],"Stick_RY"); strcpy_s(PadName[25],"Stick_-RY");
	strcpy_s(PadName[26],"Stick_RZ"); strcpy_s(PadName[27],"Stick_-RZ");
	strcpy_s(PadName[28],"POV_UP");   strcpy_s(PadName[29],"POV_RIGHT");
	strcpy_s(PadName[30],"POV_DOWN"); strcpy_s(PadName[31],"POV_LEFT");
}

// L[pbh͂Ă璷͂ĂlԂB
int KeyOrPad(int InputKey){

	switch(InputKey){
		case CF_LEFT:
			return (Key[KeyCon.Left]>Pad[PadCon.Left])? Key[KeyCon.Left] : Pad[PadCon.Left];
		case CF_RIGHT:
			return (Key[KeyCon.Right]>Pad[PadCon.Right])? Key[KeyCon.Right] : Pad[PadCon.Right];
		case CF_UP:
			return (Key[KeyCon.Up]>Pad[PadCon.Up])? Key[KeyCon.Up] : Pad[PadCon.Up];
		case CF_DOWN:
			return (Key[KeyCon.Down]>Pad[PadCon.Down])? Key[KeyCon.Down] : Pad[PadCon.Down];
		case CF_LEFT2:
			return (Key[KeyCon.Left2]>Pad[PadCon.Left2])? Key[KeyCon.Left2] : Pad[PadCon.Left2];
		case CF_RIGHT2:
			return (Key[KeyCon.Right2]>Pad[PadCon.Right2])? Key[KeyCon.Right2] : Pad[PadCon.Right2];
		case CF_UP2:
			return (Key[KeyCon.Up2]>Pad[PadCon.Up2])? Key[KeyCon.Up2] : Pad[PadCon.Up2];
		case CF_DOWN2:
			return (Key[KeyCon.Down2]>Pad[PadCon.Down2])? Key[KeyCon.Down2] : Pad[PadCon.Down2];
		case CF_ENTER:
			return (Key[KeyCon.Enter]>Pad[PadCon.Enter])? Key[KeyCon.Enter] : Pad[PadCon.Enter];
		case CF_CANCEL:
			return (Key[KeyCon.Cancel]>Pad[PadCon.Cancel])? Key[KeyCon.Cancel] : Pad[PadCon.Cancel];
		case CF_SHOT:
			return (Key[KeyCon.Shot]>Pad[PadCon.Shot])? Key[KeyCon.Shot] : Pad[PadCon.Shot];
		case CF_BOMB:
			return (Key[KeyCon.Bomb]>Pad[PadCon.Bomb])? Key[KeyCon.Bomb] : Pad[PadCon.Bomb];
		case CF_SHOTMODESELECT:
			return (Key[KeyCon.ShotModeSelect]>Pad[PadCon.ShotModeSelect])? Key[KeyCon.ShotModeSelect] : Pad[PadCon.ShotModeSelect];
		case CF_TARGETCHANGE:
			return (Key[KeyCon.TargetChange]>Pad[PadCon.TargetChange])? Key[KeyCon.TargetChange] : Pad[PadCon.TargetChange];
		case CF_SKILL1:
			return (Key[KeyCon.Skill1]>Pad[PadCon.Skill1])? Key[KeyCon.Skill1] : Pad[PadCon.Skill1];
		case CF_SKILL2:
			return (Key[KeyCon.Skill2]>Pad[PadCon.Skill2])? Key[KeyCon.Skill2] : Pad[PadCon.Skill2];
		case CF_SKILL3:
			return (Key[KeyCon.Skill3]>Pad[PadCon.Skill3])? Key[KeyCon.Skill3] : Pad[PadCon.Skill3];
		case CF_SKILL4:
			return (Key[KeyCon.Skill4]>Pad[PadCon.Skill4])? Key[KeyCon.Skill4] : Pad[PadCon.Skill4];
	}
	return 0;
}

// L[͂pbh͂󂯂܂őҋ@
void WaitKeyOrPad(void){

	while(1){
		GetHitKeyStateAll2(); // L[͍XV
		GetHitPadStateAll();  // pbh͍XV
		ProcessMessage(); // ͒l
		for(int i=0;i<ALLKEY;i++) if(Key[i]==1) return; // L[͂ꂽ疳[vEo
		for(int i=0;i<ALLPAD;i++) if(Pad[i]==1) return; // pbh͂ꂽ疳[vEo
	}
}
// L[̓͏Ԃ̍XV
int GetHitKeyStateAll2(){
	char TmpKey[ALLKEY];

    GetHitKeyStateAll(TmpKey);
    for(int i=0;i<ALLKEY;i++) if(TmpKey[i]!=0) Key[i]++; else Key[i]=0;
    return 0;
}

//pbh̓͏Ԃ擾
void GetHitPadStateAll(void){
    int PadInput=GetJoypadInputState(DX_INPUT_PAD1);
	int Mul=16;

    for(int i=0;i<12;i++){
        if(PadInput&Mul) Pad[i]++; else Pad[i]=0; // eX̃{^̓͂
        Mul*=2;
    }

	// AiOXeBbN̓͂擾
	GetJoypadDirectInputState(DX_INPUT_PAD1,&PadState);

	// AiOXeBbÑZbg
	if(PadState.X>0) Pad[16]++; else Pad[16]=0;
	if(PadState.X<0) Pad[17]++; else Pad[17]=0;
	if(PadState.Y>0) Pad[18]++; else Pad[18]=0;
	if(PadState.Y<0) Pad[19]++; else Pad[19]=0;
	if(PadState.Z>0) Pad[20]++; else Pad[20]=0;
	if(PadState.Z<0) Pad[21]++; else Pad[21]=0;
	if(PadState.Rx>0) Pad[22]++; else Pad[22]=0;
	if(PadState.Rx<0) Pad[23]++; else Pad[23]=0;
	if(PadState.Ry>0) Pad[24]++; else Pad[24]=0;
	if(PadState.Ry<0) Pad[25]++; else Pad[25]=0;
	if(PadState.Rz>0) Pad[26]++; else Pad[26]=0;
	if(PadState.Rz<0) Pad[27]++; else Pad[27]=0;
	// POṼZbg
	if(PadState.POV[0]==0||PadState.POV[0]==4500||PadState.POV[0]==31500) Pad[28]++; else Pad[28]=0;
	if(PadState.POV[0]==9000||PadState.POV[0]==4500||PadState.POV[0]==13500) Pad[29]++; else Pad[29]=0;
	if(PadState.POV[0]==18000||PadState.POV[0]==13500||PadState.POV[0]==22500) Pad[30]++; else Pad[30]=0;
	if(PadState.POV[0]==27000||PadState.POV[0]==22500||PadState.POV[0]==31500) Pad[31]++; else Pad[31]=0;
}