#ifndef _PLAYER_H_
#define _PLAYER_H_

#include "DxLib.h"
#include "GraphHandle.h"

// LptOW
struct FLAG {
	int TargetMode; // ˌ[h
	int Target; // _ĂGID
	int SelectedBomb; // {I
	int LastDeadlyFrame; // SԂɂȂ
	int LastDeadFrame; // SԂɂȂ
	int TargetModeFrame; // ̎ˌ[hɂ
	int LastDamageFrame; // ŌɃ_[W󂯂
	int LastRecoveryFrame; // Ōɉ񕜂󂯂
	int LastShotFrame; // ŌɎˌ
	int LastMoveFrame; // ŌɈړ
	int LastAttachFrame; // ŌɃAj[Vς
	// CPUp
	int LastMoveDecideFrame; // Ōɍs߂
};

// vC̎XL
struct PCSKILL {
	int Selected; // I񂾃XLA{
	int State; // XL̏
	VECTOR Pos[2]; // ʒu
	int StartFrame; // XLʊJnt[
	int EndFrame; // XLʏIt[
	int CoolTime; // Ďgp\
};

// L
struct PC {
	HANDLES Handle; // fnh
	int ModelID; // fԍ
	int Control; // 
	char Name[30]; // O
	FLAG Flag; // tOW
	VECTOR PPos; // Öʒu̍W
	VECTOR Pos; // ݈ʒu̍W
	VECTOR NPos; // ړ̍W
	ROT Rot;    // px
	ROT RotTar; // ڕWpx
	ROT SARot; // Upx
	ROT Spd; // ]x
	ROT RotEne; // G̊px
	int NearEne[2]; // ԋ߂GID
	float DisEne; // G܂ł̋
	int MaxLife; // ő̗
	int Life; // ̗
	int Damage; // _[W
	int Recovery; // 
	int Kill; // EQ
	int Score,ScoreTar; // XRA
	int Team; // `[
	int Death; // S
	int Graze; // 萔
	int Condition; // Ԉُ
	int State; // 
	float Power; // ˌ
	float Bomb; // {
	PCSKILL Skill[4]; // ZbgꂽXL
	PCSKILL SetBomb; // Zbgꂽ{
	int Killed; // Eꂽ
	int Killedby; // v
	//CPUp
	int MMInterval; // ősԊu
	VECTOR Move; // ړ
};

// QƗp
int GetMainPlayerID(void);
PC* GetAllPlayer(void);
PC GetPlayer(int ID);
VECTOR GetPlayerPos(int ID);
ROT GetPlayerRot(int ID);
float GetPlayerPower(int ID);

void PlayerInit(void);
void MainPlayerControl(void);
void CpuControl(void);
void MainPlayerMove(void);
void CpuMove(void);
void DrawPlayer(void);
void CalcTarget(int ID);
double CalcDis(int ID,int EID);
void CalcPlayer(void);
void PlayerRespawn(int ID);
int CheckAllHit(int PcID,VECTOR Old,VECTOR New);
void PlayerDamage(int DamegedID, int AttackerID,int DamagePoint);
void CheckPlayerKilled(int KilledID, int KillID, int Killedby);
void PlayerOutArea(void);
void UpdatePlayerAnim(void);
void UpdateAllPlayer(void);
void DrawPlayerStatus(void);
void DrawEnemyStatus(void);
void SkillRegist(int i,int SkillNum);
void SkillUnregist(int i,int SkillNum);
void BombRegist(int i);
void BombUnregist(int i);
void SkillMove(void);
void BombMove(void);

#endif