#include "DxLib.h"
#include "Shot.h"
#include "main.h"
#include "Move.h"
#include <math.h>

extern PC Pc[PCNUM];
extern CAMERA Camera;
extern GAME Game;
extern BULLET Bullet[SHOTMAX];
extern GRAPHHANDLE Handle;
extern NUM Num;
extern TEAM Team[PCNUM];
extern KILLLOG KillLog[6];
extern int PlayerID;
extern DINPUT_JOYSTATE PadState;


// eo^łȂƂT
int SearchShot(int i){
	for(int j=0;j<SHOTMAX;j++) if(Pc[i].PcBullet[j].Flag==0) return j;
	return -1;
}

// 蔻
bool HitSearch(int PcID,int BulletID,int EcID,VECTOR Old,VECTOR New){
	if(Pc[PcID].Team!=Pc[EcID].Team&&Pc[EcID].State!=PS_DEADLY&&Pc[EcID].State!=PS_DEAD&&Pc[EcID].State!=PS_SATTACK){
		float Length;
		VECTOR Tmp;
		Tmp.x=Pc[EcID].Pos.x; Tmp.y=Pc[EcID].Pos.y; Tmp.z=Pc[EcID].Pos.z;
		Length=Segment_Point_MinLength(Old,New,Tmp);
		if(Length<Pc[PcID].PcBullet[BulletID].Size*6){
			MV1_COLL_RESULT_POLY Result=MV1CollCheck_Line(Pc[EcID].Handle.Model,-1,Old,New);
			if(Result.HitFlag) return true;
		}
		if(Length<100) Pc[EcID].Graze++;
	}
	return false;
}

// XL̎gp
void SkillRegist(int i,int SkillNum){

	// ԃZbg
	Pc[i].State=PS_SATTACK;
	Pc[i].Skill[SkillNum].State=SS_ACTIVATED;
	Pc[i].Skill[SkillNum].StartFrame=Game.Frame;
	if(Pc[i].Skill[SkillNum].Selected==SK_DOUBLEDIRECTIONALLAZER){
		Pc[i].Skill[SkillNum].EndFrame=Pc[i].Skill[SkillNum].StartFrame+200;
		Pc[i].Skill[SkillNum].Pos[0]=Pc[i].Pos;
		Pc[i].Skill[SkillNum].Pos[1]=Pc[i].Pos;
		if(Pc[i].Control==CC_MAINPLAYER){
			Pc[i].Skill[SkillNum].Pos[1].x+=18192*sin(Camera.Rot.v+1.0f/2.0f*M_PI)*cos(1.0f/2.0f*M_PI-Camera.Rot.h);
			Pc[i].Skill[SkillNum].Pos[1].y+=18192*cos(Camera.Rot.v+1.0f/2.0f*M_PI);
			Pc[i].Skill[SkillNum].Pos[1].z+=18192*sin(Camera.Rot.v+1.0f/2.0f*M_PI)*sin(1.0f/2.0f*M_PI-Camera.Rot.h);
		}else{
			Pc[i].Skill[SkillNum].Pos[1].x+=18192*sin(Pc[i].Rot.v+1.0f/2.0f*M_PI)*cos(1.0f/2.0f*M_PI-Pc[i].Rot.h);
			Pc[i].Skill[SkillNum].Pos[1].y+=18192*cos(Pc[i].Rot.v+1.0f/2.0f*M_PI);
			Pc[i].Skill[SkillNum].Pos[1].z+=18192*sin(Pc[i].Rot.v+1.0f/2.0f*M_PI)*sin(1.0f/2.0f*M_PI-Pc[i].Rot.h);
		}
	}
}

// XL̉
void SkillUnregist(int i,int SkillNum){

	if(Pc[i].State==PS_SATTACK) Pc[i].State=PS_FINE;
	Pc[i].Skill[SkillNum].State=SS_AVAILABLE;
}

// {̎gp
void BombRegist(int i){

	// ԃZbg
	Pc[i].State=PS_SATTACK;
	Pc[i].SetBomb.StartFrame=Game.Frame;
	Pc[i].SetBomb.State=SS_ACTIVATED;
	Pc[i].Bomb--;
	if(Pc[i].SetBomb.Selected==BM_MASTERSPARK){
		Pc[i].SetBomb.EndFrame=Pc[i].SetBomb.StartFrame+300;
		Pc[i].SetBomb.Pos[0]=Pc[i].Pos;
		Pc[i].SetBomb.Pos[1]=Pc[i].Pos;
		if(Pc[i].Control==CC_MAINPLAYER){
			Pc[i].SARot=Camera.Rot;
			Pc[i].SetBomb.Pos[1].x+=18192*sin(Camera.Rot.v+1.0f/2.0f*M_PI)*cos(1.0f/2.0f*M_PI-Camera.Rot.h);
			Pc[i].SetBomb.Pos[1].y+=18192*cos(Camera.Rot.v+1.0f/2.0f*M_PI);
			Pc[i].SetBomb.Pos[1].z+=18192*sin(Camera.Rot.v+1.0f/2.0f*M_PI)*sin(1.0f/2.0f*M_PI-Camera.Rot.h);
		}else{
			Pc[i].SARot=Pc[i].Rot;
			Pc[i].SetBomb.Pos[1].x+=18192*sin(Pc[i].Rot.v+1.0f/2.0f*M_PI)*cos(1.0f/2.0f*M_PI-Pc[i].Rot.h);
			Pc[i].SetBomb.Pos[1].y+=18192*cos(Pc[i].Rot.v+1.0f/2.0f*M_PI);
			Pc[i].SetBomb.Pos[1].z+=18192*sin(Pc[i].Rot.v+1.0f/2.0f*M_PI)*sin(1.0f/2.0f*M_PI-Pc[i].Rot.h);
		}
	}
}

// {̉
void BombUnregist(int i){

	if(Pc[i].State==PS_SATTACK) Pc[i].State=PS_FINE;
	if(Pc[i].Bomb<1.0f) Pc[i].SetBomb.State=SS_UNAVAILABLE; else Pc[i].SetBomb.State=SS_AVAILABLE;
}

// eo^
void ShotRegist(int i){
	int j;

	if((j=SearchShot(i))!=-1){
		if(Pc[i].Team==0) Pc[i].PcBullet[j].Handle.Graph=Handle.RedBullet.Graph;
		else Pc[i].PcBullet[j].Handle.Graph=Handle.BuleBullet.Graph;
		Pc[i].PcBullet[j].Flag=1;
		Pc[i].PcBullet[j].Variety=BV_NORMAL;
		Pc[i].PcBullet[j].Pos.x=Pc[i].Pos.x;
		Pc[i].PcBullet[j].Pos.y=Pc[i].Pos.y;
		Pc[i].PcBullet[j].Pos.z=Pc[i].Pos.z;
		if(Pc[i].Flag.TargetMode==1||i!=PlayerID){
			if(i!=PlayerID){
				Pc[i].PcBullet[j].Rot.h=Pc[i].RotEne.h+((double)GetRand(1000)-500)/1500;
				Pc[i].PcBullet[j].Rot.v=Pc[i].RotEne.v+((double)GetRand(1000)-500)/1500;
				Pc[i].PcBullet[j].Rot.t=Pc[i].RotEne.t+((double)GetRand(1000)-500)/1500;
			}else{
				Pc[i].PcBullet[j].Rot.h=Pc[i].RotEne.h+((double)GetRand(1000)-500)/1500+PadState.Rx/10000.0;
				Pc[i].PcBullet[j].Rot.v=Pc[i].RotEne.v+((double)GetRand(1000)-500)/1500+PadState.Ry/10000.0;
				Pc[i].PcBullet[j].Rot.t=Pc[i].RotEne.t+((double)GetRand(1000)-500)/1500;
			}
		}else{
			Pc[i].PcBullet[j].Rot.h=Camera.Rot.h+((double)GetRand(1000)-500)/1500;
			Pc[i].PcBullet[j].Rot.v=Camera.Rot.v+((double)GetRand(1000)-500)/1500;
			Pc[i].PcBullet[j].Rot.t=Camera.Rot.t+((double)GetRand(1000)-500)/1500;
		}
		Pc[i].PcBullet[j].Spd=40.0f;
		Pc[i].PcBullet[j].Size=40.0f;
		Pc[i].PcBullet[j].Power=10;
		Pc[i].Flag.LastShotFrame=Game.Frame;

	}
}

// eo^
void ShotUnregist(int i,int Num){
	Pc[i].PcBullet[Num].Flag=0;
}

// ΐ폈
void Killed(int Kill,int Killed, int by){

	// łł͂Ȃ
	if(Kill!=-1){
		// LZ
		Pc[Kill].Kill++;
		Pc[Kill].ScoreTar+=100;

		// ʏUœ|Ȃp[Abv
		if(by==KL_DEFAULT){ Pc[Kill].Power+=0.5; }

		// [`[fXȂ1_Z
		if(Game.SelectedRule==SR_TEAMDEATHMATCH&&Pc[Kill].Team!=Pc[Killed].Team) Team[Pc[Kill].Team].Point++;
	}

	// ꂽL̎Sƃp[_E 
	Pc[Killed].Death++;
	Pc[Killed].Power--;
	if(Pc[Killed].Power<0) Pc[Killed].Power=0;

	// LOɓo^
	KillLog[Num.KillLog].Kill=Kill;
	KillLog[Num.KillLog].Killed=Killed;
	KillLog[Num.KillLog].Frame=Game.Frame;
	KillLog[Num.KillLog].by=by;
	KillLog[Num.KillLog].x=10;
	KillLog[Num.KillLog].y=400+28*(Num.KillLog+1);

	// LȌɒBĂȂ
	if(Num.KillLog<5){
		Num.KillLog++;

	// BĂ
	}else{

		// Â̂㏑
		for(int k=0;k<Num.KillLog;k++){
			KillLog[k].Kill=KillLog[k+1].Kill;
			KillLog[k].Killed=KillLog[k+1].Killed;
			KillLog[k].Frame=KillLog[k+1].Frame;
			KillLog[k].by=KillLog[k+1].by;
			KillLog[k].x=KillLog[k+1].x;
			KillLog[k].y=KillLog[k+1].y;
			KillLog[k].Nx=KillLog[k+1].Nx;
			KillLog[k].Ny=KillLog[k+1].Ny;
		}
	}
}