#include "DxLib.h"
#include "Direction.h"
#include "Player.h"
#include "Game.h"
#include "Font.h"
#include "Team.h"
#include "GraphHandle.h"
#include "Shader.h"
#include "main.h"
#include <math.h>

// So
void DeadDirection(void){

	// 擾
	FONT Font=GetFont();
	PC MainPlayer=GetPlayer(GetMainPlayerID());
	int GameFrame=GetGameFrame();

	// X|[JEg_E`
	if(MainPlayer.State==PS_DEAD){
		if(GameFrame-MainPlayer.Flag.LastDeadFrame>120){
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,(GameFrame-MainPlayer.Flag.LastDeadFrame-120)*255/60);
			DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"1");
		}else if(GameFrame-MainPlayer.Flag.LastDeadFrame>60){
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,(GameFrame-MainPlayer.Flag.LastDeadFrame-60)*255/60);
			DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"2");
		}else if(GameFrame-MainPlayer.Flag.LastDeadFrame>0){
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,(GameFrame-MainPlayer.Flag.LastDeadFrame-0)*255/60);
			DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"3");
		}
		SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
	}
}

// ʕ\o
void ResultDirection(void){

	// 擾
	TEAM *Team=GetAllTeam();
	PC *Pc=GetAllPlayer();
	FONT Font=GetFont();
	int GameFrame=GetGameFrame();
	int GameSelectedRule=GetGameSelectedRule();
	int GameFunctionStatus=GetGameFunctionStatus();
	
	// gtF[hC
	if(GameFrame<50){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,255.0-GameFrame*255.0/50.0);
		DrawBox(0,0,WINDOWWIDTH,WINDOWHEIGHT,GetColor(0,0,0),1);
		SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
	}

	// gtF[hAEg
	if(GameFrame>950){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(GameFrame-950.0)*255.0/50.0);
		DrawBox(0,0,WINDOWWIDTH,WINDOWHEIGHT,GetColor(0,0,0),1);
		SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
	}

	// ȉAΐ팋ʕ\
	double BoxAlpha,BoxFade;

	// xAtF[hlXV
	if(GameFrame<100) BoxAlpha=0.0;
	else if(GameFrame<125) BoxAlpha=(GameFrame-100.0)*8.0;
	else if(GameFrame<900) BoxAlpha=200.0;
	else if(GameFrame<925) BoxAlpha=(200.0-(GameFrame-900.0)*8.0);
	else BoxAlpha=0.0;
	if(GameFrame<100) BoxFade=-100.0;
	else if(GameFrame<112) BoxFade=-100.0+(GameFrame-100.0)*8.0;
	else if(GameFrame<930) BoxFade=0;
	else if(GameFrame<942) BoxFade=32.0+(GameFrame-700.0)*8.0;
	else BoxFade=100.0;

	SetDrawBlendMode(DX_BLENDMODE_ALPHA,BoxAlpha);
	DrawBox(50.0+BoxFade,30,WINDOWWIDTH-50.0+BoxFade,510,GetColor(0,0,0),1);
	SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);

	// ΐ탋[\
	int RuleAlpha = (GameFrame - 100)*2;
	if(GameSelectedRule==SR_TEAMDEATHMATCH){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha));
		DrawFormatStringToHandle(70+BoxFade,50,GetColor(255,255,255),Font.Rule,"TeamDeathMatch");
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha-30));
		DrawFormatStringToHandle(70+BoxFade,90,GetColor(255,255,255),Font.KeyConfig,"F`[75l|");

		// `[\
		if(Team[0].Win==1){
			DrawFormatStringToHandle(80+BoxFade,130,GetColor(255,255,64),Font.Status,"WON");
		}else{
			DrawFormatStringToHandle(480+BoxFade,130,GetColor(255,255,64),Font.Status,"WON");
		}

		// `[_\
		DrawBox(90+BoxFade,170,450+BoxFade,190,GetColor(255,64,64),1);
		DrawFormatStringToHandle(80+BoxFade,160,GetColor(255,255,255),Font.Status,"RED TEAM");
		DrawFormatStringToHandle(380+BoxFade,140,GetColor(255,255,255),Font.Rule,"%2d",Team[0].Point);
		DrawBox(490+BoxFade,170,850+BoxFade,190,GetColor(64,64,255),1);
		DrawFormatStringToHandle(480+BoxFade,160,GetColor(255,255,255),Font.Status,"BLUE TEAM");
		DrawFormatStringToHandle(780+BoxFade,140,GetColor(255,255,255),Font.Rule,"%2d",Team[1].Point);
		
	}

	// lѕ\
	int FIndex=0,EIndex=0;
	for(int i=0;i<PCNUM;i++){
		if(Pc[i].Team==0){
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha-10*i-50));
			DrawFormatStringToHandle(80+BoxFade,210+35*FIndex,GetColor(255,255,255),Font.KeyConfig,"%s",Pc[i].Name);
			DrawFormatStringToHandle(150+BoxFade,210+35*FIndex,GetColor(255,255,255),Font.KeyConfig,"Won:%2d  Lost:%2d  _:%6d",Pc[i].Kill,Pc[i].Death,Pc[i].Score);
			FIndex++;
		}else{
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha-10*i-50));
			DrawFormatStringToHandle(480+BoxFade,210+35*EIndex,GetColor(255,255,255),Font.KeyConfig,"%s",Pc[i].Name);
			DrawFormatStringToHandle(550+BoxFade,210+35*EIndex,GetColor(255,255,255),Font.KeyConfig,"Won:%2d  Lost:%2d  _:%6d",Pc[i].Kill,Pc[i].Death,Pc[i].Score);
			EIndex++;
		}
	}

	// 1000t[oߌAj[ɖ߂
	if(GameFrame==1000) UpdateGameFunctionStatus(FS_MENU);

	SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
}

// Q[Jn̉o
void GameDirection(void){

	// 擾
	TEAM *Team=GetAllTeam();
	PC *Pc=GetAllPlayer();
	FONT Font=GetFont();
	int GameFrame=GetGameFrame();
	int GameSelectedRule=GetGameSelectedRule();

	// VF[_K摜`
	DrawScreenGraphFromShader();

	// tF[hCo
	if(GameFrame<50){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,255.0-GameFrame*255.0/50.0);
		DrawBox(0,0,WINDOWWIDTH,WINDOWHEIGHT,GetColor(0,0,0),1);
		SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
	}

	// ȉAΐJ[h\
	double BoxAlpha,BoxFade;

	// xAtF[hlXV
	if(GameFrame<100) BoxAlpha=0.0;
	else if(GameFrame<125) BoxAlpha=(GameFrame-100.0)*8.0;
	else if(GameFrame<700) BoxAlpha=200.0f;
	else if(GameFrame<708) BoxAlpha=(200.0f-(GameFrame-700.0)*32.0);
	else BoxAlpha=0.0f;
	if(GameFrame<100) BoxFade=-100.0f;
	else if(GameFrame<108) BoxFade=-100.0+(GameFrame-100.0)*8.0;
	else if(GameFrame<700) BoxFade=-32.0+(GameFrame-110.0)*64.0/700.0;
	else if(GameFrame<708) BoxFade=32.0+(GameFrame-700.0)*8.0;
	else BoxFade=100.0f;

	// g`
	SetDrawBlendMode(DX_BLENDMODE_ALPHA,BoxAlpha);
	DrawBox(50.0f+BoxFade,30,710.0f+BoxFade,510,GetColor(0,0,0),1);
	SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);

	// ΐ탋[\
	int RuleAlpha = (GameFrame - 100)*2;
	if(GameSelectedRule==SR_TEAMDEATHMATCH){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha));
		DrawFormatStringToHandle(70+BoxFade,50,GetColor(255,255,255),Font.Rule,"TeamDeathMatch");
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha-30));
		DrawFormatStringToHandle(70+BoxFade,90,GetColor(255,255,255),Font.KeyConfig,"F`[75̓|");

		DrawBox(90+BoxFade,140,370+BoxFade,160,GetColor(255,64,64),1);
		DrawFormatStringToHandle(80+BoxFade,130,GetColor(255,255,255),Font.Status,"RED TEAM");
		DrawBox(410+BoxFade,140,690+BoxFade,160,GetColor(64,64,255),1);
		DrawFormatStringToHandle(400+BoxFade,130,GetColor(255,255,255),Font.Status,"BLUE TEAM");
		
	}

	// L\
	int FIndex=0,EIndex=0;
	for(int i=0;i<PCNUM;i++){
		if(Pc[i].Team==0){
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha-10*i-50));
			DrawFormatStringToHandle(80+BoxFade,180+40*FIndex,GetColor(255,255,255),Font.KeyConfig,"%s",Pc[i].Name);
			FIndex++;
		}else{
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha-10*i-50));
			DrawFormatStringToHandle(400+BoxFade,180+40*EIndex,GetColor(255,255,255),Font.KeyConfig,"%s",Pc[i].Name);
			EIndex++;
		}
	}

	// 5JEg_E
	if(GameFrame>1000);
	else if(GameFrame>940){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(GameFrame-940)*255/60);
		DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"1");
	}else if(GameFrame>880){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(GameFrame-880)*255/60);
		DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"2");
	}else if(GameFrame>820){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(GameFrame-820)*255/60);
		DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"3");
	}else if(GameFrame>760){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(GameFrame-760)*255/60);
		DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"4");
	}else if(GameFrame>700){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(GameFrame-700)*255/60);
		DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"5");
	}

	// `[̓_{[h̃tF[hC
	if(GameFrame>1000);
	else if(GameFrame>940){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(GameFrame-940)*255/120);
		DrawBox(250,0,520,50,GetColor(0,0,0),1);
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(GameFrame-940)*255/60);
		DrawFormatStringToHandle(270,10,GetColor(255,255,255),Font.Status,"RED: %2d - %2d :BLUE",Team[0].Point,Team[1].Point);
		}

	SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
}