#include "main.h"
#include "Game.h"
#include "Player.h"
#include "KillLog.h"
#include "Num.h"
#include "Font.h"
#include "DxLib.h"

// \̎̒`
static KILLLOG KillLog[KILLLOGMAX+1];

// LO
void UpdateKillLog(void){
	int Num=GetNumCount(NUM_KILLLOG);

	for(int i=0;i<Num;i++){
		KillLog[i].Nx=10;
		KillLog[i].Ny=400+28*i;

		if(KillLog[i].y>KillLog[i].Ny) KillLog[i].y-=4;
	}
}

// LOo^
void KillLogRegist(int KillID, int KilledID, int Killedby){
	int Num=GetNumCount(NUM_KILLLOG);
	int GameFrame=GetGameFrame();

	KillLog[Num].Kill=KillID;
	KillLog[Num].Killed=KilledID;
	KillLog[Num].Frame=GameFrame;
	KillLog[Num].by=Killedby;
	KillLog[Num].x=10;
	KillLog[Num].y=400+28*(Num+1);

	// LȌɒBĂȂ
	if(Num<KILLLOGMAX) NumCountUp(NUM_KILLLOG);

	// BĂ
	else{

		// Â̂㏑
		for(int k=0;k<Num;k++){
			KillLog[k].Kill=KillLog[k+1].Kill;
			KillLog[k].Killed=KillLog[k+1].Killed;
			KillLog[k].Frame=KillLog[k+1].Frame;
			KillLog[k].by=KillLog[k+1].by;
			KillLog[k].x=KillLog[k+1].x;
			KillLog[k].y=KillLog[k+1].y;
			KillLog[k].Nx=KillLog[k+1].Nx;
			KillLog[k].Ny=KillLog[k+1].Ny;
		}
	}
}

// LOo^
void KillLogUnregistAsNecessary(void){
	int Num=GetNumCount(NUM_KILLLOG);
	int GameFrame=GetGameFrame();

	if(KillLog[0].Frame+300==GameFrame){
		for(int k=0;k<Num-1;k++) KillLog[k]=KillLog[k+1];
		NumCountDown(NUM_KILLLOG);
	}
}

// LO̕`
void DrawKillLog(void){
	int LogWidth,Alpha;

	// 擾
	int Num=GetNumCount(NUM_KILLLOG);
	int GameFrame=GetGameFrame();
	PC *Pc=GetAllPlayer();
	int PlayerID=GetMainPlayerID();
	FONT Font=GetFont();

	// LO̕`
	for(int i=0;i<Num;i++){
		LogWidth=0;

		// xݒ
		if(GameFrame-KillLog[i].Frame<268) Alpha=(GameFrame-KillLog[i].Frame)*8;
		else Alpha=(32-(GameFrame-KillLog[i].Frame-268))*8;
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,Alpha);

		// łł͂Ȃ
		if(KillLog[i].Kill!=-1){

			// |L̕`
			if(Pc[KillLog[i].Kill].Team==Pc[PlayerID].Team) DrawFormatStringToHandle(KillLog[i].x,KillLog[i].y,GetColor(255,64,64),Font.KeyConfig,"%s",Pc[KillLog[i].Kill].Name);
			else DrawFormatStringToHandle(KillLog[i].x+LogWidth,KillLog[i].y,GetColor(64,64,255),Font.KeyConfig,"%s",Pc[KillLog[i].Kill].Name);
			LogWidth+=GetDrawFormatStringWidthToHandle(Font.KeyConfig,"%s",Pc[KillLog[i].Kill].Name);

			// ʏUȂ
			if(KillLog[i].by==KL_DEFAULT){
				DrawFormatStringToHandle(KillLog[i].x+LogWidth,KillLog[i].y,GetColor(255,255,255),Font.KeyConfig," [ʏU] ");
				LogWidth+=GetDrawFormatStringWidthToHandle(Font.KeyConfig," [ʏU] ");

			// }X^[Xp[NȂ
			}else if(KillLog[i].by==KL_MASTERSPARK){
				DrawFormatStringToHandle(KillLog[i].x+LogWidth,KillLog[i].y,GetColor(255,255,255),Font.KeyConfig," [}X^[Xp[N] ");
				LogWidth+=GetDrawFormatStringWidthToHandle(Font.KeyConfig," [}X^[Xp[N] ");

			// ȊOȂ
			}else{
				DrawFormatStringToHandle(KillLog[i].x+LogWidth,KillLog[i].y,GetColor(255,255,255),Font.KeyConfig," [_ufBNVi[U[] ");
				LogWidth+=GetDrawFormatStringWidthToHandle(Font.KeyConfig," [_ufBNVi[U[] ");
			}

		// ł̎
		}else{
			DrawFormatStringToHandle(KillLog[i].x+LogWidth,KillLog[i].y,GetColor(255,255,255),Font.KeyConfig,"[] ");
			LogWidth+=GetDrawFormatStringWidthToHandle(Font.KeyConfig,"[] ");
		}

		// |ꂽL̕`
		if(Pc[KillLog[i].Killed].Team==0) DrawFormatStringToHandle(KillLog[i].x+LogWidth,KillLog[i].y,GetColor(255,64,64),Font.KeyConfig,"%s",Pc[KillLog[i].Killed].Name);
		else DrawFormatStringToHandle(KillLog[i].x+LogWidth,KillLog[i].y,GetColor(64,64,255),Font.KeyConfig,"%s",Pc[KillLog[i].Killed].Name);
		SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
	}
}