#include "main.h"
#include "Map.h"
#include "Game.h"
#include "Player.h"
#include "DxLib.h"

// \̎̒`
static MAP Map[MAPNUM];

// }bṽf[h
void LoadMapModel(void){
	char MapModel[MAPNUM][2][33]={{"Model/sky_test3.mqo","Model/kirisameShop/marisaHouse.x"}};

	for(int i=0;i<MAPNUM;i++){
		Map[i].SkyHandle=MV1LoadModel(MapModel[i][0]);
		Map[i].MapHandle=MV1LoadModel(MapModel[i][1]);
		MV1SetScale(Map[i].MapHandle,VGet(1000,1000,1000));
		MV1SetPosition(Map[i].MapHandle,VGet(0,-STAGESIZE/2,0));
		Map[i].GroundHandle=Map[i].MapHandle;
	}
}

// }bv`
void DrawMap(void){
	int GameSelectMap=GetGameSelectMap();

	// WCg̕
	SetLightDirection(VGet(0.29f,-0.58f,-0.58f));

	// V`
	MV1SetPosition(Map[GameSelectMap].SkyHandle,VGet(0,-STAGESIZE/2,0));
	MV1SetScale(Map[GameSelectMap].SkyHandle,VGet(20.0f,20.0f,20.0f));
	MV1DrawModel(Map[GameSelectMap].SkyHandle);

	// Xe[W`
	MV1DrawModel(Map[GameSelectMap].MapHandle);

	// Xe[W͈͋`
	DrawLine3D(VGet(-STAGESIZE/2,-STAGESIZE/2,-STAGESIZE/2),VGet(STAGESIZE/2,-STAGESIZE/2,-STAGESIZE/2),GetColor(255,255,255));
	DrawLine3D(VGet(-STAGESIZE/2,STAGESIZE/2,-STAGESIZE/2),VGet(STAGESIZE/2,STAGESIZE/2,-STAGESIZE/2),GetColor(255,255,255));
	DrawLine3D(VGet(-STAGESIZE/2,STAGESIZE/2,STAGESIZE/2),VGet(STAGESIZE/2,STAGESIZE/2,STAGESIZE/2),GetColor(255,255,255));
	DrawLine3D(VGet(-STAGESIZE/2,-STAGESIZE/2,STAGESIZE/2),VGet(STAGESIZE/2,-STAGESIZE/2,STAGESIZE/2),GetColor(255,255,255));
	DrawLine3D(VGet(-STAGESIZE/2,-STAGESIZE/2,-STAGESIZE/2),VGet(-STAGESIZE/2,STAGESIZE/2,-STAGESIZE/2),GetColor(255,255,255));
	DrawLine3D(VGet(STAGESIZE/2,-STAGESIZE/2,-STAGESIZE/2),VGet(STAGESIZE/2,STAGESIZE/2,-STAGESIZE/2),GetColor(255,255,255));
	DrawLine3D(VGet(STAGESIZE/2,-STAGESIZE/2,STAGESIZE/2),VGet(STAGESIZE/2,STAGESIZE/2,STAGESIZE/2),GetColor(255,255,255));
	DrawLine3D(VGet(-STAGESIZE/2,-STAGESIZE/2,STAGESIZE/2),VGet(-STAGESIZE/2,STAGESIZE/2,STAGESIZE/2),GetColor(255,255,255));
	DrawLine3D(VGet(-STAGESIZE/2,-STAGESIZE/2,-STAGESIZE/2),VGet(-STAGESIZE/2,-STAGESIZE/2,STAGESIZE/2),GetColor(255,255,255));
	DrawLine3D(VGet(STAGESIZE/2,-STAGESIZE/2,-STAGESIZE/2),VGet(STAGESIZE/2,-STAGESIZE/2,STAGESIZE/2),GetColor(255,255,255));
	DrawLine3D(VGet(STAGESIZE/2,STAGESIZE/2,-STAGESIZE/2),VGet(STAGESIZE/2,STAGESIZE/2,STAGESIZE/2),GetColor(255,255,255));
	DrawLine3D(VGet(-STAGESIZE/2,STAGESIZE/2,-STAGESIZE/2),VGet(-STAGESIZE/2,STAGESIZE/2,STAGESIZE/2),GetColor(255,255,255));
}

// Xe[WM~bN
void StageGimmick(void){

	// vC̈Oɏȍ
	PlayerOutArea();
}