#include <stdio.h>
#include <string.h>
#include <math.h>
#include "main.h"
#include "Player.h"
#include "Camera.h"
#include "Bullet.h"
#include "Game.h"
#include "Team.h"
#include "Font.h"
#include "KeyPadInput.h"
#include "KillLog.h"
#include "GraphHandle.h"
#include "KillLog.h"
#include "DxLib.h"

// \̎̒`
static PC Pc[PCNUM];

// t@CXR[vϐ`
static int PlayerID;

// QƗp
int GetMainPlayerID(void){ return PlayerID; } // CvCID擾
PC* GetAllPlayer(void){return Pc; } // SvC̏擾
PC GetPlayer(int ID){return Pc[ID]; } // w肵vC̏擾
VECTOR GetPlayerPos(int ID){ return Pc[ID].Pos; } // w肵vC̈ʒu擾
ROT GetPlayerRot(int ID){ return Pc[ID].Rot; } // w肵vC̊px擾
float GetPlayerPower(int ID){ return Pc[ID].Power; } // w肵vC̎ˌ͂擾

// LN^̏
void PlayerInit(void){
	HANDLES* CharacterModelHandle=GetCharacterModelHandle(); 

	// vCL
	PlayerID=0;

	// Q[ɑ݂邷ׂẴLɑ΂
	for(int i=0;i<PCNUM;i++){

		// fnhɂĂ
		MV1DeleteModel(Pc[i].Handle.Model);

		// l삵Ă̂CPU삵Ă̂
		if(i==PlayerID) Pc[i].Control=CC_MAINPLAYER; else Pc[i].Control=CC_COMPUTER;

		// f̑I
		if(Pc[i].Control==CC_MAINPLAYER) Pc[i].ModelID=GetGameSelectedCharacter(); else Pc[i].ModelID=SCR_MARISA;

		// f̓ǂݍ
		Pc[i].Handle.Model=MV1DuplicateModel(CharacterModelHandle[Pc[i].ModelID].Model);

		// 傫AobNJOAAj[VA^b`A蔻̐ݒ
		if(Pc[i].ModelID==SCR_MARISA){
			MV1SetScale(Pc[i].Handle.Model,VGet(5.0f,5.0f,5.0f));
			int MaterialNum = MV1GetMaterialNum(Pc[i].Handle.Model);
			for(int j=0;j<MaterialNum;j++){
				float DotWidth = MV1GetMaterialOutLineDotWidth(Pc[i].Handle.Model,j);  
			    MV1SetMaterialOutLineDotWidth(Pc[i].Handle.Model,j,DotWidth/50.0f);
				MV1SetMeshBackCulling(Pc[i].Handle.Model,j,FALSE);
			}
		}
		Pc[i].Handle.Attach=MV1AttachAnim(Pc[i].Handle.Model,AN_STAND);
		Pc[i].Handle.Anitime=0;
		MV1SetUseZBuffer(Pc[i].Handle.Model, true);
		MV1SetWriteZBuffer(Pc[i].Handle.Model, true);
		int FrameIndex=-1,XDivNum=10,YDivNum=30,ZDivNum=10;
		MV1SetupCollInfo(Pc[i].Handle.Model,FrameIndex,XDivNum,YDivNum,ZDivNum);
	
		// W
		Pc[i].Pos.x=GetRand(30000)/10.0f-1500.0f;
		Pc[i].Pos.y=GetRand(10000)/10.0f-500.0f;
		Pc[i].Pos.z=GetRand(30000)/10.0f-1500.0f;
		Pc[i].PPos=Pc[i].Pos;
		
		// 
		Pc[i].Rot.v=-atan2(-Pc[i].Pos.y,hypotf(-Pc[i].Pos.z,-Pc[i].Pos.x));
		Pc[i].Rot.h=atan2(-Pc[i].Pos.x,-Pc[i].Pos.z);
		Pc[i].Rot.t=0.0f;
		Pc[i].RotTar=Pc[i].Rot;

		// ]Eړx
		Pc[i].Spd.v=0.0f;
		Pc[i].Spd.h=0.0f;
		Pc[i].Spd.t=0.0f;

		//߂GIDC̍ŒZƊpx
		Pc[i].NearEne[0]=NOTSELECTED;
		Pc[i].NearEne[1]=NOTSELECTED;
		Pc[i].DisEne=10000.0f;
		Pc[i].RotEne.v=0.0f;
		Pc[i].RotEne.h=0.0f;
		Pc[i].RotEne.t=0.0f;

		// Xe[^X
		Pc[i].Life=LIFEMAX;
		Pc[i].MaxLife=LIFEMAX;
		Pc[i].Damage=0;
		Pc[i].Recovery=0;
		Pc[i].Kill=0;
		Pc[i].Death=0;
		Pc[i].Graze=0;
		Pc[i].Power=1.0f;
		Pc[i].Bomb=1.0f;
		Pc[i].Team=i%2;
		Pc[i].State=PS_FINE;
		Pc[i].ScoreTar=0;
		Pc[i].Score=0;

		// {AXL
		Pc[i].SetBomb.Selected=BM_MASTERSPARK;
		Pc[i].SetBomb.State=SS_AVAILABLE;
		for(int j=0;j<4;j++){
			Pc[i].Skill[j].Selected=NOTSELECTED;
			Pc[i].Skill[j].State=SS_UNAVAILABLE;
		}
		Pc[i].Skill[0].Selected=SK_DOUBLEDIRECTIONALLAZER;
		Pc[i].Skill[0].State=SS_AVAILABLE;

		// CPUpϐ
		Pc[i].MMInterval=120;
		Pc[i].Move.x=0.0f;
		Pc[i].Move.y=0.0f;
		Pc[i].Move.z=0.0f;

		// FlagW
		Pc[i].Flag.TargetMode=AIM_FREE;
		Pc[i].Flag.Target=NOTSELECTED;
		Pc[i].Flag.TargetModeFrame=-1000;
		Pc[i].Flag.LastDamageFrame=-1000;
		Pc[i].Flag.LastShotFrame=-1000;
		Pc[i].Flag.LastMoveFrame=-1000;
		Pc[i].Flag.LastAttachFrame=-1000;
		Pc[i].Flag.LastMoveDecideFrame=-1000;
	}
	// O
	for(int i=0;i<PCNUM;i++){
		if(i==PlayerID) strcpy_s(Pc[i].Name,"p");
		else if(Pc[i].Team==Pc[PlayerID].Team) strcpy_s(Pc[i].Name,"F");
		else strcpy_s(Pc[i].Name,"E");
	}
}

// vC[̑
void MainPlayerControl(void){
	int ID=PlayerID;

	// ͏̎擾
	KEYCON KeyCon=GetKeyCon();
	KEYCON PadCon=GetPadCon();
	DINPUT_JOYSTATE PadState=GetPadState();

	// SZĂ鎞͈ȉ̂ƂłȂ
	if(Pc[ID].State==PS_DEADLY||Pc[ID].State==PS_DEAD||Pc[ID].State==PS_SATTACK) return;
		
	// Free[hȂ
	if(Pc[ID].Flag.TargetMode==AIM_FREE){

		// L̎Oړ
		if(PadCon.Down==18&&PadState.Y>0) Pc[ID].Spd.t=-PadState.Y/100.0f; 
		else{ if(KeyOrPad(CF_DOWN)) Pc[ID].Spd.t--; else if(Pc[ID].Spd.t<0) Pc[ID].Spd.t++; }
		
		// L̉ړ
		if(PadCon.Up==19&&PadState.Y<0) Pc[ID].Spd.t=-PadState.Y/100.0f;
		else{ if(KeyOrPad(CF_UP)) Pc[ID].Spd.t++; else if(Pc[ID].Spd.t>0) Pc[ID].Spd.t--; }
		
		// L̉Eړ
		if(PadCon.Right==16&&PadState.X>0) Pc[ID].Spd.h=PadState.X/100.0f; 
		else{ if(KeyOrPad(CF_RIGHT)) Pc[ID].Spd.h++; else if(Pc[ID].Spd.h>0) Pc[ID].Spd.h--; }
		
		// L̍ړ
		if(PadCon.Left==17&&PadState.X<0) Pc[ID].Spd.h=PadState.X/100.0f;
		else{ if(KeyOrPad(CF_LEFT)) Pc[ID].Spd.h--; else if(Pc[ID].Spd.h<0) Pc[ID].Spd.h++; }

	// Target[hȂ
	}else{

		// L̉ړ
		if(PadCon.Down==18&&PadState.Y>0) Pc[ID].Spd.v=PadState.Y/100.0f;
		else{ if(KeyOrPad(CF_DOWN)) Pc[ID].Spd.v++; else if(Pc[ID].Spd.v>0) Pc[ID].Spd.v--; }
		
		// L̏ړ
		if(PadCon.Up==19&&PadState.Y<0) Pc[ID].Spd.v=PadState.Y/100.0f;
		else{ if(KeyOrPad(CF_UP)) Pc[ID].Spd.v--; else if(Pc[ID].Spd.v<0) Pc[ID].Spd.v++; }
		
		// L̉Eړ
		if(PadCon.Right==16&&PadState.X>0) Pc[ID].Spd.h=-PadState.X/100.0f;
		else{ if(KeyOrPad(CF_RIGHT)) Pc[ID].Spd.h--; else if(Pc[ID].Spd.h<0) Pc[ID].Spd.h++; }
		
		// L̍ړ
		if(PadCon.Left==17&&PadState.X<0) Pc[ID].Spd.h=-PadState.X/100.0f;
		else{ if(KeyOrPad(CF_LEFT)) Pc[ID].Spd.h++; else if(Pc[ID].Spd.h>0) Pc[ID].Spd.h--; }
	}

	// ˌ[h؂ւ
	if(KeyOrPad(CF_SHOTMODESELECT)==1){
		Pc[ID].Flag.TargetMode=1-Pc[ID].Flag.TargetMode;
		Pc[ID].Flag.TargetModeFrame=GetGameFrame();
	}

	// ˌ
	if(KeyOrPad(CF_SHOT)){
		ShotRegist(ID);
		Pc[ID].Flag.LastShotFrame=GetGameFrame();
	}

	// XLgp
	if(KeyOrPad(CF_SKILL1)) SkillRegist(ID,0);

	// {gp
	if(KeyOrPad(CF_BOMB)==1&&Pc[ID].Bomb>=1) BombRegist(ID);
}

// CPȖ
void CpuControl(void){

	// Q[擾
	int GameFrame=GetGameFrame();

	for(int ID=0;ID<PCNUM;ID++){
		if(Pc[ID].Control!=CC_COMPUTER) continue;

		// ʎƓU͓Ȃ
		if(Pc[ID].State==PS_DEADLY||Pc[ID].State==PS_DEAD||Pc[ID].State==PS_SATTACK) return;

		// LN^ړ
		// CPŨ_ړ
		if(GameFrame-Pc[ID].Flag.LastMoveDecideFrame>Pc[ID].MMInterval||GameFrame==0){
			Pc[ID].Flag.LastMoveDecideFrame=GameFrame;
			if(Pc[ID].Pos.x<-STAGESIZE/3) Pc[ID].Move.x=GetRand(300)/100.0f;
			else if(Pc[ID].Pos.x>STAGESIZE/3) Pc[ID].Move.x=-GetRand(300)/100.0f;
			else Pc[ID].Move.x=GetRand(600)/100.0f-3.0f;

			if(Pc[ID].Pos.y<-STAGESIZE/3) Pc[ID].Move.y=GetRand(300)/100.0f;
			else if(Pc[ID].Pos.y>STAGESIZE/3) Pc[ID].Move.y=-GetRand(300)/100.0f;
			else Pc[ID].Move.y=GetRand(600)/100.0f-3.0f;

			if(Pc[ID].Pos.z<-STAGESIZE/3) Pc[ID].Move.z=GetRand(300)/100.0f;
			else if(Pc[ID].Pos.z>STAGESIZE/3) Pc[ID].Move.z=-GetRand(300)/100.0f;
			else Pc[ID].Move.z=GetRand(600)/100.0f-3.0f;
		}

		// ˌ
		if(Pc[ID].Flag.Target!=NOTSELECTED){
			ShotRegist(ID);
			Pc[ID].Flag.LastShotFrame=GameFrame;
		}

		// {gp
		if(GetRand(2000)==1&&Pc[ID].Bomb>=1.0f&&Pc[ID].Flag.Target!=NOTSELECTED) BombRegist(ID);

		// XLgp
		if(GetRand(200)==1) SkillRegist(ID,0);
	}
}

// vC[ړ
void MainPlayerMove(void){
	int ID=PlayerID;

	// J̊px擾
	ROT CameraRot=GetCameraRot();
	
	// Q[擾
	int GameFrame=GetGameFrame();
	int GameFunctionStatus=GetGameFunctionStatus();
	int GameSelectedMenu=GetGameSelectedMenu();


	// ݈ʒuۑ
	Pc[ID].PPos=Pc[ID].Pos;
	Pc[ID].NPos=Pc[ID].Pos;
	
	// Ȃ͎SZgp
	if(Pc[ID].State==PS_DEADLY||Pc[ID].State==PS_DEAD) goto A;
	if(Pc[ID].State==PS_SATTACK) goto B;
		
	// FreeModeȂ
	if(Pc[ID].Flag.TargetMode==AIM_FREE){

		// xől̒ߑj~
		if(Pc[ID].Spd.h>P_MAXSPEED) Pc[ID].Spd.h=P_MAXSPEED;
		if(Pc[ID].Spd.t>P_MAXSPEED) Pc[ID].Spd.t=P_MAXSPEED;
		if(Pc[ID].Spd.h<-P_MAXSPEED) Pc[ID].Spd.h=-P_MAXSPEED;
		if(Pc[ID].Spd.t<-P_MAXSPEED) Pc[ID].Spd.t=-P_MAXSPEED;
		
		// J̌lʒuݒ
		if(KeyOrPad(CF_LEFT)||KeyOrPad(CF_RIGHT)){
			Pc[ID].NPos.x+=Pc[ID].Spd.h*sin(CameraRot.h+DX_PI/2.0f);
			Pc[ID].NPos.z+=Pc[ID].Spd.h*cos(CameraRot.h+DX_PI/2.0f);
		}
		if(KeyOrPad(CF_UP)||KeyOrPad(CF_DOWN)){
			Pc[ID].NPos.x+=Pc[ID].Spd.t*sin(CameraRot.h);
			Pc[ID].NPos.y+=Pc[ID].Spd.t*cos(CameraRot.v+1.0f/2.0f*DX_PI);
			Pc[ID].NPos.z+=Pc[ID].Spd.t*cos(CameraRot.h);
		}

	// TargetModeȂ
	}else{
	
		// xől̒ߑj~
		if(Pc[ID].Spd.h>P_MAXSPEED) Pc[ID].Spd.h=P_MAXSPEED;
		if(Pc[ID].Spd.v>P_MAXSPEED) Pc[ID].Spd.v=P_MAXSPEED;
		if(Pc[ID].Spd.h<-P_MAXSPEED) Pc[ID].Spd.h=-P_MAXSPEED;
		if(Pc[ID].Spd.v<-P_MAXSPEED) Pc[ID].Spd.v=-P_MAXSPEED;
			
		// pxւ̔f
		Pc[ID].RotEne.h+=(1.0f/2.0f)*DX_PI*Pc[ID].Spd.h/Pc[ID].DisEne;
		Pc[ID].RotEne.v-=(1.0f/2.0f)*DX_PI*Pc[ID].Spd.v/Pc[ID].DisEne;
				
		// ^[Qbg̈ʒulʒuݒ
		Pc[ID].NPos.x=Pc[Pc[ID].Flag.Target].Pos.x-(Pc[ID].DisEne*sin(Pc[ID].RotEne.v+1.0f/2.0f*DX_PI)*cos(1.0f/2.0f*DX_PI-Pc[ID].RotEne.h));
		Pc[ID].NPos.z=Pc[Pc[ID].Flag.Target].Pos.z-(Pc[ID].DisEne*sin(Pc[ID].RotEne.v+1.0f/2.0f*DX_PI)*sin(1.0f/2.0f*DX_PI-Pc[ID].RotEne.h));
		Pc[ID].NPos.y=Pc[Pc[ID].Flag.Target].Pos.y-(Pc[ID].DisEne*cos(Pc[ID].RotEne.v+1.0f/2.0f*DX_PI));
	}

	// tO̐ݒ
	if(sqrt(pow(Pc[ID].NPos.x-Pc[ID].Pos.x,2)+
			pow(Pc[ID].NPos.y-Pc[ID].Pos.y,2)+
			pow(Pc[ID].NPos.z-Pc[ID].Pos.z,2))>=0.1f) Pc[ID].Flag.LastMoveFrame=GameFrame;

	// pxւ̔f
	B:
	if(Pc[ID].State==PS_SATTACK){
		Pc[ID].RotTar.h=Pc[ID].SARot.h;
		Pc[ID].RotTar.v=Pc[ID].SARot.v;
	}else if(Pc[ID].Flag.TargetMode==AIM_FREE&&GameFrame-Pc[ID].Flag.LastShotFrame<60){
		Pc[ID].RotTar.h=CameraRot.h;
		Pc[ID].RotTar.v=CameraRot.v;
	}else if(Pc[ID].Flag.TargetMode==AIM_FREE&&Pc[ID].Flag.LastMoveFrame==GameFrame&&GameFrame-Pc[ID].Flag.LastShotFrame>=60){
		Pc[ID].RotTar.h=atan2(Pc[ID].NPos.x-Pc[ID].Pos.x,(Pc[ID].NPos.z-Pc[ID].Pos.z));
		Pc[ID].RotTar.v=-atan2(Pc[ID].NPos.y-Pc[ID].Pos.y,hypotf(Pc[ID].NPos.x-Pc[ID].Pos.x,Pc[ID].NPos.z-Pc[ID].Pos.z));
	}else{
		Pc[ID].RotTar.h=Pc[ID].RotEne.h;
		Pc[ID].RotTar.v=Pc[ID].RotEne.v;
	}

	// S̉o
	A:
	if(GameFunctionStatus==FS_PLAY&&Pc[ID].State==PS_DEAD){
		if(GameFrame-Pc[ID].Flag.LastDeadFrame==1){
			int r=GetRand(6);
			Pc[ID].Spd.h=sin((double)r)*10;
			Pc[ID].Spd.v=8;
			Pc[ID].Spd.t=cos((double)r)*10;
		}else if(GameFrame-Pc[ID].Flag.LastDeadFrame>=1){
			Pc[ID].Spd.v-=0.15;
			Pc[ID].RotTar.h=atan2(Pc[ID].Spd.h,Pc[ID].Spd.t);
			Pc[ID].RotTar.v=-atan2(Pc[ID].Spd.v,hypotf(Pc[ID].Spd.h,Pc[ID].Spd.t))+1.0/2.0*DX_PI;
			Pc[ID].NPos.x+=Pc[ID].Spd.h;
			Pc[ID].NPos.y+=Pc[ID].Spd.v;
			Pc[ID].NPos.z+=Pc[ID].Spd.t;
		}
	}

	// }bvI
	if(GameSelectedMenu==SM_MAP&&GameFunctionStatus==FS_MENU){
		Pc[PlayerID].Pos.y=-2000;
		Pc[PlayerID].Pos.x=0;
		Pc[PlayerID].Pos.z=0;
		Pc[PlayerID].Flag.TargetMode=0;
	}

	// őp̒ߖh~
	if(Pc[ID].State!=PS_DEAD){
		if(Pc[ID].RotTar.v-(1.0f/2.0f)*DX_PI*Pc[ID].Spd.v/100.0f<=-1.4f) Pc[ID].RotTar.v=-1.4f;
		if(Pc[ID].RotTar.v-(1.0f/2.0f)*DX_PI*Pc[ID].Spd.v/100.0f>=1.4f) Pc[ID].RotTar.v=1.4f;
	}
	if(Pc[ID].Rot.h>2.0f*DX_PI) Pc[ID].Rot.h-=2.0f*DX_PI;
	if(Pc[ID].Rot.h<0.0f) Pc[ID].Rot.h+=2.0f*DX_PI;
	if(Pc[ID].RotTar.h>2.0f*DX_PI) Pc[ID].RotTar.h-=2.0f*DX_PI;
	if(Pc[ID].RotTar.h<0.0f) Pc[ID].RotTar.h+=2.0f*DX_PI;
	if(Pc[ID].RotEne.h>2.0f*DX_PI) Pc[ID].RotEne.h-=2.0f*DX_PI;
	if(Pc[ID].RotEne.h<0.0f) Pc[ID].RotEne.h+=2.0f*DX_PI;

	// pxڕWlɋ߂Â
	if(Pc[ID].RotTar.h-Pc[ID].Rot.h>DX_PI) Pc[ID].Rot.h-=0.2f;
	else if(Pc[ID].RotTar.h-Pc[ID].Rot.h>0.1f) Pc[ID].Rot.h+=0.2f;
	else if(Pc[ID].RotTar.h-Pc[ID].Rot.h>-0.1f) Pc[ID].Rot.h=Pc[ID].RotTar.h; 
	else if(Pc[ID].RotTar.h-Pc[ID].Rot.h>-DX_PI) Pc[ID].Rot.h-=0.2f;
	else Pc[ID].Rot.h+=0.2f;
	if(sqrt(pow(Pc[ID].Rot.v-Pc[ID].RotTar.v,2))<=0.1f) Pc[ID].Rot.v=Pc[ID].RotTar.v; else if(Pc[ID].Rot.v<Pc[ID].RotTar.v) Pc[ID].Rot.v+=0.1f; else if(Pc[ID].Rot.v>Pc[ID].RotTar.v) Pc[ID].Rot.v-=0.1f;
	if(sqrt(pow(Pc[ID].Rot.t-Pc[ID].RotTar.t,2))<=0.1f) Pc[ID].Rot.t=Pc[ID].RotTar.t; else if(Pc[ID].Rot.t<Pc[ID].RotTar.t) Pc[ID].Rot.t+=0.1f; else if(Pc[ID].Rot.t>Pc[ID].RotTar.t) Pc[ID].Rot.t-=0.1f;

	// ʒuf
	Pc[ID].Pos=Pc[ID].NPos;
}

// CPUړ
void CpuMove(void){
	
	// Q[擾
	int GameFrame=GetGameFrame();
	int GameFunctionStatus=GetGameFunctionStatus();

	for(int i=0;i<PCNUM;i++){
		if(Pc[i].Control!=CC_COMPUTER) continue;

		// ݈ʒuۑ
		Pc[i].PPos=Pc[i].Pos;
		Pc[i].NPos=Pc[i].Pos;
	
		// Ȃ͎SZgp
		if(Pc[i].State==PS_DEADLY||Pc[i].State==PS_DEAD) goto A;
		if(Pc[i].State==PS_SATTACK) goto B;

		// CPUړ
		Pc[i].NPos.x=Pc[i].Pos.x+Pc[i].Move.x;
		Pc[i].NPos.y=Pc[i].Pos.y+Pc[i].Move.y;
		Pc[i].NPos.z=Pc[i].Pos.z+Pc[i].Move.z;

		// tO̐ݒ
		if(sqrt(pow(Pc[i].NPos.x-Pc[i].Pos.x,2)+
				pow(Pc[i].NPos.y-Pc[i].Pos.y,2)+
				pow(Pc[i].NPos.z-Pc[i].Pos.z,2))>=0.1f) Pc[i].Flag.LastMoveFrame=GameFrame;

		// Ľ
		B:
		if(Pc[i].State==PS_SATTACK){
			Pc[i].RotTar.h=Pc[i].SARot.h;
			Pc[i].RotTar.v=Pc[i].SARot.v;
		}else{
			Pc[i].RotTar.h=Pc[i].RotEne.h;
			Pc[i].RotTar.v=Pc[i].RotEne.v;
		}

		// S̉o
		A:
		if(GameFunctionStatus==FS_PLAY&&Pc[i].State==PS_DEAD){
			if(GameFrame-Pc[i].Flag.LastDeadFrame==1){
				int r=GetRand(6);
				Pc[i].Spd.h=sin((double)r)*10;
				Pc[i].Spd.v=8;
				Pc[i].Spd.t=cos((double)r)*10;
			}else if(GameFrame-Pc[i].Flag.LastDeadFrame>=1){
				Pc[i].Spd.v-=0.15;
				Pc[i].RotTar.h=atan2(Pc[i].Spd.h,Pc[i].Spd.t);
				Pc[i].RotTar.v=-atan2(Pc[i].Spd.v,hypotf(Pc[i].Spd.h,Pc[i].Spd.t))+1.0/2.0*DX_PI;
				Pc[i].NPos.x+=Pc[i].Spd.h;
				Pc[i].NPos.y+=Pc[i].Spd.v;
				Pc[i].NPos.z+=Pc[i].Spd.t;
			}
		}


		// őp̒ߖh~
		if(Pc[i].State!=PS_DEAD){
			if(Pc[i].RotTar.v-(1.0f/2.0f)*DX_PI*(double)Pc[i].Spd.v/100.0f<=-1.4f) Pc[i].RotTar.v=-1.4f;
			if(1.4f<=Pc[i].RotTar.v-(1.0f/2.0f)*DX_PI*(double)Pc[i].Spd.v/100.0f) Pc[i].RotTar.v=1.4f;
		}
		if(Pc[i].Rot.h>2.0f*DX_PI) Pc[i].Rot.h-=2.0f*DX_PI;
		if(Pc[i].Rot.h<0) Pc[i].Rot.h+=2.0f*DX_PI;
		if(Pc[i].RotTar.h>2.0f*DX_PI) Pc[i].RotTar.h-=2.0f*DX_PI;
		if(Pc[i].RotTar.h<0) Pc[i].RotTar.h+=2.0f*DX_PI;
		if(Pc[i].RotEne.h>2.0f*DX_PI) Pc[i].RotEne.h-=2.0f*DX_PI;
		if(Pc[i].RotEne.h<0) Pc[i].RotEne.h+=2.0f*DX_PI;

		// pxڕWlɋ߂Â
		if(Pc[i].RotTar.h-Pc[i].Rot.h>DX_PI) Pc[i].Rot.h-=0.2f;
		else if(Pc[i].RotTar.h-Pc[i].Rot.h>0.1f) Pc[i].Rot.h+=0.2f;
		else if(Pc[i].RotTar.h-Pc[i].Rot.h>-0.1f) Pc[i].Rot.h=Pc[i].RotTar.h; 
		else if(Pc[i].RotTar.h-Pc[i].Rot.h>-DX_PI) Pc[i].Rot.h-=0.2f;
		else Pc[i].Rot.h+=0.2f;
		if(sqrt(pow(Pc[i].Rot.v-Pc[i].RotTar.v,2))<=0.1f) Pc[i].Rot.v=Pc[i].RotTar.v; else if(Pc[i].Rot.v<Pc[i].RotTar.v) Pc[i].Rot.v+=0.1f; else if(Pc[i].Rot.v>Pc[i].RotTar.v) Pc[i].Rot.v-=0.1f;
		if(sqrt(pow(Pc[i].Rot.t-Pc[i].RotTar.t,2))<=0.1f) Pc[i].Rot.t=Pc[i].RotTar.t; else if(Pc[i].Rot.t<Pc[i].RotTar.t) Pc[i].Rot.t+=0.1f; else if(Pc[i].Rot.t>Pc[i].RotTar.t) Pc[i].Rot.t-=0.1f;

		// ʒuf
		Pc[i].Pos=Pc[i].NPos;
	}
}

//L`
void DrawPlayer(void){
	for(int i=0;i<PCNUM;i++){
		MV1SetPosition(Pc[i].Handle.Model,VGet(Pc[i].Pos.x,Pc[i].Pos.y,Pc[i].Pos.z));
		MV1SetRotationXYZ(Pc[i].Handle.Model,VGet(Pc[i].Rot.v,Pc[i].Rot.h,Pc[i].Rot.t));
		MV1DrawModel(Pc[i].Handle.Model);
	}
}

// ߂G2̂T
void CalcTarget(int ID){
	double MinDis[2]={1000000,1000000};
	double Dis;
	int Target[2]={-1,-1};

	// SẴLT
	for(int i=0;i<PCNUM;i++){

		// ̃LAgȂāA`[łȂASł͂ȂA2Ԗڂɋ߂LN^߂o^
		if(i!=ID&&Pc[i].Team!=Pc[ID].Team&&!(Pc[i].State==PS_DEADLY||Pc[i].State==PS_DEAD)&&(Dis=CalcDis(ID,i))<MinDis[1]){

			// ԋ߂
			if(Dis<MinDis[0]){
				MinDis[1]=MinDis[0];
				Target[1]=Target[0];
				MinDis[0]=Dis;
				Target[0]=i;

			// 2Ԗڂɋ߂
			}else{
				MinDis[1]=Dis;
				Target[1]=i;
			}
		}
	}

	// o^
	Pc[ID].NearEne[0]=Target[0];
	Pc[ID].NearEne[1]=Target[1];
}

// 2̊Ԃ̋v
double CalcDis(int ID,int EID){
	return sqrt(pow(Pc[ID].Pos.x-Pc[EID].Pos.x,2)+pow(Pc[ID].Pos.y-Pc[EID].Pos.y,2)+pow(Pc[ID].Pos.z-Pc[EID].Pos.z,2));
}

// L̏󋵌vZ
void CalcPlayer(void){

	// SẴL
	for(int i=0;i<PCNUM;i++){

		// ^[Qbg
		CalcTarget(i);
		if(Pc[i].Flag.TargetMode==AIM_FREE) Pc[i].Flag.Target=Pc[i].NearEne[0];
		else if(KeyOrPad(CF_TARGETCHANGE)==1){
			if(Pc[i].Flag.Target==Pc[i].NearEne[0]) Pc[i].Flag.Target=Pc[i].NearEne[1];
			else Pc[i].Flag.Target=Pc[i].NearEne[0];
		}

		// G̕c
		if(Pc[i].Control==CC_MAINPLAYER){
			Pc[i].RotEne.h=atan2(Pc[Pc[i].Flag.Target].Pos.x-Pc[i].Pos.x,Pc[Pc[i].Flag.Target].Pos.z-Pc[i].Pos.z);
			Pc[i].RotEne.v=-atan2(Pc[Pc[i].Flag.Target].Pos.y-Pc[i].Pos.y,hypotf(Pc[Pc[i].Flag.Target].Pos.z-Pc[i].Pos.z,Pc[Pc[i].Flag.Target].Pos.x-Pc[i].Pos.x));
		}else{
			Pc[i].RotEne.h=atan2(Pc[Pc[i].Flag.Target].Pos.x+(Pc[Pc[i].Flag.Target].Pos.x-Pc[Pc[i].Flag.Target].PPos.x)*Pc[i].DisEne/40-Pc[i].Pos.x,Pc[Pc[i].Flag.Target].Pos.z+(Pc[Pc[i].Flag.Target].Pos.z-Pc[Pc[i].Flag.Target].PPos.z)*Pc[i].DisEne/40-Pc[i].Pos.z);
			Pc[i].RotEne.v=-atan2(Pc[Pc[i].Flag.Target].Pos.y+(Pc[Pc[i].Flag.Target].Pos.y-Pc[Pc[i].Flag.Target].PPos.y)*Pc[i].DisEne/40-Pc[i].Pos.y,hypotf(Pc[Pc[i].Flag.Target].Pos.z+(Pc[Pc[i].Flag.Target].Pos.z-Pc[Pc[i].Flag.Target].PPos.z)*Pc[i].DisEne/40-Pc[i].Pos.z,Pc[Pc[i].Flag.Target].Pos.x+(Pc[Pc[i].Flag.Target].Pos.x-Pc[Pc[i].Flag.Target].PPos.x)*Pc[i].DisEne/40-Pc[i].Pos.x));
		}

		// G̋c
		Pc[i].DisEne=CalcDis(i,Pc[i].Flag.Target);
	}
}

// LN^
void PlayerRespawn(int i){

		// W
		Pc[i].Pos.x=GetRand(30000)/10.0-1500.0;
		Pc[i].Pos.y=GetRand(10000)/10.0-500.0;
		Pc[i].Pos.z=GetRand(30000)/10.0-1500.0;
		Pc[i].PPos=Pc[i].Pos;
		
		// 
		Pc[i].Rot.v=-atan2(-Pc[i].Pos.y,hypotf(-Pc[i].Pos.z,-Pc[i].Pos.x));
		Pc[i].Rot.h=atan2(-Pc[i].Pos.x,-Pc[i].Pos.z);
		Pc[i].Rot.t=0.0;
		Pc[i].RotTar=Pc[i].Rot;

		// ]Eړx
		Pc[i].Spd.v=0.0;
		Pc[i].Spd.h=0.0;
		Pc[i].Spd.t=0.0;

		//߂GIDC̍ŒZƊpx
		Pc[i].NearEne[0]=-1;
		Pc[i].NearEne[1]=-1;
		Pc[i].DisEne=10000.0;
		Pc[i].RotEne.v=0.0;
		Pc[i].RotEne.h=0.0;
		Pc[i].RotEne.t=0.0;

		// Xe[^X
		Pc[i].MaxLife=100;
		Pc[i].Life=100;
		Pc[i].Damage=0;
		Pc[i].Recovery=0;
		Pc[i].State=PS_FINE;

		// CPUpϐ
		Pc[i].MMInterval=120;
		Pc[i].Move.x=0.0;
		Pc[i].Move.y=0.0;
		Pc[i].Move.z=0.0;

		// FlagW
		Pc[i].Flag.TargetMode=0;
		Pc[i].Flag.Target=-1;
		Pc[i].Flag.TargetModeFrame=0;
		Pc[i].Flag.LastDamageFrame=0;
		Pc[i].Flag.LastShotFrame=0;
		Pc[i].Flag.LastMoveFrame=0;
		Pc[i].Flag.LastAttachFrame=0;
		Pc[i].Flag.LastMoveDecideFrame=0;

		// JC
		if(i==PlayerID) CameraInit();
}

// 蔻
int CheckAllHit(int PcID,VECTOR Old,VECTOR New){

	// SLɑ΂
	for(int EcID=0;EcID<PCNUM;EcID++){

		// `[ł͂ȂASłZgpłȂ
		if(Pc[PcID].Team!=Pc[EcID].Team&&Pc[EcID].State!=PS_DEADLY&&Pc[EcID].State!=PS_DEAD&&Pc[EcID].State!=PS_SATTACK){
			float Length;
			VECTOR Tmp;
			Tmp.x=Pc[EcID].Pos.x; Tmp.y=Pc[EcID].Pos.y; Tmp.z=Pc[EcID].Pos.z;
			Length=Segment_Point_MinLength(Old,New,Tmp);
			MV1_COLL_RESULT_POLY Result=MV1CollCheck_Line(Pc[EcID].Handle.Model,-1,Old,New);
			if(Result.HitFlag) return EcID;
			if(Length<100) Pc[EcID].Graze++;
		}
	}
	return -1;
}

// _[W
void PlayerDamage(int DamegedID, int AttackerID,int DamagePoint){

	Pc[DamegedID].Life-=DamagePoint;
	Pc[DamegedID].Damage+=DamagePoint;
	Pc[AttackerID].ScoreTar+=DamagePoint;
	Pc[AttackerID].Bomb+=DamagePoint/1000.0f;
	Pc[DamegedID].Flag.LastDamageFrame=GetGameFrame();
}

// S
void CheckPlayerKilled(int KilledID, int KillID, int Killedby){

	if(Pc[KilledID].Life<=0){
		Pc[KilledID].State=PS_DEADLY;
		Pc[KilledID].Flag.LastDeadlyFrame=GetGameFrame();
		Pc[KilledID].Killed=KillID;
		if(Killedby==BV_NORMAL) Pc[KilledID].Killedby=KL_DEFAULT;
		else Pc[KilledID].Killedby=KL_DOUBLEDIRECTIONALLAZER;
	}
}

// S
void PlayerKill(int KillID,int KilledID, int Killedby){
	int GameSelectedRule=GetGameSelectedRule();

	// łł͂Ȃ
	if(KillID!=-1){

		// LZ
		Pc[KillID].Kill++;
		Pc[KillID].ScoreTar+=100;

		// ʏUœ|Ȃp[Abv
		if(Killedby==KL_DEFAULT){ Pc[KillID].Power+=0.5; }

		// [`[fXȂ1_Z
		if(GameSelectedRule==SR_TEAMDEATHMATCH&&Pc[KillID].Team!=Pc[KilledID].Team) TeamPointCountUp(Pc[KillID].Team);
	}

	// ꂽL̎Sƃp[_E 
	Pc[KilledID].Death++;
	Pc[KilledID].Power--;

	// LOɓo^
	KillLogRegist(KillID,KilledID,Killedby);
}

// ͈͊Oɏȍ
void PlayerOutArea(void){
	int GameFrame=GetGameFrame();

	for(int i=0;i<PCNUM;i++){
		if((Pc[i].Pos.x<-STAGESIZE/2||STAGESIZE/2<Pc[i].Pos.x||
			Pc[i].Pos.y<-STAGESIZE/2||STAGESIZE/2<Pc[i].Pos.y||
			Pc[i].Pos.z<-STAGESIZE/2||STAGESIZE/2<Pc[i].Pos.z)&&
			!(Pc[i].State==PS_DEADLY||Pc[i].State==PS_DEAD)){
			   Pc[i].Life--;
			   Pc[i].Damage++;
			   (Pc+i)->Flag.LastDamageFrame=GameFrame;
			   if(Pc[i].Life<=0){
				  Pc[i].State=PS_DEADLY;
				  Pc[i].Flag.LastDeadlyFrame=GameFrame;
			      Pc[i].Killed=-1;
			 	  Pc[i].Killedby=-1;
			   }
		}
	}
}

// f̃Aj[VXV
void UpdatePlayerAnim(void){
	for(int i=0;i<PCNUM;i++){

		// Aj[VԂ̒擾
		int TotalTime=MV1GetAttachAnimTotalTime(Pc[i].Handle.Model,Pc[i].Handle.Attach);

		// ݂̃Aj[VԂ̍XV
		if(TotalTime==0) Pc[i].Handle.Anitime=0.0;
		else Pc[i].Handle.Anitime=(Pc[i].Handle.Anitime+1)%TotalTime;

		// Aj[VԂZbg
		MV1SetAttachAnimTime(Pc[i].Handle.Model,Pc[i].Handle.Attach,Pc[i].Handle.Anitime);
	}
}

// f̃Aj[VA^b`XV
void UpdatePlayerAttach(void){
	int BeforeAttach,AfterAttach;
	int GameFrame=GetGameFrame();

	for(int i=0;i<PCNUM;i++){

		// Ot[̃A^b`e̕ۑ
		BeforeAttach=MV1GetAttachAnim(Pc[i].Handle.Model,Pc[i].Handle.Attach);

		// 
		if(BeforeAttach!=AN_DEAD&&Pc[i].State==PS_DEAD){
			if(GameFrame-Pc[i].Flag.LastAttachFrame<=10) MV1DetachAnim(Pc[i].Handle.Model,Pc[i].Handle.BeforeAttach);
			Pc[i].Handle.BeforeAttach=Pc[i].Handle.Attach;
			Pc[i].Handle.Attach = MV1AttachAnim(Pc[i].Handle.Model,AN_DEAD);
		}
		if(Pc[i].State==PS_DEAD) goto A;
		
		// _ufBNV[U[
		if(BeforeAttach!=AN_DOUBLEDIRECTIONALLAZER&&Pc[i].Skill[0].State==SS_ACTIVATED){
			if(GameFrame-Pc[i].Flag.LastAttachFrame<=10) MV1DetachAnim(Pc[i].Handle.Model,Pc[i].Handle.BeforeAttach);
			Pc[i].Handle.BeforeAttach=Pc[i].Handle.Attach;
			Pc[i].Handle.Attach = MV1AttachAnim(Pc[i].Handle.Model,AN_DOUBLEDIRECTIONALLAZER);
		}
		if(Pc[i].Skill[0].State==SS_ACTIVATED) goto A;

		// }X^[Xp[N
		if(BeforeAttach!=AN_MASTERSPARK&&Pc[i].SetBomb.Selected==BM_MASTERSPARK&&Pc[i].SetBomb.State==SS_ACTIVATED){
			if(GameFrame-Pc[i].Flag.LastAttachFrame<=10) MV1DetachAnim(Pc[i].Handle.Model,Pc[i].Handle.BeforeAttach);
			Pc[i].Handle.BeforeAttach=Pc[i].Handle.Attach;
			Pc[i].Handle.Attach = MV1AttachAnim(Pc[i].Handle.Model,AN_MASTERSPARK);
		}
		if(Pc[i].SetBomb.Selected==BM_MASTERSPARK&&Pc[i].SetBomb.State==SS_ACTIVATED) goto A;

		// ړ
		if(BeforeAttach!=AN_MOVE&&GameFrame-Pc[i].Flag.LastMoveFrame==0){
			if(GameFrame-Pc[i].Flag.LastAttachFrame<=10) MV1DetachAnim(Pc[i].Handle.Model,Pc[i].Handle.BeforeAttach);
			Pc[i].Handle.BeforeAttach=Pc[i].Handle.Attach;
			Pc[i].Handle.Attach = MV1AttachAnim(Pc[i].Handle.Model,AN_MOVE);
		}
		if(GameFrame-Pc[i].Flag.LastMoveFrame==0) goto A;

		// ~
		if(BeforeAttach!=AN_STAND&&GameFrame-Pc[i].Flag.LastMoveFrame>0){
			if(GameFrame-Pc[i].Flag.LastAttachFrame<=10) MV1DetachAnim(Pc[i].Handle.Model,Pc[i].Handle.BeforeAttach);
			Pc[i].Handle.BeforeAttach=Pc[i].Handle.Attach;
			Pc[i].Handle.Attach = MV1AttachAnim(Pc[i].Handle.Model,AN_STAND);
		}

		// t[̃A^b`e̕ۑ
		A:
		AfterAttach=MV1GetAttachAnim(Pc[i].Handle.Model,Pc[i].Handle.Attach);

		// A^b`̍XV
		if(BeforeAttach!=AfterAttach){
			Pc[i].Handle.Anitime=0;
			Pc[i].Flag.LastAttachFrame=GameFrame;
		}
		if(GameFrame-Pc[i].Flag.LastAttachFrame<=10){
			MV1SetAttachAnimBlendRate(Pc[i].Handle.Model,Pc[i].Handle.BeforeAttach,1.0f-(GameFrame-Pc[i].Flag.LastAttachFrame)/10.0f);
			MV1SetAttachAnimBlendRate(Pc[i].Handle.Model,Pc[i].Handle.Attach,(GameFrame-Pc[i].Flag.LastAttachFrame)/10.0f);
		}
		if(GameFrame-Pc[i].Flag.LastAttachFrame==10){
			MV1DetachAnim(Pc[i].Handle.Model,Pc[i].Handle.BeforeAttach);
		}
	}
}

// L̍XV
void UpdateAllPlayer(void){
	int GameFrame=GetGameFrame();

	// 蔻XV
	MV1RefreshCollInfo(Pc[GameFrame%PCNUM].Handle.Model,-1);

	for(int i=0;i<PCNUM;i++){

		// HP/ˌ/{񐔂Kl
		if(Pc[i].Life<0.0) Pc[i].Life=0.0f;
		if(Pc[i].Power<0.0) Pc[i].Power=0.0f;
		if(Pc[i].Power>3.0) Pc[i].Power=3.0f;
		if(Pc[i].Bomb>5.0) Pc[i].Bomb=5.0f;

		// ˌ͉
		if(Pc[i].Power<1&&!(Pc[i].State==PS_DEADLY||Pc[i].State==PS_DEAD)) Pc[i].Power+=0.001f;
		
		// HPQ[Wop
		if(GameFrame-Pc[i].Flag.LastDamageFrame>10&&Pc[i].Damage>1) Pc[i].Damage-=2;
		if(GameFrame-Pc[i].Flag.LastDamageFrame>10&&Pc[i].Damage<=1) Pc[i].Damage=0;
		if(GameFrame-Pc[i].Flag.LastRecoveryFrame>10&&Pc[i].Recovery>1) Pc[i].Recovery-=2;
		if(GameFrame-Pc[i].Flag.LastRecoveryFrame>10&&Pc[i].Recovery<=1) Pc[i].Recovery=0;

		// HP
		if(Pc[i].Control!=CC_COMPUTER&&GameFrame-Pc[i].Flag.LastDamageFrame>100&&Pc[i].Life<Pc[i].MaxLife&&!(Pc[i].State==PS_DEADLY||Pc[i].State==PS_DEAD)&&
		   GameFrame-Pc[i].Flag.LastMoveFrame>100&&(GameFrame-Pc[i].Flag.LastDamageFrame)%10==0){
			   Pc[i].Life++;
			   Pc[i].Recovery++;
			   Pc[i].Flag.LastRecoveryFrame=GameFrame;
		}
		if(Pc[i].Control==CC_COMPUTER&&GameFrame-Pc[i].Flag.LastDamageFrame>100&&Pc[i].Life<Pc[i].MaxLife&&!(Pc[i].State==PS_DEADLY||Pc[i].State==PS_DEAD)&&
		   (GameFrame-Pc[i].Flag.LastDamageFrame)%20==0){
			   Pc[i].Life++;
			   Pc[i].Recovery++;
			   Pc[i].Flag.LastRecoveryFrame=GameFrame;
		}

		// XRAXV
		if(Pc[i].Score<Pc[i].ScoreTar) Pc[i].Score++;
		if(Pc[i].Score>Pc[i].ScoreTar) Pc[i].Score--;

		// {
		if(Pc[i].SetBomb.EndFrame==GameFrame) BombUnregist(i);

		// S肩莞Ԍo߂̂ŎS
		if(Pc[i].State==PS_DEADLY&&GameFrame-Pc[i].Flag.LastDeadlyFrame>5){
			Pc[i].State=PS_DEAD;
			Pc[i].Flag.LastDeadFrame=GameFrame;
			PlayerKill(Pc[i].Killed,i,Pc[i].Killedby);
		}

		// ł莞Ԍo߂̂ŃX|[
		if(Pc[i].State==PS_DEAD&&GameFrame-Pc[i].Flag.LastDeadFrame>180) PlayerRespawn(i);
	}
}

// Xe[^X`
void DrawPlayerStatus(void){
	int LogWidth,Alpha;

	// 擾
	FONT Font=GetFont();
	TEAM *Team=GetAllTeam();
	GRAPHHANDLE Handle=GetAllHandle();
	int GameFrame=GetGameFrame();

	DrawKillLog();

	// eBN̕`(380.0f,270.0f)
	if(Pc[PlayerID].State==PS_FINE){
		DrawLine(380,295,380,306,GetColor(0,0,0),1);
		DrawLine(375,300,386,300,GetColor(0,0,0),1);
	}

	// 1000t[oߌ
	if(GameFrame>=1000){

		// XRA{[h̕`
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,128);
		DrawBox(250,0,520,50,GetColor(0,0,0),1);
		SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
		DrawFormatStringToHandle(270,10,GetColor(255,255,255),Font.Status,"RED: %2d - %2d :BLUE",Team[0].Point,Team[1].Point);
	}

	// _A|A|ꂽAOCYAp[A{̕`
	DrawGraph(760,0,Handle.ScoreBoard.Graph,FALSE);
	DrawFormatStringToHandle(760+10,10,GetColor(255,255,255),Font.Status,"Score:");
	DrawFormatStringToHandle(760+135,10,GetColor(255,255,255),Font.Status,"%4d",Pc[PlayerID].Score);
	DrawFormatStringToHandle(760+10,55,GetColor(255,255,255),Font.Status,"Won:");
	DrawFormatStringToHandle(760+135,55,GetColor(255,255,255),Font.Status,"%4d",Pc[PlayerID].Kill);
	DrawFormatStringToHandle(760+10,80,GetColor(255,255,255),Font.Status,"Lost:");
	DrawFormatStringToHandle(760+135,80,GetColor(255,255,255),Font.Status,"%4d",Pc[PlayerID].Death);
	DrawFormatStringToHandle(760+10,105,GetColor(255,255,255),Font.Status,"Graze:");
	DrawFormatStringToHandle(760+107,105,GetColor(255,255,255),Font.Status,"%6d",Pc[PlayerID].Graze);
	DrawFormatStringToHandle(760+10,150,GetColor(255,255,255),Font.Status,"POWER:");
	DrawFormatStringToHandle(760+140,150,GetColor(255,255,255),Font.Status,"%1.2f",Pc[PlayerID].Power);
	DrawFormatStringToHandle(760+10,175,GetColor(255,255,255),Font.Status,"BOMB:");
	DrawFormatStringToHandle(760+140,175,GetColor(255,255,255),Font.Status,"%1.2f",Pc[PlayerID].Bomb);

	// {摜`
	if(Pc[PlayerID].SetBomb.Selected!=-1){
		DrawGraph(760,220,Handle.Bomb[Pc[PlayerID].SetBomb.Selected].Graph,FALSE);
		DrawFormatStringToHandle(805,245,GetColor(255,255,255),Font.KeyConfigEdge,"%s","}X^[Xp[N");

		// {摜_ŕ\
		if(Pc[PlayerID].SetBomb.State==SS_ACTIVATED){
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,(GameFrame%32)*8);
			DrawBox(760+200*((double)(Pc[PlayerID].SetBomb.StartFrame-GameFrame)/(Pc[PlayerID].SetBomb.StartFrame-Pc[PlayerID].SetBomb.EndFrame)),220,960,270,GetColor(255,255,255),TRUE);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
		}else if(Pc[PlayerID].SetBomb.State==SS_AVAILABLE){
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,(GameFrame%64)*4);
			DrawBox(760,220,960,270,GetColor(255,255,255),TRUE);
			SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
		}
	}

	// HP̕`
	DrawFormatStringToHandle(760+10,290,GetColor(255,255,255),Font.Status,"HP:");
	DrawLine(760,330,960,330,GetColor(255,255,255));
	double x=200.0/Pc[PlayerID].MaxLife;
	DrawBox(960-Pc[PlayerID].Life*x,330,960,315,GetColor(255,255,255),TRUE);
	DrawBox(960-Pc[PlayerID].Life*x,330,max(760,960-Pc[PlayerID].Life*x-Pc[PlayerID].Damage*x),315,GetColor(255,0,0),TRUE);
	DrawBox(960-Pc[PlayerID].Life*x,330,min(960,960-Pc[PlayerID].Life*x+Pc[PlayerID].Recovery*x),315,GetColor(0,255,255),TRUE);
	DrawFormatStringToHandle(865,330,GetColor(255,255,255),Font.Status,"%3d/%3d",Pc[PlayerID].Life,Pc[PlayerID].MaxLife);
	/*
	// LXg[N̕`
	for(int i=0;i<3;i++){
		if(Pc[PlayerID].KillStreak[i].Selected!=-1){
			DrawGraph(760,380+i*50,Handle.KillStreak[Pc[PlayerID].KillStreak[i].Selected].Graph,FALSE);
			DrawFormatStringToHandle(785,405+i*50,GetColor(255,255,255),Font.StatusEdge,"  %4dScore",KillStreakCost[Pc[PlayerID].KillStreak[i].Selected]);
		}
	}

	//LXg[N_ŕ\
	for(int i=0;i<3;i++){
		if(Pc[PlayerID].KillStreak[i].Selected!=-1&&Pc[PlayerID].KillStreak[Pc[PlayerID].KillStreak[i].Selected].Activate==1){
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,(Game.Frame%32)*8);
			DrawBox(760+200*((double)(Pc[PlayerID].KillStreak[i].StartFrame-Game.Frame)/(Pc[PlayerID].KillStreak[i].StartFrame-Pc[PlayerID].KillStreak[i].EndFrame)),380+i*50,960,430+i*50,GetColor(255,255,255),TRUE);
		}else if(Pc[PlayerID].KillStreak[i].Selected!=-1&&Pc[PlayerID].KillStreak[i].Available==1){
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,(Game.Frame%64)*4);
			DrawBox(760,380+i*50,960,430+i*50,GetColor(255,255,255),TRUE);
		}
	}*/

	// LN^̏ԂDEADLYȂ
	if(Pc[PlayerID].State==PS_DEADLY){

		// DEADLY\
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(120,(GameFrame-Pc[PlayerID].Flag.LastDeadlyFrame)*(120/20)));
		DrawBox(0,0,WINDOWWIDTH,WINDOWHEIGHT,GetColor(80,0,0),1);
		SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
	}
}

// G̃Xe[^X`
void DrawEnemyStatus(void){
	VECTOR ScreenPos,Tmp;
	FONT Font=GetFont();

	// SLΏ
	for(int index=0;index<PCNUM;index++){

		// gȊÕL
		if(Pc[index].Control!=CC_MAINPLAYER){

			// Ă`悵Ȃ
			if(Pc[index].State==PS_DEAD) return;

			// XN[Wɕϊ
			Tmp.x=Pc[index].Pos.x; Tmp.y=Pc[index].Pos.y; Tmp.z=Pc[index].Pos.z;
			ScreenPos = ConvWorldPosToScreenPos(Tmp);

			// ʓɎ܂ĂȂ
			if(ScreenPos.z>0.0f&&1.0f>ScreenPos.z){

				// `
				double x=100.0/Pc[index].MaxLife;
				DrawBox(ScreenPos.x+100-Pc[index].Life*x,ScreenPos.y-10,ScreenPos.x+100,ScreenPos.y,GetColor(255,255,255),TRUE);
				DrawBox(ScreenPos.x+100-Pc[index].Life*x,ScreenPos.y-10,min(ScreenPos.x+100,ScreenPos.x+100-Pc[index].Life*x+Pc[index].Recovery*x),ScreenPos.y,GetColor(0,255,255),TRUE);
				DrawBox(ScreenPos.x+100-Pc[index].Life*x,ScreenPos.y-10,max(ScreenPos.x,ScreenPos.x+100-Pc[index].Life*x-Pc[index].Damage*x),ScreenPos.y,GetColor(255,0,0),TRUE);
				DrawFormatStringToHandle(ScreenPos.x+10,ScreenPos.y-10,GetColor(0,0,0),Font.EnemyStatus,"%10s %3d/%3d",Pc[index].Name,Pc[index].Life,Pc[index].MaxLife);
				DrawFormatStringToHandle(ScreenPos.x+55,ScreenPos.y,GetColor(0,0,0),Font.EnemyStatus," Won:%3d",Pc[index].Kill);
				DrawFormatStringToHandle(ScreenPos.x+55,ScreenPos.y+10,GetColor(0,0,0),Font.EnemyStatus,"Lost:%3d",Pc[index].Death);
				if(Pc[index].Team==Pc[PlayerID].Team) DrawLine(ScreenPos.x,ScreenPos.y,ScreenPos.x+100,ScreenPos.y,GetColor(255,0,0));
				else DrawLine(ScreenPos.x,ScreenPos.y,ScreenPos.x+100,ScreenPos.y,GetColor(0,0,255));

				// ԋ߂GN[YAbv
				if(index==Pc[PlayerID].NearEne[0]){
					DrawBox(ScreenPos.x-30,ScreenPos.y-20,ScreenPos.x+110,ScreenPos.y+30,GetColor(255,0,0),FALSE);
					DrawFormatStringToHandle(ScreenPos.x-30,ScreenPos.y-30,GetColor(255,0,0),Font.EnemyStatus,"Nearest");
				}

				// Ԗڂɋ߂GN[YAbv
				if(index==Pc[PlayerID].NearEne[1]){
					DrawBox(ScreenPos.x-30,ScreenPos.y-20,ScreenPos.x+110,ScreenPos.y+30,GetColor(255,255,0),FALSE);
					DrawFormatStringToHandle(ScreenPos.x-30,ScreenPos.y-30,GetColor(255,255,0),Font.EnemyStatus,"Second Nearest");
				}
			}
		}
	}
}

// XL̎gp
void SkillRegist(int i,int SkillNum){
	
	// 擾
	int GameFrame=GetGameFrame();
	CAMERA Camera=GetCamera();

	// ԃZbg
	Pc[i].State=PS_SATTACK;
	Pc[i].Skill[SkillNum].State=SS_ACTIVATED;
	Pc[i].Skill[SkillNum].StartFrame=GameFrame;
	if(Pc[i].Skill[SkillNum].Selected==SK_DOUBLEDIRECTIONALLAZER){
		Pc[i].Skill[SkillNum].EndFrame=Pc[i].Skill[SkillNum].StartFrame+200;
		Pc[i].Skill[SkillNum].Pos[0]=Pc[i].Pos;
		Pc[i].Skill[SkillNum].Pos[1]=Pc[i].Pos;
		if(Pc[i].Control==CC_MAINPLAYER){
			Pc[i].Skill[SkillNum].Pos[1].x+=18192*sin(Camera.Rot.v+1.0f/2.0f*DX_PI)*cos(1.0f/2.0f*DX_PI-Camera.Rot.h);
			Pc[i].Skill[SkillNum].Pos[1].y+=18192*cos(Camera.Rot.v+1.0f/2.0f*DX_PI);
			Pc[i].Skill[SkillNum].Pos[1].z+=18192*sin(Camera.Rot.v+1.0f/2.0f*DX_PI)*sin(1.0f/2.0f*DX_PI-Camera.Rot.h);
		}else{
			Pc[i].Skill[SkillNum].Pos[1].x+=18192*sin(Pc[i].Rot.v+1.0f/2.0f*DX_PI)*cos(1.0f/2.0f*DX_PI-Pc[i].Rot.h);
			Pc[i].Skill[SkillNum].Pos[1].y+=18192*cos(Pc[i].Rot.v+1.0f/2.0f*DX_PI);
			Pc[i].Skill[SkillNum].Pos[1].z+=18192*sin(Pc[i].Rot.v+1.0f/2.0f*DX_PI)*sin(1.0f/2.0f*DX_PI-Pc[i].Rot.h);
		}
	}
}

// XL̉
void SkillUnregist(int i,int SkillNum){

	if(Pc[i].State==PS_SATTACK) Pc[i].State=PS_FINE;
	Pc[i].Skill[SkillNum].State=SS_AVAILABLE;
}

// {̎gp
void BombRegist(int i){

	// 擾
	int GameFrame=GetGameFrame();
	CAMERA Camera=GetCamera();

	// ԃZbg
	Pc[i].State=PS_SATTACK;
	Pc[i].SetBomb.StartFrame=GameFrame;
	Pc[i].SetBomb.State=SS_ACTIVATED;
	Pc[i].Bomb--;
	if(Pc[i].SetBomb.Selected==BM_MASTERSPARK){
		Pc[i].SetBomb.EndFrame=Pc[i].SetBomb.StartFrame+300;
		Pc[i].SetBomb.Pos[0]=Pc[i].Pos;
		Pc[i].SetBomb.Pos[1]=Pc[i].Pos;
		if(Pc[i].Control==CC_MAINPLAYER){
			Pc[i].SARot=Camera.Rot;
			Pc[i].SetBomb.Pos[1].x+=18192*sin(Camera.Rot.v+1.0f/2.0f*DX_PI)*cos(1.0f/2.0f*DX_PI-Camera.Rot.h);
			Pc[i].SetBomb.Pos[1].y+=18192*cos(Camera.Rot.v+1.0f/2.0f*DX_PI);
			Pc[i].SetBomb.Pos[1].z+=18192*sin(Camera.Rot.v+1.0f/2.0f*DX_PI)*sin(1.0f/2.0f*DX_PI-Camera.Rot.h);
		}else{
			Pc[i].SARot=Pc[i].Rot;
			Pc[i].SetBomb.Pos[1].x+=18192*sin(Pc[i].Rot.v+1.0f/2.0f*DX_PI)*cos(1.0f/2.0f*DX_PI-Pc[i].Rot.h);
			Pc[i].SetBomb.Pos[1].y+=18192*cos(Pc[i].Rot.v+1.0f/2.0f*DX_PI);
			Pc[i].SetBomb.Pos[1].z+=18192*sin(Pc[i].Rot.v+1.0f/2.0f*DX_PI)*sin(1.0f/2.0f*DX_PI-Pc[i].Rot.h);
		}
	}
}

// {̉
void BombUnregist(int i){

	if(Pc[i].State==PS_SATTACK) Pc[i].State=PS_FINE;
	if(Pc[i].Bomb<1.0f) Pc[i].SetBomb.State=SS_UNAVAILABLE; else Pc[i].SetBomb.State=SS_AVAILABLE;
}

// XLe̍XV
void SkillMove(void){
	static ROT pcrot[PCNUM][4][2];
	static VECTOR pcpos[PCNUM][4][2];
	int ID,SkillNum;

	// 擾
	int GameFrame=GetGameFrame();
	CAMERA Camera=GetCamera();

	for(ID=0;ID<PCNUM;ID++) for(SkillNum=0;SkillNum<4;SkillNum++){

		// XLĂ
		if(Pc[ID].Skill[SkillNum].State==SS_ACTIVATED){

			int Time=GameFrame-Pc[ID].Skill[SkillNum].StartFrame;

			// _ufBNVi[U[Ȃ
			if(Pc[ID].Skill[SkillNum].Selected==SK_DOUBLEDIRECTIONALLAZER){

				if(Time==0){
					if(Pc[ID].Control==CC_MAINPLAYER) Pc[ID].SARot=Camera.Rot; else Pc[ID].SARot=Pc[ID].RotEne;
				}
				if(Time==109){
					if(Pc[ID].Control==CC_MAINPLAYER) Pc[ID].SARot=pcrot[ID][SkillNum][0]; else Pc[ID].SARot=Pc[ID].RotEne;
				}
				if(Time==149){
					if(Pc[ID].Control==CC_MAINPLAYER) Pc[ID].SARot=pcrot[ID][SkillNum][1]; else Pc[ID].SARot=Pc[ID].RotEne;
				}

				if(Time<80&&60<=Time){
					if(Pc[ID].Control==CC_MAINPLAYER) Pc[ID].SARot=Camera.Rot; else Pc[ID].SARot=Pc[ID].RotEne;
					int j;
					for(int k=0;k<20;k++){
						SkillBulletRegist(ID,BV_DOUBLEDIRECTIONALLAZERN,Time, Pc[ID].Pos, Pc[ID].Pos);
						Pc[ID].Flag.LastShotFrame=GameFrame;
					}
				}

				if(Time==49){
					if(Pc[ID].Control==CC_MAINPLAYER) pcrot[ID][SkillNum][0]=Camera.Rot;
					else pcrot[ID][SkillNum][0]=Pc[ID].RotEne;
					pcpos[ID][SkillNum][0]=Pc[ID].Skill[SkillNum].Pos[0];
					pcpos[ID][SkillNum][0].x+=18192*sin(pcrot[ID][SkillNum][0].v+1.0f/2.0f*DX_PI)*cos(1.0f/2.0f*DX_PI-pcrot[ID][SkillNum][0].h);
					pcpos[ID][SkillNum][0].y+=18192*cos(pcrot[ID][SkillNum][0].v+1.0f/2.0f*DX_PI);
					pcpos[ID][SkillNum][0].z+=18192*sin(pcrot[ID][SkillNum][0].v+1.0f/2.0f*DX_PI)*sin(1.0f/2.0f*DX_PI-pcrot[ID][SkillNum][0].h);
					SkillBulletRegist(ID,BV_DOUBLEDIRECTIONALLAZERL,Time,Pc[ID].Skill[SkillNum].Pos[0],pcpos[ID][SkillNum][0]);
				}

				if(Time==89){
					if(Pc[ID].Control==CC_MAINPLAYER) pcrot[ID][SkillNum][1]=Camera.Rot;
					else pcrot[ID][SkillNum][1]=Pc[ID].RotEne;
					pcpos[ID][SkillNum][1]=Pc[ID].Skill[SkillNum].Pos[0];
					pcpos[ID][SkillNum][1].x+=18192*sin(pcrot[ID][SkillNum][1].v+1.0f/2.0f*DX_PI)*cos(1.0f/2.0f*DX_PI-pcrot[ID][SkillNum][1].h);
					pcpos[ID][SkillNum][1].y+=18192*cos(pcrot[ID][SkillNum][1].v+1.0f/2.0f*DX_PI);
					pcpos[ID][SkillNum][1].z+=18192*sin(pcrot[ID][SkillNum][1].v+1.0f/2.0f*DX_PI)*sin(1.0f/2.0f*DX_PI-pcrot[ID][SkillNum][1].h);
					SkillBulletRegist(ID,BV_DOUBLEDIRECTIONALLAZERL,Time,Pc[ID].Skill[SkillNum].Pos[0],pcpos[ID][SkillNum][1]);
				}

				// {ڂ̃[U[
				if(Time>=109){

					// 蔻
					for(int k=0;k<PCNUM;k++){
						if(GameFrame%10==1&&Pc[ID].Team!=Pc[k].Team&&Pc[k].State!=PS_DEAD&&Segment_Point_MinLength(Pc[ID].Skill[SkillNum].Pos[0],pcpos[ID][SkillNum][0],Pc[k].Pos)<100){
						
							// _t
							Pc[ID].ScoreTar+=5;

							//qbgȂ_[W
							Pc[k].Life-=5;
							if(Pc[k].Life<0) Pc[k].Life=0;
							Pc[k].Damage+=5;
							Pc[k].Flag.LastDamageFrame=GameFrame;
							
							// 0ȉɂȂDEADLY
							if(Pc[k].Life<=0){
								Pc[k].State=PS_DEADLY;
								Pc[k].Flag.LastDeadlyFrame=GameFrame;
								Pc[k].Killed=ID;
								Pc[k].Killedby=KL_DOUBLEDIRECTIONALLAZER;
							}
						}
					}
				}
	
				// {ڂ̃[U[
				if(Time>=149){

					// 蔻
					for(int k=0;k<PCNUM;k++){
						if(GameFrame%10==1&&Pc[ID].Team!=Pc[k].Team&&Pc[k].State!=PS_DEAD&&Segment_Point_MinLength(Pc[ID].Skill[SkillNum].Pos[0],pcpos[ID][SkillNum][1],Pc[k].Pos)<100){
						
							// _t
							Pc[ID].ScoreTar+=5;

							//qbgȂ_[W
							Pc[k].Life-=5;
							if(Pc[k].Life<0) Pc[k].Life=0;
							Pc[k].Damage+=5;
							Pc[k].Flag.LastDamageFrame=GameFrame;
							
							// 0ȉɂȂDEADLY
							if(Pc[k].Life<=0){
								Pc[k].State=PS_DEADLY;
								Pc[k].Flag.LastDeadlyFrame=GameFrame;
								Pc[k].Killed=ID;
								Pc[k].Killedby=KL_DOUBLEDIRECTIONALLAZER;
							}
						}
					}
				}
				
				// I
				if(GameFrame==Pc[ID].Skill[SkillNum].EndFrame) SkillUnregist(ID,SkillNum);
			}
		}
	}
}

// {e̍XV
void BombMove(void){

	// 擾
	int GameFrame=GetGameFrame();

	for(int ID=0;ID<PCNUM;ID++){
		// {Ă
		if(Pc[ID].SetBomb.State==SS_ACTIVATED){

			// }X^[Xp[NȂ
			if(Pc[ID].SetBomb.Selected==BM_MASTERSPARK){

				if(GameFrame-Pc[ID].SetBomb.StartFrame==0) BombBulletRegist(BV_MASTERSPARK,Pc[ID].SetBomb.Pos[0],Pc[ID].SetBomb.Pos[1]);

				// 100t[oߌ
				if(GameFrame-Pc[ID].SetBomb.StartFrame>=100){

					// 蔻
					for(int k=0;k<PCNUM;k++){
						if(GameFrame%5==1&&Pc[ID].Team!=Pc[k].Team&&Pc[k].State!=PS_DEAD&&Segment_Point_MinLength(Pc[ID].SetBomb.Pos[0],Pc[ID].SetBomb.Pos[1],Pc[k].Pos)<500){		
						
							// _t
							Pc[ID].ScoreTar+=10;

							//qbgȂ_[W
							Pc[k].Life-=10;
							if(Pc[k].Life<0) Pc[k].Life=0;
							Pc[k].Damage+=10;
							Pc[k].Flag.LastDamageFrame=GameFrame;
							
							// 0ȉɂȂDEADLY
							if(Pc[k].Life<=0){
								Pc[k].State=PS_DEADLY;
								Pc[k].Flag.LastDeadlyFrame=GameFrame;
								Pc[k].Killed=ID;
								Pc[k].Killedby=KL_MASTERSPARK;
							}
						}
					}
				}
			}

			// I
			if(GameFrame==Pc[ID].SetBomb.EndFrame) BombUnregist(ID);
		}
	}
}