#include "Shader.h"
#include "Game.h"
#include "GraphHandle.h"
#include "DxLib.h"

// \̎̒`
static SHADER Shader;

SHADER GetShader(void){ return Shader; } // VF[_擾

// VF[_ǂݍ
void LoadShader(void){
	Shader.Gray = LoadPixelShader("Shader/GrayScale.pso");
}

// VF[_K摜`
void DrawScreenGraphFromShader(void){
	VERTEX2DSHADER Vert[6];

	// _f[^̏
	Vert[ 0 ].pos = VGet(   0.0f,   0.0f, 0.0f ) ;
	Vert[ 1 ].pos = VGet( 960.0f,   0.0f, 0.0f ) ;
	Vert[ 2 ].pos = VGet(   0.0f, 540.0f, 0.0f ) ;
	Vert[ 3 ].pos = VGet( 960.0f, 540.0f, 0.0f ) ;
	Vert[ 0 ].dif = GetColorU8( 255,255,255,255 ) ;
	Vert[ 0 ].spc = GetColorU8( 0,0,0,0 ) ;
	Vert[ 1 ].dif = GetColorU8( 255,255,255,255 ) ;
	Vert[ 1 ].spc = GetColorU8( 0,0,0,0 ) ;
	Vert[ 2 ].dif = GetColorU8( 255,255,255,255 ) ;
	Vert[ 2 ].spc = GetColorU8( 0,0,0,0 ) ;
	Vert[ 3 ].dif = GetColorU8( 255,255,255,255 ) ;
	Vert[ 3 ].spc = GetColorU8( 0,0,0,0 ) ;
	Vert[ 0 ].u = 0.0f ; Vert[ 0 ].v = 0.0f ;
	Vert[ 1 ].u = 1.0f ; Vert[ 1 ].v = 0.0f ;
	Vert[ 2 ].u = 0.0f ; Vert[ 2 ].v = 1.0f ;
	Vert[ 3 ].u = 1.0f ; Vert[ 3 ].v = 1.0f ;
	Vert[ 0 ].su = 0.0f ; Vert[ 0 ].sv = 0.0f ;
	Vert[ 1 ].su = 1.0f ; Vert[ 1 ].sv = 0.0f ;
	Vert[ 2 ].su = 0.0f ; Vert[ 2 ].sv = 1.0f ;
	Vert[ 3 ].su = 1.0f ; Vert[ 3 ].sv = 1.0f ;
	Vert[ 0 ].rhw = 1.0f ;
	Vert[ 1 ].rhw = 1.0f ;
	Vert[ 2 ].rhw = 1.0f ;
	Vert[ 3 ].rhw = 1.0f ;
	Vert[ 4 ] = Vert[ 2 ] ;
	Vert[ 5 ] = Vert[ 1 ] ;

	// 摜쐬
	HANDLES Handle=MakeScreenGraph();

	// 擾
	int GameFrame=GetGameFrame();
	SHADER Shader=GetShader();
	
	// gpeNX`Zbg
	SetUseTextureToShader(0, Handle.Graph);
	
	// gpsNZVF[_Zbg
	SetUsePixelShader(Shader.Gray);

	// VF[_ɒ萔Zbg
	int cindex = GetConstIndexToShader("Alpha", Shader.Gray);
	float alpha;
	alpha=((float)(900.0f-GameFrame)/255.0f);
	FLOAT4 Alpha = {1.0f, 1.0f, 1.0f, alpha};
    SetPSConstF(cindex, Alpha);

	// `
	SetDrawBlendMode(DX_BLENDMODE_ALPHA,0);
	DrawPrimitive2DToShader( Vert, 6, DX_PRIMTYPE_TRIANGLELIST );
	SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
}