#include <stdio.h>
#include <string.h>
#include <math.h>
#include "DxLib.h"
#include "main.h"
#include "Draw.h"
#include "Move.h"
#include "Menu.h"
#include "Shot.h"
#include "Stage.h"
#include "Direction.h"

// L
void ControlPhase(PC *Player, CAMERA *Camera, GAME Game, KEYCON KeyCon, KEYCON PadCon){
	for(int i=0;i<PCNUM;i++){
		if(Player[i].Control==CC_MAINPLAYER) MainPlayerControl(Player+i,Camera,Game,KeyCon,PadCon,i); // vC[̑
		else CpuControl(Player+i,Game,i); // CPȖ
	}
}

// vC[̑
void MainPlayerControl(PC *Player, CAMERA *Camera, GAME Game, KEYCON KeyCon, KEYCON PadCon, int PlayerIndex){

	// Jړ
	// J̉Eړ
	if(PadCon.Right2==22&&Game.PadState.Rx>0) Camera->Spd.h=Game.PadState.Rx/100.0f;
	else{
		if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_RIGHT2)) Camera->Spd.h++; else if(Camera->Spd.h>0) Camera->Spd.h--;
	}

	// J̍ړ
	if(PadCon.Left2==23&&Game.PadState.Rx<0) Camera->Spd.h=Game.PadState.Rx/100.0f;
	else{
		if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_LEFT2)) Camera->Spd.h--; else if(Camera->Spd.h<0) Camera->Spd.h++;
	}

	// J̏ړ
	if(PadCon.Up2==25&&Game.PadState.Ry<0) Camera->Spd.v=Game.PadState.Ry/100.0f;
	else{
		if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_UP2)) Camera->Spd.v--; else if(Camera->Spd.v<0) Camera->Spd.v++;
	}

	// J̉ړ
	if(PadCon.Down2==24&&Game.PadState.Ry>0) Camera->Spd.v=Game.PadState.Ry/100.0f; 
	else{
		if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_DOWN2)) Camera->Spd.v++; else if(Camera->Spd.v>0) Camera->Spd.v--;
	}

	if(Camera->Spd.v>-1.0f&&1.0f>Camera->Spd.v) Camera->Spd.v=0;
	if(Camera->Spd.h>-1.0f&&1.0f>Camera->Spd.h) Camera->Spd.h=0;

	// SZĂ鎞͈ȉ̂ƂłȂ
	if(Player->State==PS_DEADLY||Player->State==PS_DEAD||Player->State==PS_SATTACK) return;
		
	// LN^ړ
	// Free[hȂ
	if(Player->Flag.TargetMode==AIM_FREE){

		// L̎Oړ
		if(PadCon.Down==18&&Game.PadState.Y>0) Player->Spd.t=-Game.PadState.Y/100.0f; 
		else{ if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_DOWN)) Player->Spd.t--; else if(Player->Spd.t<0) Player->Spd.t++; }
		
		// L̉ړ
		if(PadCon.Up==19&&Game.PadState.Y<0) Player->Spd.t=-Game.PadState.Y/100.0f;
		else{ if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_UP)) Player->Spd.t++; else if(Player->Spd.t>0) Player->Spd.t--; }
		
		// L̉Eړ
		if(PadCon.Right==16&&Game.PadState.X>0) Player->Spd.h=Game.PadState.X/100.0f; 
		else{ if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_RIGHT)) Player->Spd.h++; else if(Player->Spd.h>0) Player->Spd.h--; }
		
		// L̍ړ
		if(PadCon.Left==17&&Game.PadState.X<0) Player->Spd.h=Game.PadState.X/100.0f;
		else{ if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_LEFT)) Player->Spd.h--; else if(Player->Spd.h<0) Player->Spd.h++; }

	// Target[hȂ
	}else{

		// L̉ړ
		if(PadCon.Down==18&&Game.PadState.Y>0) Player->Spd.v=Game.PadState.Y/100.0f;
		else{ if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_DOWN)) Player->Spd.v++; else if(Player->Spd.v>0) Player->Spd.v--; }
		
		// L̏ړ
		if(PadCon.Up==19&&Game.PadState.Y<0) Player->Spd.v=Game.PadState.Y/100.0f;
		else{ if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_UP)) Player->Spd.v--; else if(Player->Spd.v<0) Player->Spd.v++; }
		
		// L̉Eړ
		if(PadCon.Right==16&&Game.PadState.X>0) Player->Spd.h=-Game.PadState.X/100.0f;
		else{ if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_RIGHT)) Player->Spd.h--; else if(Player->Spd.h<0) Player->Spd.h++; }
		
		// L̍ړ
		if(PadCon.Left==17&&Game.PadState.X<0) Player->Spd.h=-Game.PadState.X/100.0f;
		else{ if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_LEFT)) Player->Spd.h++; else if(Player->Spd.h>0) Player->Spd.h--; }
	}

	// ˌ[h؂ւ
	if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_SHOTMODESELECT)==1){
		Player->Flag.TargetMode=1-Player->Flag.TargetMode;
		Player->Flag.TargetModeFrame=Game.Frame;
	}

	// ˌ
	if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_SHOT)) ShotRegist(PlayerIndex);

	// XLgp
	if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_SKILL1)) SkillRegist(PlayerIndex,0);

	// {gp
	if(KeyOrPad(Game.Key,Game.Pad,KeyCon,PadCon,CF_BOMB)==1&&Player->Bomb>=1) BombRegist(PlayerIndex);
}

// CPȖ
void CpuControl(PC *Player, GAME Game, int PlayerIndex){

	// ʎƓU͓Ȃ
	if(Player->State==PS_DEADLY||Player->State==PS_DEAD||Player->State==PS_SATTACK) return;

	// LN^ړ
	// CPŨ_ړ
	if(Game.Frame-Player->LastMoveDecideFrame>Player->MMInterval||Game.Frame==0){
		Player->LastMoveDecideFrame=Game.Frame;
		if(Player->Pos.x<-STAGESIZE/3) Player->Move.x=GetRand(300)/100.0f;
		else if(Player->Pos.x>STAGESIZE/3) Player->Move.x=-GetRand(300)/100.0f;
		else Player->Move.x=GetRand(600)/100.0f-3.0f;

		if(Player->Pos.y<-STAGESIZE/3) Player->Move.y=GetRand(300)/100.0f;
		else if(Player->Pos.y>STAGESIZE/3) Player->Move.y=-GetRand(300)/100.0f;
		else Player->Move.y=GetRand(600)/100.0f-3.0f;

		if(Player->Pos.z<-STAGESIZE/3) Player->Move.z=GetRand(300)/100.0f;
		else if(Player->Pos.z>STAGESIZE/3) Player->Move.z=-GetRand(300)/100.0f;
		else Player->Move.z=GetRand(600)/100.0f-3.0f;
	}

	// ˌ
	if(Player->Flag.Target!=NOTSELECTED) ShotRegist(PlayerIndex);

	// {gp
	if(GetRand(2000)==1&&Player->Bomb>=1.0f&&Player->Flag.Target!=NOTSELECTED) BombRegist(PlayerIndex);

	// XLgp
	if(GetRand(200)==1) SkillRegist(PlayerIndex,0);
}

int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int){

	// \̎̒`
	GAME Game;
	PC Pc[PCNUM];
	CAMERA Camera;
	MAP Map[MAPNUM];
	TEAM Team[PCNUM];
	KILLLOG KillLog[KILLLOGMAX];
	KEYCON KeyCon,PadCon;
	FONT Font;
	DRAW Draw[DRAWMAX];
	GRAPHHANDLE Handle;
	SHADER Shader;
	NUM Num;

    // 
	GameInit(&Game,Map,&Font,&Handle,&Shader);

	// ݒ菉
	KeyConfigInit(&KeyCon,&PadCon);
	
	// L[擾
	GetKeyName(Game.KeyName,Game.PadName);

	// [v
    while(ScreenFlip()==0&&ProcessMessage()==0&&ClearDrawScreen()==0&&GetHitPadStateAll2(Game.Key)==0){

		// pbh͏Ԃ擾
		GetHitPadStateAll(Game.Pad,&Game.PadState);

		// Jݒ
		if(Game.FunctionStatus==FS_PLAY) SetCameraScreenCenter(380.0f,270.0f);
		else SetCameraScreenCenter(480.0f,270.0f);

		switch(Game.FunctionStatus){
			// j
			case FS_MENU:
				switch(Game.SelectedMenu){
				case SM_NOTSELECTED:
					Pc[Game.PlayerID].State=PS_FINE;
					Menu();                        // j
					break;
				case SM_KEYCONFIG:
					KeyConfig();                   // L[R
					break;
				case SM_RULE:
					RuleSelect();                  // [I
					break;
				case SM_MAP:
					MapSelect();                   // }bvI
					break;
				case SM_CHARACTER:
					CharacterSelect();             // LI
					break;
				case SM_START:
					StartSelect();
					break;
				}
				MenuDraw();                        // j`
				break;

			// Q[{
			case FS_PLAY:
				if(Game.Frame==0) PlayInit(&Game,Pc,&Camera,Team,&Num,Handle,Game.PlayerID); // Q[
				if(Game.Frame>=1000){
					FirstTask(Pc,Game.Key,Game.Pad,KeyCon,PadCon); // ^[̍ŏɂd
					ControlPhase();                // tF[Y   
					MovePhase();				   // ړtF[Y
					StageGimmick(&Game,Pc);                    // Xe[W̎d|
					LastTask(&Game,Pc,Team,KillLog,Draw,&Num); // ^[̍Ōɂd
				}
				PcDraw();                          // L`
				BulletDraw();                      // e`
				MapDraw();                         // }bv`
				OtherDraw();                       // ɕ`ʂ̂΁B
				DrawStatus();					   // G̏Ԃ`
				DrawPStatus();                     // ̏Ԃ`
				DeadDirection();
				OtherDraw2();                       // ɕ`ʂ̂΁B
				if(Game.Frame<1000) GameDirection();// Q[Jno
				break;

			// ʕ\
			case FS_RESULT:
				MovePhase();				       // ړtF[Y
				PcDraw();                          // L`
				BulletDraw();                      // e`
				MapDraw();                         // }bv`
				OtherDraw();                       // ɕ`ʂ̂
				ResultDirection();                 // ʉʉo
				break;
		}
		// Q[ԉZ
		Game.Frame++;
		DrawFormatString(100,100,GetColor(0,0,0),"%f",Camera.Spd.h);
	}

	DxLib_End(); // ㏈
	return 0;
}

// 
void GameInit(GAME *Game, MAP *Map, FONT *Font, GRAPHHANDLE *Handle, SHADER *Shader){

	// ݒ
	SetGraphMode(WINDOWWIDTH,WINDOWHEIGHT,COLORBIT,REFRESHRATE);
	ChangeWindowMode(TRUE), DxLib_Init(), SetDrawScreen(DX_SCREEN_BACK);
	
	// tHg̐ݒ
	Font->Title = CreateFontToHandle("CI", 40, 5, DX_FONTTYPE_ANTIALIASING_8X8);
	Font->Status = CreateFontToHandle("TTEditFont", 23, 5, DX_FONTTYPE_ANTIALIASING_8X8,DX_CHARSET_DEFAULT);
	Font->StatusSmall = CreateFontToHandle("TTEditFont", 17, 5, DX_FONTTYPE_ANTIALIASING_8X8,DX_CHARSET_DEFAULT);
	Font->StatusEdge = CreateFontToHandle("TTEditFont", 23, 5, DX_FONTTYPE_ANTIALIASING_EDGE_8X8,DX_CHARSET_DEFAULT);
	Font->EnemyStatus = CreateFontToHandle(NULL, 10, 0, DX_FONTTYPE_NORMAL);
	Font->Rule = CreateFontToHandle("TTEditFont", 40, 5, DX_FONTTYPE_ANTIALIASING_8X8,DX_CHARSET_DEFAULT);
	Font->KeyConfig = CreateFontToHandle("CI", 17, 5, DX_FONTTYPE_ANTIALIASING_8X8);
	Font->KeyConfigEdge = CreateFontToHandle("CI", 17, 5, DX_FONTTYPE_ANTIALIASING_EDGE_8X8);

	// yobt@ւ݂̏Lɂ
	SetUseZBuffer3D(TRUE);
	SetWriteZBuffer3D(TRUE);

	// f̓ǂݍ
	char CharacterModel[CHARACTERMODELNUM][30]={{"Model/pc_test1.mqo"},{"Model/MarisaV12/Ver12.mv1"}};
	char BombModel[BOMBNUM][30]={{"Model/masterspark8.mv1"}};
	//char SkillModel[SKILLNUM][30]={};
	//char SkillGraph[SKILLNUM][30]={};
	char MapModel[MAPNUM][2][33]={{"Model/sky_test3.mqo","Model/kirisameShop/marisaHouse.x"}};
	for(int i=0;i<CHARACTERMODELNUM;i++) Handle->Character[i].Model=MV1LoadModel(CharacterModel[i]);
	for(int i=0;i<BOMBNUM;i++) Handle->Bomb[i].Model=MV1LoadModel(BombModel[i]);
	for(int i=0;i<MAPNUM;i++){
		Map[i].SkyHandle=MV1LoadModel(MapModel[i][0]);
		Map[i].MapHandle=MV1LoadModel(MapModel[i][1]);
		MV1SetScale(Map[i].MapHandle,VGet(1000,1000,1000));
		MV1SetPosition(Map[i].MapHandle,VGet(0,-STAGESIZE/2,0));
		Map[i].GroundHandle=Map[i].MapHandle;
	}

	// sNZVF[_oCiR[h̓ǂݍ
	Shader->Gray = LoadPixelShader("Shader/GrayScale.pso");

	// 摜̓ǂݍ
	char StarBullet[5][30]={"Graph/BulletS0.png","Graph/BulletS1.png","Graph/BulletS2.png","Graph/BulletS3.png","Graph/BulletS4.png"};
	char BombGraph[BOMBNUM][30]={{"Graph/Bomb0.png"}};
	for(int i=0;i<5;i++) Handle->StarBullet[i].Graph=LoadGraph(StarBullet[i]);
	Handle->ScoreBoard.Graph=LoadGraph("Graph/ScoreBoard.jpg");
	for(int i=0;i<BOMBNUM;i++) Handle->Bomb[i].Graph=LoadGraph(BombGraph[i]);
	Handle->RedBullet.Graph=LoadGraph("Graph/RedBullet.png");
	Handle->BuleBullet.Graph=LoadGraph("Graph/BlueBullet.png");

	// tO
	Game->Frame=0;
	Game->FunctionStatus=FS_MENU;
	Game->SelectMenu=SM_KEYCONFIG;
	Game->SelectRule=SR_TEAMDEATHMATCH;
	Game->SelectKeyConfig=0;
	Game->SelectCharacter=0;
	Game->SelectMap=0;
	Game->SelectedRule=SR_TEAMDEATHMATCH;
	Game->SelectedCharacter=SCR_MARISA;
	Game->SelectedMap=0;
}

void KeyConfigInit(KEYCON *KeyCon, KEYCON *PadCon){

	// L[{[h
	KeyCon->Left=KEY_INPUT_A;
	KeyCon->Right=KEY_INPUT_D;
	KeyCon->Up=KEY_INPUT_W;
	KeyCon->Down=KEY_INPUT_S;
	KeyCon->Left2=KEY_INPUT_LEFT;
	KeyCon->Right2=KEY_INPUT_RIGHT;
	KeyCon->Up2=KEY_INPUT_UP;
	KeyCon->Down2=KEY_INPUT_DOWN;
	KeyCon->Enter=KEY_INPUT_Z;
	KeyCon->Cancel=KEY_INPUT_X;
	KeyCon->Shot=KEY_INPUT_SPACE;
	KeyCon->Bomb=KEY_INPUT_B;
	KeyCon->ShotModeSelect=KEY_INPUT_E;
	KeyCon->TargetChange=KEY_INPUT_R;
	KeyCon->Skill1=KEY_INPUT_F;
	KeyCon->Skill2=KEY_INPUT_G;
	KeyCon->Skill3=KEY_INPUT_C;
	KeyCon->Skill4=KEY_INPUT_V;

	// pbh
	PadCon->Left=17;
	PadCon->Right=16;
	PadCon->Up=19;
	PadCon->Down=18;
	PadCon->Left2=23;
	PadCon->Right2=22;
	PadCon->Up2=25;
	PadCon->Down2=24;
	PadCon->Enter=1;
	PadCon->Cancel=0;
	PadCon->Shot=5;
	PadCon->Bomb=4;
	PadCon->ShotModeSelect=21;
	PadCon->TargetChange=20;
	PadCon->Skill1=28;
	PadCon->Skill2=29;
	PadCon->Skill3=30;
	PadCon->Skill4=31;
}

// Q[̏
void PlayInit(GAME *Game, PC *Pc, CAMERA *Camera, TEAM *Team, NUM *Num, GRAPHHANDLE Handle, int PlayerID){

	// 
	PcInit(Game,Pc,Handle,PlayerID);
	CameraInit(Camera,Pc[PlayerID]);

	// JEg̏
	Num->KillLog=0;
	Num->Draw=0;

	// `[̏
	for(int i=0;i<PCNUM;i++){ Team[i].Point=0; Team[i].Win=0; }
}

// LN^̏
void PcInit(GAME *Game, PC *Pc, GRAPHHANDLE Handle, int PlayerID){

	// Q[ɑ݂邷ׂẴLɑ΂
	for(int i=0;i<PCNUM;i++){

		// fnhɂĂ
		MV1DeleteModel(Pc[i].Handle.Model);

		// l삵Ă̂CPU삵Ă̂
		if(i==PlayerID) Pc[i].Control=CC_MAINPLAYER; else Pc[i].Control=CC_COMPUTER;

		// f̑I
		if(Pc[i].Control==CC_MAINPLAYER) Pc[i].ModelID=Game->SelectedCharacter; else Pc[i].ModelID=SCR_MARISA;

		// f̓ǂݍ
		Pc[i].Handle.Model=MV1DuplicateModel(Handle.Character[Pc[i].ModelID].Model);

		// 傫AobNJOAAj[VA^b`A蔻̐ݒ
		if(Pc[i].ModelID==SCR_MARISA){
			MV1SetScale(Pc[i].Handle.Model,VGet(5.0f,5.0f,5.0f));
			int MaterialNum = MV1GetMaterialNum(Pc[i].Handle.Model);
			for(int j=0;j<MaterialNum;j++){
				float DotWidth = MV1GetMaterialOutLineDotWidth(Pc[i].Handle.Model,j);  
			    MV1SetMaterialOutLineDotWidth(Pc[i].Handle.Model,j,DotWidth/50.0f);
				MV1SetMeshBackCulling(Pc[i].Handle.Model,j,FALSE);
			}
		}
		Pc[i].Handle.Attach=MV1AttachAnim(Pc[i].Handle.Model,AN_STAND);
		Pc[i].Handle.Anitime=0;
		MV1SetUseZBuffer(Pc[i].Handle.Model, true);
		MV1SetWriteZBuffer(Pc[i].Handle.Model, true);
		int FrameIndex=-1,XDivNum=10,YDivNum=30,ZDivNum=10;
		MV1SetupCollInfo(Pc[i].Handle.Model,FrameIndex,XDivNum,YDivNum,ZDivNum);
	
		// W
		Pc[i].Pos.x=GetRand(30000)/10.0f-1500.0f;
		Pc[i].Pos.y=GetRand(10000)/10.0f-500.0f;
		Pc[i].Pos.z=GetRand(30000)/10.0f-1500.0f;
		Pc[i].PPos=Pc[i].Pos;
		
		// 
		Pc[i].Rot.v=-atan2(-Pc[i].Pos.y,hypotf(-Pc[i].Pos.z,-Pc[i].Pos.x));
		Pc[i].Rot.h=atan2(-Pc[i].Pos.x,-Pc[i].Pos.z);
		Pc[i].Rot.t=0.0f;
		Pc[i].RotTar=Pc[i].Rot;

		// ]Eړx
		Pc[i].Spd.v=0.0f;
		Pc[i].Spd.h=0.0f;
		Pc[i].Spd.t=0.0f;

		//߂GIDC̍ŒZƊpx
		Pc[i].NearEne[0]=NOTSELECTED;
		Pc[i].NearEne[1]=NOTSELECTED;
		Pc[i].DisEne=10000.0f;
		Pc[i].RotEne.v=0.0f;
		Pc[i].RotEne.h=0.0f;
		Pc[i].RotEne.t=0.0f;

		// Xe[^X
		Pc[i].Life=LIFEMAX;
		Pc[i].MaxLife=LIFEMAX;
		Pc[i].Damage=0;
		Pc[i].Recovery=0;
		Pc[i].Kill=0;
		Pc[i].Death=0;
		Pc[i].Graze=0;
		Pc[i].Power=1.0f;
		Pc[i].Bomb=1.0f;
		Pc[i].Team=i%2;
		Pc[i].State=PS_FINE;
		Pc[i].ScoreTar=0;
		Pc[i].Score=0;

		// {AXL
		Pc[i].SetBomb.Selected=BM_MASTERSPARK;
		Pc[i].SetBomb.State=SS_AVAILABLE;
		for(int j=0;j<4;j++){
			Pc[i].Skill[j].Selected=NOTSELECTED;
			Pc[i].Skill[j].State=SS_UNAVAILABLE;
		}
		Pc[i].Skill[0].Selected=SK_DOUBLEDIRECTIONALLAZER;
		Pc[i].Skill[0].State=SS_AVAILABLE;

		// CPUpϐ
		Pc[i].MMInterval=120;
		Pc[i].Move.x=0.0f;
		Pc[i].Move.y=0.0f;
		Pc[i].Move.z=0.0f;

		// FlagW
		Pc[i].Flag.TargetMode=AIM_FREE;
		Pc[i].Flag.Target=NOTSELECTED;
		Pc[i].Flag.TargetModeFrame=-1000;
		Pc[i].Flag.LastDamageFrame=-1000;
		Pc[i].Flag.LastShotFrame=-1000;
		Pc[i].Flag.LastMoveFrame=-1000;
		Pc[i].Flag.LastAttachFrame=-1000;
		Pc[i].LastMoveDecideFrame=-1000;
	}
	// O
	for(int i=0;i<PCNUM;i++){
		if(i==PlayerID) strcpy_s(Pc[i].Name,"p");
		else if(Pc[i].Team==Pc[PlayerID].Team) strcpy_s(Pc[i].Name,"F");
		else strcpy_s(Pc[i].Name,"E");
	}
}

// J̏
void CameraInit(CAMERA *Camera, PC MainPlayer){

	// _px
	Camera->Rot=MainPlayer.Rot;
	Camera->RotTar=Camera->Rot;

	// 񔼌a
	Camera->Radius=300.0f;

	// W
	Camera->Pos.x = MainPlayer.Pos.x-(Camera->Radius*sin(Camera->Rot.v+1.0f/2.0f*M_PI)*cos(1.0f/2.0f*M_PI-Camera->Rot.h))+(100.0f*sin(Camera->Rot.v)*sin(Camera->Rot.h));
	Camera->Pos.z = MainPlayer.Pos.z-(Camera->Radius*sin(Camera->Rot.v+1.0f/2.0f*M_PI)*sin(1.0f/2.0f*M_PI-Camera->Rot.h))+(100.0f*sin(Camera->Rot.v)*cos(Camera->Rot.h));
	Camera->Pos.y = MainPlayer.Pos.y-(Camera->Radius*cos(Camera->Rot.v+1.0f/2.0f*M_PI))+100.0f*cos(Camera->Rot.v);

	// ]x(1/100)
	Camera->Spd.v=0;
	Camera->Spd.h=0;
	Camera->Spd.t=0;

	// Jf
	SetupCamera_Perspective(M_PI/3);
	SetCameraPositionAndAngle(Camera->Pos,Camera->Rot.v,Camera->Rot.h,Camera->Rot.t);
}

// L[̖O擾
void GetKeyName(char (*KeyName)[12], char (*PadName)[12]){

	strcpy_s(KeyName[KEY_INPUT_BACK],"BackSpace");    strcpy_s(KeyName[KEY_INPUT_TAB],"Tab");
	strcpy_s(KeyName[KEY_INPUT_RETURN],"Enter");      strcpy_s(KeyName[KEY_INPUT_LSHIFT],"LShift");
	strcpy_s(KeyName[KEY_INPUT_RSHIFT],"RShift");     strcpy_s(KeyName[KEY_INPUT_LCONTROL],"LControl");
	strcpy_s(KeyName[KEY_INPUT_RCONTROL],"RControl"); strcpy_s(KeyName[KEY_INPUT_ESCAPE],"Escape");
	strcpy_s(KeyName[KEY_INPUT_SPACE],"Space");       strcpy_s(KeyName[KEY_INPUT_PGUP],"PageUp");
	strcpy_s(KeyName[KEY_INPUT_PGDN],"PageDown");     strcpy_s(KeyName[KEY_INPUT_END],"End");
	strcpy_s(KeyName[KEY_INPUT_HOME],"Home");         strcpy_s(KeyName[KEY_INPUT_LEFT],"Left");
	strcpy_s(KeyName[KEY_INPUT_RIGHT],"Right");       strcpy_s(KeyName[KEY_INPUT_DOWN],"Down");
	strcpy_s(KeyName[KEY_INPUT_UP],"Up");             strcpy_s(KeyName[KEY_INPUT_INSERT],"Insert");
	strcpy_s(KeyName[KEY_INPUT_DELETE],"Delete");

	strcpy_s(KeyName[KEY_INPUT_F1],"F1");   strcpy_s(KeyName[KEY_INPUT_F2],"F2");
	strcpy_s(KeyName[KEY_INPUT_F3],"F3");   strcpy_s(KeyName[KEY_INPUT_F4],"F4");
	strcpy_s(KeyName[KEY_INPUT_F5],"F5");   strcpy_s(KeyName[KEY_INPUT_F6],"F6");
	strcpy_s(KeyName[KEY_INPUT_F7],"F7");   strcpy_s(KeyName[KEY_INPUT_F8],"F8");
	strcpy_s(KeyName[KEY_INPUT_F9],"F9");   strcpy_s(KeyName[KEY_INPUT_F10],"F10");
	strcpy_s(KeyName[KEY_INPUT_F11],"F11"); strcpy_s(KeyName[KEY_INPUT_F12],"F12");

	strcpy_s(KeyName[KEY_INPUT_A],"A"); strcpy_s(KeyName[KEY_INPUT_B],"B");
	strcpy_s(KeyName[KEY_INPUT_C],"C"); strcpy_s(KeyName[KEY_INPUT_D],"D");
	strcpy_s(KeyName[KEY_INPUT_E],"E"); strcpy_s(KeyName[KEY_INPUT_F],"F");
	strcpy_s(KeyName[KEY_INPUT_G],"G"); strcpy_s(KeyName[KEY_INPUT_H],"H");
	strcpy_s(KeyName[KEY_INPUT_I],"I"); strcpy_s(KeyName[KEY_INPUT_J],"J");
	strcpy_s(KeyName[KEY_INPUT_K],"K"); strcpy_s(KeyName[KEY_INPUT_L],"L");
	strcpy_s(KeyName[KEY_INPUT_M],"M"); strcpy_s(KeyName[KEY_INPUT_N],"N");
	strcpy_s(KeyName[KEY_INPUT_O],"O"); strcpy_s(KeyName[KEY_INPUT_P],"P");
	strcpy_s(KeyName[KEY_INPUT_Q],"Q"); strcpy_s(KeyName[KEY_INPUT_R],"R");
	strcpy_s(KeyName[KEY_INPUT_S],"S"); strcpy_s(KeyName[KEY_INPUT_T],"T");
	strcpy_s(KeyName[KEY_INPUT_U],"U"); strcpy_s(KeyName[KEY_INPUT_V],"V");
	strcpy_s(KeyName[KEY_INPUT_W],"W"); strcpy_s(KeyName[KEY_INPUT_X],"X");
	strcpy_s(KeyName[KEY_INPUT_Y],"Y"); strcpy_s(KeyName[KEY_INPUT_Z],"Z");

	strcpy_s(KeyName[KEY_INPUT_0],"0"); strcpy_s(KeyName[KEY_INPUT_1],"1");
	strcpy_s(KeyName[KEY_INPUT_2],"2"); strcpy_s(KeyName[KEY_INPUT_3],"3");
	strcpy_s(KeyName[KEY_INPUT_4],"4"); strcpy_s(KeyName[KEY_INPUT_5],"5");
	strcpy_s(KeyName[KEY_INPUT_6],"6"); strcpy_s(KeyName[KEY_INPUT_7],"7");
	strcpy_s(KeyName[KEY_INPUT_8],"8"); strcpy_s(KeyName[KEY_INPUT_9],"9");

	strcpy_s(PadName[0],"Button0");   strcpy_s(PadName[1],"Button1");
	strcpy_s(PadName[2],"Button2");   strcpy_s(PadName[3],"Button3");
	strcpy_s(PadName[4],"Button4");   strcpy_s(PadName[5],"Button5");
	strcpy_s(PadName[6],"Button6");   strcpy_s(PadName[7],"Button7");
	strcpy_s(PadName[8],"Button8");   strcpy_s(PadName[9],"Button9");
	strcpy_s(PadName[10],"Button10"); strcpy_s(PadName[11],"Button11");
	strcpy_s(PadName[12],"Button12"); strcpy_s(PadName[13],"Button13");
	strcpy_s(PadName[14],"Button14"); strcpy_s(PadName[15],"Button15");
	strcpy_s(PadName[16],"Stick_X");  strcpy_s(PadName[17],"Stick_-X");
	strcpy_s(PadName[18],"Stick_Y");  strcpy_s(PadName[19],"Stick_-Y");
	strcpy_s(PadName[20],"Stick_Z");  strcpy_s(PadName[21],"Stick_-Z");
	strcpy_s(PadName[22],"Stick_RX"); strcpy_s(PadName[23],"Stick_-RX");
	strcpy_s(PadName[24],"Stick_RY"); strcpy_s(PadName[25],"Stick_-RY");
	strcpy_s(PadName[26],"Stick_RZ"); strcpy_s(PadName[27],"Stick_-RZ");
	strcpy_s(PadName[28],"POV_UP");   strcpy_s(PadName[29],"POV_RIGHT");
	strcpy_s(PadName[30],"POV_DOWN"); strcpy_s(PadName[31],"POV_LEFT");
}

// L[̓͏Ԃ̍XV
int GetHitPadStateAll2(int *Key){
	char TmpKey[ALLKEY];

    GetHitKeyStateAll(TmpKey);
    for(int i=0;i<ALLKEY;i++) if(TmpKey[i]!=0) Key[i]++; else Key[i]=0;
    return 0;
}

//pbh̓͏Ԃ擾
void GetHitPadStateAll(int *Pad, DINPUT_JOYSTATE *PadState){
    int PadInput=GetJoypadInputState(DX_INPUT_PAD1);
	int Mul=16;

    for(int i=0;i<12;i++){
        if(PadInput&Mul) Pad[i]++; else Pad[i]=0; // eX̃{^̓͂
        Mul*=2;
    }

	// AiOXeBbN̓͂擾
	GetJoypadDirectInputState(DX_INPUT_PAD1,&PadState);

	// AiOXeBbÑZbg
	if(PadState->X>0)  Pad[16]++; else Pad[16]=0;
	if(PadState->X<0)  Pad[17]++; else Pad[17]=0;
	if(PadState->Y>0)  Pad[18]++; else Pad[18]=0;
	if(PadState->Y<0)  Pad[19]++; else Pad[19]=0;
	if(PadState->Z>0)  Pad[20]++; else Pad[20]=0;
	if(PadState->Z<0)  Pad[21]++; else Pad[21]=0;
	if(PadState->Rx>0) Pad[22]++; else Pad[22]=0;
	if(PadState->Rx<0) Pad[23]++; else Pad[23]=0;
	if(PadState->Ry>0) Pad[24]++; else Pad[24]=0;
	if(PadState->Ry<0) Pad[25]++; else Pad[25]=0;
	if(PadState->Rz>0) Pad[26]++; else Pad[26]=0;
	if(PadState->Rz<0) Pad[27]++; else Pad[27]=0;
	// POṼZbg
	if(PadState->POV[0]==0||PadState->POV[0]==4500||PadState->POV[0]==31500) Pad[28]++; else Pad[28]=0;
	if(PadState->POV[0]==9000||PadState->POV[0]==4500||PadState->POV[0]==13500) Pad[29]++; else Pad[29]=0;
	if(PadState->POV[0]==18000||PadState->POV[0]==13500||PadState->POV[0]==22500) Pad[30]++; else Pad[30]=0;
	if(PadState->POV[0]==27000||PadState->POV[0]==22500||PadState->POV[0]==31500) Pad[31]++; else Pad[31]=0;
}

// L[͂pbh͂󂯂܂őҋ@
void WaitKeyOrPad(int Key[],int Pad[], DINPUT_JOYSTATE *PadState){

	while(1){
		GetHitPadStateAll2(Key);         // L[͍XV
		GetHitPadStateAll(Pad,PadState); // pbh͍XV
		ProcessMessage(); // ͒l
		for(int i=0;i<ALLKEY;i++) if(Key[i]==1) return; // L[͂ꂽ疳[vEo
		for(int i=0;i<ALLPAD;i++) if(Pad[i]==1) return; // pbh͂ꂽ疳[vEo
	}
}

// L[pbh͂Ă璷͂ĂlԂB
int KeyOrPad(int Key[], int Pad[], KEYCON KeyCon, KEYCON PadCon, int InputKey){

	switch(InputKey){
		case CF_LEFT:
			return (Key[KeyCon.Left]>Pad[PadCon.Left])? Key[KeyCon.Left] : Pad[PadCon.Left];
		case CF_RIGHT:
			return (Key[KeyCon.Right]>Pad[PadCon.Right])? Key[KeyCon.Right] : Pad[PadCon.Right];
		case CF_UP:
			return (Key[KeyCon.Up]>Pad[PadCon.Up])? Key[KeyCon.Up] : Pad[PadCon.Up];
		case CF_DOWN:
			return (Key[KeyCon.Down]>Pad[PadCon.Down])? Key[KeyCon.Down] : Pad[PadCon.Down];
		case CF_LEFT2:
			return (Key[KeyCon.Left2]>Pad[PadCon.Left2])? Key[KeyCon.Left2] : Pad[PadCon.Left2];
		case CF_RIGHT2:
			return (Key[KeyCon.Right2]>Pad[PadCon.Right2])? Key[KeyCon.Right2] : Pad[PadCon.Right2];
		case CF_UP2:
			return (Key[KeyCon.Up2]>Pad[PadCon.Up2])? Key[KeyCon.Up2] : Pad[PadCon.Up2];
		case CF_DOWN2:
			return (Key[KeyCon.Down2]>Pad[PadCon.Down2])? Key[KeyCon.Down2] : Pad[PadCon.Down2];
		case CF_ENTER:
			return (Key[KeyCon.Enter]>Pad[PadCon.Enter])? Key[KeyCon.Enter] : Pad[PadCon.Enter];
		case CF_CANCEL:
			return (Key[KeyCon.Cancel]>Pad[PadCon.Cancel])? Key[KeyCon.Cancel] : Pad[PadCon.Cancel];
		case CF_SHOT:
			return (Key[KeyCon.Shot]>Pad[PadCon.Shot])? Key[KeyCon.Shot] : Pad[PadCon.Shot];
		case CF_BOMB:
			return (Key[KeyCon.Bomb]>Pad[PadCon.Bomb])? Key[KeyCon.Bomb] : Pad[PadCon.Bomb];
		case CF_SHOTMODESELECT:
			return (Key[KeyCon.ShotModeSelect]>Pad[PadCon.ShotModeSelect])? Key[KeyCon.ShotModeSelect] : Pad[PadCon.ShotModeSelect];
		case CF_TARGETCHANGE:
			return (Key[KeyCon.TargetChange]>Pad[PadCon.TargetChange])? Key[KeyCon.TargetChange] : Pad[PadCon.TargetChange];
		case CF_SKILL1:
			return (Key[KeyCon.Skill1]>Pad[PadCon.Skill1])? Key[KeyCon.Skill1] : Pad[PadCon.Skill1];
		case CF_SKILL2:
			return (Key[KeyCon.Skill2]>Pad[PadCon.Skill2])? Key[KeyCon.Skill2] : Pad[PadCon.Skill2];
		case CF_SKILL3:
			return (Key[KeyCon.Skill3]>Pad[PadCon.Skill3])? Key[KeyCon.Skill3] : Pad[PadCon.Skill3];
		case CF_SKILL4:
			return (Key[KeyCon.Skill4]>Pad[PadCon.Skill4])? Key[KeyCon.Skill4] : Pad[PadCon.Skill4];
	}
	return 0;
}

// ^[̍ŏɂd
void FirstTask(PC *Pc, int Key[], int Pad[], KEYCON KeyCon, KEYCON PadCon){

	// SẴL
	for(int i=0;i<PCNUM;i++){

		// ^[Qbg
		CalcTarget(i);
		if(Pc[i].Flag.TargetMode==AIM_FREE) Pc[i].Flag.Target=Pc[i].NearEne[0];
		else if(KeyOrPad(Key,Pad,KeyCon,PadCon,CF_TARGETCHANGE)==1){
			if(Pc[i].Flag.Target==Pc[i].NearEne[0]) Pc[i].Flag.Target=Pc[i].NearEne[1];
			else Pc[i].Flag.Target=Pc[i].NearEne[0];
		}

		// G̕c
		if(Pc[i].Control==CC_MAINPLAYER){
			Pc[i].RotEne.h=atan2(Pc[Pc[i].Flag.Target].Pos.x-Pc[i].Pos.x,Pc[Pc[i].Flag.Target].Pos.z-Pc[i].Pos.z);
			Pc[i].RotEne.v=-atan2(Pc[Pc[i].Flag.Target].Pos.y-Pc[i].Pos.y,hypotf(Pc[Pc[i].Flag.Target].Pos.z-Pc[i].Pos.z,Pc[Pc[i].Flag.Target].Pos.x-Pc[i].Pos.x));
		}else{
			Pc[i].RotEne.h=atan2(Pc[Pc[i].Flag.Target].Pos.x+(Pc[Pc[i].Flag.Target].Pos.x-Pc[Pc[i].Flag.Target].PPos.x)*Pc[i].DisEne/40-Pc[i].Pos.x,Pc[Pc[i].Flag.Target].Pos.z+(Pc[Pc[i].Flag.Target].Pos.z-Pc[Pc[i].Flag.Target].PPos.z)*Pc[i].DisEne/40-Pc[i].Pos.z);
			Pc[i].RotEne.v=-atan2(Pc[Pc[i].Flag.Target].Pos.y+(Pc[Pc[i].Flag.Target].Pos.y-Pc[Pc[i].Flag.Target].PPos.y)*Pc[i].DisEne/40-Pc[i].Pos.y,hypotf(Pc[Pc[i].Flag.Target].Pos.z+(Pc[Pc[i].Flag.Target].Pos.z-Pc[Pc[i].Flag.Target].PPos.z)*Pc[i].DisEne/40-Pc[i].Pos.z,Pc[Pc[i].Flag.Target].Pos.x+(Pc[Pc[i].Flag.Target].Pos.x-Pc[Pc[i].Flag.Target].PPos.x)*Pc[i].DisEne/40-Pc[i].Pos.x));
		}

		// G̋c
		Pc[i].DisEne=CalcDis(i,Pc[i].Flag.Target);
	}
}

// ^[̏Iɂd
void LastTask(GAME *Game, PC *Pc, TEAM *Team, KILLLOG *KillLog, DRAW *Draw, NUM *Num){
	int BeforeAttach,AfterAttach;

	MV1RefreshCollInfo(Pc[Game->Frame%PCNUM].Handle.Model,-1);
	for(int i=0;i<PCNUM;i++){

		// Aj[VA^b`̍XV
		// Ot[̃A^b`e̕ۑ
		BeforeAttach=MV1GetAttachAnim(Pc[i].Handle.Model,Pc[i].Handle.Attach);

		// 
		if(BeforeAttach!=AN_DEAD&&Pc[i].State==PS_DEAD){
			if(Game->Frame-Pc[i].Flag.LastAttachFrame<=10) MV1DetachAnim(Pc[i].Handle.Model,Pc[i].Handle.BeforeAttach);
			Pc[i].Handle.BeforeAttach=Pc[i].Handle.Attach;
			Pc[i].Handle.Attach = MV1AttachAnim(Pc[i].Handle.Model,AN_DEAD);
		}
		if(Pc[i].State==PS_DEAD) goto A;
		
		// _ufBNV[U[
		if(BeforeAttach!=AN_DOUBLEDIRECTIONALLAZER&&Pc[i].Skill[0].State==SS_ACTIVATED){
			if(Game->Frame-Pc[i].Flag.LastAttachFrame<=10) MV1DetachAnim(Pc[i].Handle.Model,Pc[i].Handle.BeforeAttach);
			Pc[i].Handle.BeforeAttach=Pc[i].Handle.Attach;
			Pc[i].Handle.Attach = MV1AttachAnim(Pc[i].Handle.Model,AN_DOUBLEDIRECTIONALLAZER);
		}
		if(Pc[i].Skill[0].State==SS_ACTIVATED) goto A;

		// }X^[Xp[N
		if(BeforeAttach!=AN_MASTERSPARK&&Pc[i].SetBomb.Selected==BM_MASTERSPARK&&Pc[i].SetBomb.State==SS_ACTIVATED){
			if(Game->Frame-Pc[i].Flag.LastAttachFrame<=10) MV1DetachAnim(Pc[i].Handle.Model,Pc[i].Handle.BeforeAttach);
			Pc[i].Handle.BeforeAttach=Pc[i].Handle.Attach;
			Pc[i].Handle.Attach = MV1AttachAnim(Pc[i].Handle.Model,AN_MASTERSPARK);
		}
		if(Pc[i].SetBomb.Selected==BM_MASTERSPARK&&Pc[i].SetBomb.State==SS_ACTIVATED) goto A;

		// ړ
		if(BeforeAttach!=AN_MOVE&&Game->Frame-Pc[i].Flag.LastMoveFrame==0){
			if(Game->Frame-Pc[i].Flag.LastAttachFrame<=10) MV1DetachAnim(Pc[i].Handle.Model,Pc[i].Handle.BeforeAttach);
			Pc[i].Handle.BeforeAttach=Pc[i].Handle.Attach;
			Pc[i].Handle.Attach = MV1AttachAnim(Pc[i].Handle.Model,AN_MOVE);
		}
		if(Game->Frame-Pc[i].Flag.LastMoveFrame==0) goto A;

		// ~
		if(BeforeAttach!=AN_STAND&&Game->Frame-Pc[i].Flag.LastMoveFrame>0){
			if(Game->Frame-Pc[i].Flag.LastAttachFrame<=10) MV1DetachAnim(Pc[i].Handle.Model,Pc[i].Handle.BeforeAttach);
			Pc[i].Handle.BeforeAttach=Pc[i].Handle.Attach;
			Pc[i].Handle.Attach = MV1AttachAnim(Pc[i].Handle.Model,AN_STAND);
		}

		// t[̃A^b`e̕ۑ
		A:
		AfterAttach=MV1GetAttachAnim(Pc[i].Handle.Model,Pc[i].Handle.Attach);

		// A^b`̍XV
		if(BeforeAttach!=AfterAttach){
			Pc[i].Handle.Anitime=0;
			Pc[i].Flag.LastAttachFrame=Game->Frame;
		}
		if(Game->Frame-Pc[i].Flag.LastAttachFrame<=10){
			MV1SetAttachAnimBlendRate(Pc[i].Handle.Model,Pc[i].Handle.BeforeAttach,1.0f-(Game->Frame-Pc[i].Flag.LastAttachFrame)/10.0f);
			MV1SetAttachAnimBlendRate(Pc[i].Handle.Model,Pc[i].Handle.Attach,(Game->Frame-Pc[i].Flag.LastAttachFrame)/10.0f);
		}
		if(Game->Frame-Pc[i].Flag.LastAttachFrame==10){
			MV1DetachAnim(Pc[i].Handle.Model,Pc[i].Handle.BeforeAttach);
		}

		// HP/ˌ/{񐔂Kl
		if(Pc[i].Life<0.0) Pc[i].Life=0.0f;
		if(Pc[i].Power<0.0) Pc[i].Power=0.0f;
		if(Pc[i].Power>3.0) Pc[i].Power=3.0f;
		if(Pc[i].Bomb>5.0) Pc[i].Bomb=5.0f;

		// ˌ͉
		if(Pc[i].Power<1&&!(Pc[i].State==PS_DEADLY||Pc[i].State==PS_DEAD)) Pc[i].Power+=0.001f;
		
		// HPQ[Wop
		if(Game->Frame-Pc[i].Flag.LastDamageFrame>10&&Pc[i].Damage>1) Pc[i].Damage-=2;
		if(Game->Frame-Pc[i].Flag.LastDamageFrame>10&&Pc[i].Damage<=1) Pc[i].Damage=0;
		if(Game->Frame-Pc[i].Flag.LastRecoveryFrame>10&&Pc[i].Recovery>1) Pc[i].Recovery-=2;
		if(Game->Frame-Pc[i].Flag.LastRecoveryFrame>10&&Pc[i].Recovery<=1) Pc[i].Recovery=0;

		// HP
		if(Pc[i].Control!=CC_COMPUTER&&Game->Frame-Pc[i].Flag.LastDamageFrame>100&&Pc[i].Life<Pc[i].MaxLife&&!(Pc[i].State==PS_DEADLY||Pc[i].State==PS_DEAD)&&
		   Game->Frame-Pc[i].Flag.LastMoveFrame>100&&(Game->Frame-Pc[i].Flag.LastDamageFrame)%10==0){
			   Pc[i].Life++;
			   Pc[i].Recovery++;
			   Pc[i].Flag.LastRecoveryFrame=Game->Frame;
		}
		if(Pc[i].Control==CC_COMPUTER&&Game->Frame-Pc[i].Flag.LastDamageFrame>100&&Pc[i].Life<Pc[i].MaxLife&&!(Pc[i].State==PS_DEADLY||Pc[i].State==PS_DEAD)&&
		   (Game->Frame-Pc[i].Flag.LastDamageFrame)%20==0){
			   Pc[i].Life++;
			   Pc[i].Recovery++;
			   Pc[i].Flag.LastRecoveryFrame=Game->Frame;
		}

		// XRAXV
		if(Pc[i].Score<Pc[i].ScoreTar) Pc[i].Score++;
		if(Pc[i].Score>Pc[i].ScoreTar) Pc[i].Score--;

		// {
		if(Pc[i].SetBomb.EndFrame==Game->Frame) BombUnregist(i);

		// S肩莞Ԍo߂̂ŎS
		if(Pc[i].State==PS_DEADLY&&Game->Frame-Pc[i].Flag.LastDeadlyFrame>5){
			Pc[i].State=PS_DEAD;
			Pc[i].Flag.LastDeadFrame=Game->Frame;
			Killed(Pc[i].Killed,i,Pc[i].Killedby);
		}

		// ł莞Ԍo߂̂ŃX|[
		if(Pc[i].State==PS_DEAD&&Game->Frame-Pc[i].Flag.LastDeadFrame>180) Respawn(i);

		// Q[I
		for(int j=0;j<PCNUM;j++){
			if(Team[j].Point>=75&&Game->SelectedRule==SR_TEAMDEATHMATCH){
				Team[j].Win=1;
				Game->FunctionStatus=FS_RESULT;
				Game->Frame=-1;
				break;
			}
		}
	}

	// LO̍XV
	if(KillLog[0].Frame+300==Game->Frame){
		for(int k=0;k<Num->KillLog-1;k++) KillLog[k]=KillLog[k+1];
		Num->KillLog--;
	}
	UpdateKillLog();

	// `ʂȂĂ悭Ȃ̂폜
	int j;
	for(int i=0;i<Num->Draw;i++){
		if(Draw[i].EndFrame==Game->Frame){
			for(j=i;j<Num->Draw-1;j++){
				Draw[j]=Draw[j+1];
			}
			i--;
			Num->Draw--;
		}
	}
}