#ifndef _MAIN_H_
#define _MAIN_H_

// Q[ݒp
#define WINDOWWIDTH 960
#define WINDOWHEIGHT 540
#define COLORBIT 32
#define REFRESHRATE 60
#define PCNUM 2
#define CHARACTERMODELNUM 2
#define MAPNUM 1
#define LIFEMAX 100 // L̗̑
#define SHOTMAX 1500
#define DRAWMAX 100
#define KILLLOGMAX 6
#define M_PI 3.14159265358979 // ~
#define STAGESIZE 4000
#define P_MAXSPEED 10 // ړōx
#define C_MAXSPEED 10 // Jړōx
#define ALLKEY 256 // ͂󂯕tL[̎ސ
#define ALLPAD 32 // ͂󂯕tL[̎ސ
#define BOMBNUM 1 // {̐
#define SKILLNUM 0 //XL̐

#define NOTSELECTED -1

// Game.FunctionStatusp
enum {FS_MENU,FS_PLAY,FS_RESULT};

// Game.SelectedMenup
enum {SM_NOTSELECTED,SM_KEYCONFIG,SM_RULE,SM_MAP,SM_CHARACTER,SM_START};

// Game.SelectCharacterp
enum {SCR_DEFAULT,SCR_MARISA};

// Game.SelectRulep
enum {SR_TEAMDEATHMATCH};

// Configp
enum {CF_LEFT,CF_RIGHT,CF_UP,CF_DOWN,CF_LEFT2,CF_RIGHT2,CF_UP2,CF_DOWN2,CF_ENTER,CF_CANCEL,CF_SHOT,CF_BOMB,CF_SHOTMODESELECT,CF_TARGETCHANGE,CF_SKILL1,CF_SKILL2,CF_SKILL3,CF_SKILL4};

// KillLogp
enum {KL_DEFAULT,KL_MASTERSPARK,KL_DOUBLEDIRECTIONALLAZER};

// e̎
enum {BV_NORMAL,BV_DOUBLEDIRECTIONALLAZER};

// {p
enum {BM_MASTERSPARK};

// XLp
enum {SK_DOUBLEDIRECTIONALLAZER};

// XL̏
enum {SS_UNAVAILABLE,SS_AVAILABLE,SS_ACTIVATED};

// vC[̏
enum {PS_FINE,PS_DEADLY,PS_DEAD,PS_SATTACK};

// Ə[h
enum {AIM_FREE,AIM_TARGET};

// Aj[Vp
enum {AN_STAND,AN_MOVE,AN_MASTERSPARK,AN_DEAD,AN_DOUBLEDIRECTIONALLAZER};

// vC[
enum {CC_MAINPLAYER,CC_COMPUTER,CC_PLAYER};

// Drawp
enum {DR_MASTERSPARK,DR_DOUBLEDIRECTIONALLAZER};

// ]Float
struct ROT {
	float v; // 
	float h; // 
	float t; // P
};

// fnh
struct HANDLES {
	int Graph;
	int Model;
	int Attach;
	int Anitime;
	int BeforeAttach;
	int AfterAttach;
	int BeforeAnim;
	int AfterAnim;
};

// tHgpnh
struct FONT {
	int Title;
	int KeyConfig;
	int KeyConfigEdge;
	int Rule;
	int Status;
	int StatusSmall;
	int StatusEdge;
	int EnemyStatus;
};

// nhQ
struct GRAPHHANDLE {
	HANDLES Screen; // 
	HANDLES ScoreBoard; // XRA{[h
	HANDLES RedBullet; // Ԃe
	HANDLES BuleBullet; // e
	HANDLES StarBullet[5]; // ^e
	HANDLES Character[CHARACTERMODELNUM]; // LN^
	HANDLES Bomb[BOMBNUM]; // {
};

// LO
struct KILLLOG {
	int Kill; // |
	int Killed; // |ꂽ
	int Frame; // |
	int by; //  Z
	float x,y,Nx,Ny; // W
};

// LptOW
struct FLAG {
	int TargetMode; // ˌ[h
	int Target; // _ĂGID
	int SelectedBomb; // {I
	int LastDeadlyFrame; // SԂɂȂ
	int LastDeadFrame; // SԂɂȂ
	int TargetModeFrame; // ̎ˌ[hɂ
	int LastDamageFrame; // ŌɃ_[W󂯂
	int LastRecoveryFrame; // Ōɉ񕜂󂯂
	int LastShotFrame; // ŌɎˌ
	int LastMoveFrame; // ŌɈړ
	int LastAttachFrame; // ŌɃAj[Vς
};

// ȅi[
struct BULLET {
	HANDLES Handle; // fnh
	int Variety; // 
	int Flag; // e݃tO
	VECTOR Pos; // ݈ʒu
	ROT Rot;   // px
	float Spd; // x
	int Power; // З
	float Size; // a
};

// `ʕ̏i[
struct DRAW {
	int Variety; // 
	HANDLES Handle; // fnh
	int LightHandle; // Cgnh
	VECTOR Pos[2];// W
	ROT Rot;// px
	int PlayerID; // LID
	int Size;    // 傫
	int FirstFrame; // Jnt[
	int EndFrame; // It[
};

// vC̎XL
struct PCSKILL {
	int Selected;
	int State;
	VECTOR Pos[2];
	int StartFrame;
	int EndFrame;
	int CoolTime;
};

// L
struct PC {
	HANDLES Handle; // fnh
	int ModelID; // fԍ
	int Control; // 
	char Name[30]; // O
	FLAG Flag; // tOW
	VECTOR PPos; // Öʒu̍W
	VECTOR Pos; // ݈ʒu̍W
	VECTOR NPos; // ړ̍W
	ROT Rot;    // px
	ROT RotTar; // ڕWpx
	ROT SARot; // Upx
	ROT Spd; // ]x
	ROT RotEne; // G̊px
	int NearEne[2]; // ԋ߂GID
	float DisEne; // G܂ł̋
	int MaxLife; // ő̗
	int Life; // ̗
	int Damage; // _[W
	int Recovery; // 
	int Kill; // EQ
	int Score,ScoreTar; // XRA
	int Team; // `[
	int Death; // S
	int Graze; // 萔
	int State; // 
	float Power; // ˌ
	float Bomb; // {
	BULLET Bullet[SHOTMAX]; // e
	PCSKILL Skill[4]; // ZbgꂽXL
	PCSKILL SetBomb; // Zbgꂽ{
	int Killed; // Eꂽ
	int Killedby; // v
	//CPUp
	int MMInterval; // ősԊu
	VECTOR Move; // ړ
	int LastMoveDecideFrame;
};

struct TEAM {
	int Point; // _
	int Win; // s
};

// J
struct CAMERA {
	VECTOR Pos,NPos; // ݍW
	ROT Rot,RotTar; // px
	ROT Spd; //]x
	float Radius; //񔼌a 
};

// }bv
struct MAP {
	int SkyHandle; // 󃂃fnh
	int MapHandle; // }bvfnh
	int GroundHandle; // ڒn}bvfnh
};

// Q[
struct GAME {
	int FunctionStatus;
	int Frame;
	int SelectRule;
	int SelectedRule;
	int SelectMenu;
	int SelectedMenu;
	int SelectKeyConfig;
	int SelectedKeyConfig;
	int SelectCharacter;
	int SelectedCharacter;
	int SelectMap;
	int SelectedMap;
	char KeyName[ALLKEY][12]; // L[̖O
	char PadName[ALLPAD][12]; // {^̖O
    int Key[ALLKEY]; // L[Ăt[̊i[
	int Pad[ALLPAD]; // pbh̃{^Ăt[̊i[
	DINPUT_JOYSTATE PadState; // pbh͏̊i[
	int PlayerID;
};

// JEg
struct NUM {
	int Draw;
	int KillLog;
};

// ݒɗp
struct KEYCON {
	int Left,Right,Up,Down,Left2,Right2,Up2,Down2,Enter,Cancel,Shot,Bomb,
		ShotModeSelect,TargetChange,Skill1,Skill2,Skill3,Skill4;
};

// VF[_Ǘp
struct SHADER {
	int Gray;	
};

void GameInit(GAME *Game, MAP *Map, FONT *Font, GRAPHHANDLE *Handle, SHADER *Shader);
void KeyConfigInit(KEYCON *KeyCon, KEYCON *PadCon);
void PlayInit(GAME *Game, PC *Pc, CAMERA *Camera, TEAM *Team, NUM *Num, GRAPHHANDLE Handle, int PlayerID);
void PcInit(GAME *Game, PC *Pc, GRAPHHANDLE Handle, int PlayerID);
void CameraInit(CAMERA *Camera, PC MainPlayer);

void GetKeyName(char (*KeyName)[12], char (*PadName)[12]);
int GetHitKeyStateAll2(int *Key);
void GetHitPadStateAll(int *Pad, DINPUT_JOYSTATE *PadState);

void WaitKeyOrPad(int Key[],int Pad[], DINPUT_JOYSTATE *PadState);
int KeyOrPad(int Key[], int Pad[], KEYCON KeyCon, KEYCON PadCon, int InputKey);

void FirstTask(PC *Pc, int Key[], int Pad[], KEYCON KeyCon, KEYCON PadCon);
void LastTask(GAME *Game, PC *Pc, TEAM *Team, KILLLOG *KillLog, DRAW *Draw, NUM *Num);

void ControlPhase(PC *Player, CAMERA *Camera, GAME Game, KEYCON KeyCon, KEYCON PadCon);
void MainPlayerControl(PC *Player, CAMERA *Camera, GAME Game, KEYCON KeyCon, KEYCON PadCon, int PlayerIndex);
void CpuControl(PC *Player, GAME Game, int PlayerIndex);

#endif